# coding: utf-8

"""
    App Center Client

    Microsoft Visual Studio App Center API  # noqa: E501

    OpenAPI spec version: preview
    Contact: benedetto.abbenanti@gmail.com
    Project Repository: https://github.com/b3nab/appcenter-sdks
"""

from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from appcenter_sdk.api_client import ApiClient


class billingApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def billingAggregatedInformation_getForOrg(self, orgName, **kwargs):  # noqa: E501
        """billingAggregatedInformation_getForOrg  # noqa: E501

        Aggregated Billing Information for a given Organization.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.billingAggregatedInformation_getForOrg(orgName, async=True)
        >>> result = thread.get()

        :param async bool
        :param string orgName: The name of the Organization (required)
        :param string service: Type of service that should be included in the Billing Information(optional)
        :param string period: Type of period that should be included in the Billing Information(optional)
        :param boolean showOriginalPlans: Controls whether the API should show the original plan when Azure Subscription is not enabled(optional)
        :return: BillingError
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async'):
            return self.billingAggregatedInformation_getForOrg_with_http_info(orgName, **kwargs)  # noqa: E501
        else:
            (data) = self.billingAggregatedInformation_getForOrg_with_http_info(orgName, **kwargs)  # noqa: E501
            return data

    def billingAggregatedInformation_getForOrg_with_http_info(self, orgName, **kwargs):  # noqa: E501
        """billingAggregatedInformation_getForOrg  # noqa: E501

        Aggregated Billing Information for a given Organization.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.billingAggregatedInformation_getForOrg_with_http_info(orgName, async=True)
        >>> result = thread.get()

        :param async bool
        :param string orgName: The name of the Organization (required)
        :param string service: Type of service that should be included in the Billing Information(optional)
        :param string period: Type of period that should be included in the Billing Information(optional)
        :param boolean showOriginalPlans: Controls whether the API should show the original plan when Azure Subscription is not enabled(optional)
        :return: BillingError
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['orgName', 'service', 'period', 'showOriginalPlans']  # noqa: E501
        all_params.append('async')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method billingAggregatedInformation_getForOrg" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'orgName' is set
        if ('orgName' not in params or
                params['orgName'] is None):
            raise ValueError("Missing the required parameter `orgName` when calling `billingAggregatedInformation_getForOrg`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'orgName' in params:
            path_params['orgName'] = params['orgName']  # noqa: E501

        query_params = []
        if 'service' in params:
            query_params.append(('service', params['service']))  # noqa: E501
        if 'period' in params:
            query_params.append(('period', params['period']))  # noqa: E501
        if 'showOriginalPlans' in params:
            query_params.append(('showOriginalPlans', params['showOriginalPlans']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json', 'application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json', 'multipart/form-data', 'application/json-patch+json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['APIToken']  # noqa: E501

        return self.api_client.call_api(
            '/v0.1/orgs/{orgName}/billing/aggregated', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='BillingError',  # noqa: E501
            auth_settings=auth_settings,
            async=params.get('async'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def billingAggregatedInformation_getByApp(self, owner_name, app_name, **kwargs):  # noqa: E501
        """billingAggregatedInformation_getByApp  # noqa: E501

        Aggregated Billing Information for owner of a given app.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.billingAggregatedInformation_getByApp(owner_name, app_name, async=True)
        >>> result = thread.get()

        :param async bool
        :param string owner_name: The name of the owner (required)
        :param string app_name: The name of the application (required)
        :param string service: Type of service that should be included in the Billing Information(optional)
        :param string period: Type of period that should be included in the Billing Information(optional)
        :param boolean showOriginalPlans: Controls whether the API should show the original plan when Azure Subscription is not enabled(optional)
        :return: BillingError
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async'):
            return self.billingAggregatedInformation_getByApp_with_http_info(owner_name, app_name, **kwargs)  # noqa: E501
        else:
            (data) = self.billingAggregatedInformation_getByApp_with_http_info(owner_name, app_name, **kwargs)  # noqa: E501
            return data

    def billingAggregatedInformation_getByApp_with_http_info(self, owner_name, app_name, **kwargs):  # noqa: E501
        """billingAggregatedInformation_getByApp  # noqa: E501

        Aggregated Billing Information for owner of a given app.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.billingAggregatedInformation_getByApp_with_http_info(owner_name, app_name, async=True)
        >>> result = thread.get()

        :param async bool
        :param string owner_name: The name of the owner (required)
        :param string app_name: The name of the application (required)
        :param string service: Type of service that should be included in the Billing Information(optional)
        :param string period: Type of period that should be included in the Billing Information(optional)
        :param boolean showOriginalPlans: Controls whether the API should show the original plan when Azure Subscription is not enabled(optional)
        :return: BillingError
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['owner_name', 'app_name', 'service', 'period', 'showOriginalPlans']  # noqa: E501
        all_params.append('async')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method billingAggregatedInformation_getByApp" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'owner_name' is set
        if ('owner_name' not in params or
                params['owner_name'] is None):
            raise ValueError("Missing the required parameter `owner_name` when calling `billingAggregatedInformation_getByApp`")  # noqa: E501
        # verify the required parameter 'app_name' is set
        if ('app_name' not in params or
                params['app_name'] is None):
            raise ValueError("Missing the required parameter `app_name` when calling `billingAggregatedInformation_getByApp`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'owner_name' in params:
            path_params['owner_name'] = params['owner_name']  # noqa: E501
        if 'app_name' in params:
            path_params['app_name'] = params['app_name']  # noqa: E501

        query_params = []
        if 'service' in params:
            query_params.append(('service', params['service']))  # noqa: E501
        if 'period' in params:
            query_params.append(('period', params['period']))  # noqa: E501
        if 'showOriginalPlans' in params:
            query_params.append(('showOriginalPlans', params['showOriginalPlans']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json', 'application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json', 'multipart/form-data', 'application/json-patch+json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['APIToken']  # noqa: E501

        return self.api_client.call_api(
            '/v0.1/apps/{owner_name}/{app_name}/billing/aggregated', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='BillingError',  # noqa: E501
            auth_settings=auth_settings,
            async=params.get('async'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
