# coding: utf-8

"""
    App Center Client

    Microsoft Visual Studio App Center API  # noqa: E501

    OpenAPI spec version: preview
    Contact: benedetto.abbenanti@gmail.com
    Project Repository: https://github.com/b3nab/appcenter-sdks
"""

from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from appcenter_sdk.api_client import ApiClient


class exportApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def ExportConfigurations_Enable(self, export_configuration_id, owner_name, app_name, **kwargs):  # noqa: E501
        """ExportConfigurations_Enable  # noqa: E501

        Enable export configuration.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.ExportConfigurations_Enable(export_configuration_id, owner_name, app_name, async=True)
        >>> result = thread.get()

        :param async bool
        :param string export_configuration_id: The id of the export configuration. (required)
        :param string owner_name: The name of the owner (required)
        :param string app_name: The name of the application (required)
        :return: ErrorResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async'):
            return self.ExportConfigurations_Enable_with_http_info(export_configuration_id, owner_name, app_name, **kwargs)  # noqa: E501
        else:
            (data) = self.ExportConfigurations_Enable_with_http_info(export_configuration_id, owner_name, app_name, **kwargs)  # noqa: E501
            return data

    def ExportConfigurations_Enable_with_http_info(self, export_configuration_id, owner_name, app_name, **kwargs):  # noqa: E501
        """ExportConfigurations_Enable  # noqa: E501

        Enable export configuration.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.ExportConfigurations_Enable_with_http_info(export_configuration_id, owner_name, app_name, async=True)
        >>> result = thread.get()

        :param async bool
        :param string export_configuration_id: The id of the export configuration. (required)
        :param string owner_name: The name of the owner (required)
        :param string app_name: The name of the application (required)
        :return: ErrorResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['export_configuration_id', 'owner_name', 'app_name']  # noqa: E501
        all_params.append('async')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method ExportConfigurations_Enable" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'export_configuration_id' is set
        if ('export_configuration_id' not in params or
                params['export_configuration_id'] is None):
            raise ValueError("Missing the required parameter `export_configuration_id` when calling `ExportConfigurations_Enable`")  # noqa: E501
        # verify the required parameter 'owner_name' is set
        if ('owner_name' not in params or
                params['owner_name'] is None):
            raise ValueError("Missing the required parameter `owner_name` when calling `ExportConfigurations_Enable`")  # noqa: E501
        # verify the required parameter 'app_name' is set
        if ('app_name' not in params or
                params['app_name'] is None):
            raise ValueError("Missing the required parameter `app_name` when calling `ExportConfigurations_Enable`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'export_configuration_id' in params:
            path_params['export_configuration_id'] = params['export_configuration_id']  # noqa: E501
        if 'owner_name' in params:
            path_params['owner_name'] = params['owner_name']  # noqa: E501
        if 'app_name' in params:
            path_params['app_name'] = params['app_name']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json', 'multipart/form-data', 'application/json-patch+json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['APIToken']  # noqa: E501

        return self.api_client.call_api(
            '/v0.1/apps/{owner_name}/{app_name}/export_configurations/{export_configuration_id}/enable', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ErrorResponse',  # noqa: E501
            auth_settings=auth_settings,
            async=params.get('async'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def ExportConfigurations_Disable(self, export_configuration_id, owner_name, app_name, **kwargs):  # noqa: E501
        """ExportConfigurations_Disable  # noqa: E501

        Disable export configuration.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.ExportConfigurations_Disable(export_configuration_id, owner_name, app_name, async=True)
        >>> result = thread.get()

        :param async bool
        :param string export_configuration_id: The id of the export configuration. (required)
        :param string owner_name: The name of the owner (required)
        :param string app_name: The name of the application (required)
        :return: ErrorResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async'):
            return self.ExportConfigurations_Disable_with_http_info(export_configuration_id, owner_name, app_name, **kwargs)  # noqa: E501
        else:
            (data) = self.ExportConfigurations_Disable_with_http_info(export_configuration_id, owner_name, app_name, **kwargs)  # noqa: E501
            return data

    def ExportConfigurations_Disable_with_http_info(self, export_configuration_id, owner_name, app_name, **kwargs):  # noqa: E501
        """ExportConfigurations_Disable  # noqa: E501

        Disable export configuration.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.ExportConfigurations_Disable_with_http_info(export_configuration_id, owner_name, app_name, async=True)
        >>> result = thread.get()

        :param async bool
        :param string export_configuration_id: The id of the export configuration. (required)
        :param string owner_name: The name of the owner (required)
        :param string app_name: The name of the application (required)
        :return: ErrorResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['export_configuration_id', 'owner_name', 'app_name']  # noqa: E501
        all_params.append('async')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method ExportConfigurations_Disable" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'export_configuration_id' is set
        if ('export_configuration_id' not in params or
                params['export_configuration_id'] is None):
            raise ValueError("Missing the required parameter `export_configuration_id` when calling `ExportConfigurations_Disable`")  # noqa: E501
        # verify the required parameter 'owner_name' is set
        if ('owner_name' not in params or
                params['owner_name'] is None):
            raise ValueError("Missing the required parameter `owner_name` when calling `ExportConfigurations_Disable`")  # noqa: E501
        # verify the required parameter 'app_name' is set
        if ('app_name' not in params or
                params['app_name'] is None):
            raise ValueError("Missing the required parameter `app_name` when calling `ExportConfigurations_Disable`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'export_configuration_id' in params:
            path_params['export_configuration_id'] = params['export_configuration_id']  # noqa: E501
        if 'owner_name' in params:
            path_params['owner_name'] = params['owner_name']  # noqa: E501
        if 'app_name' in params:
            path_params['app_name'] = params['app_name']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json', 'multipart/form-data', 'application/json-patch+json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['APIToken']  # noqa: E501

        return self.api_client.call_api(
            '/v0.1/apps/{owner_name}/{app_name}/export_configurations/{export_configuration_id}/disable', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ErrorResponse',  # noqa: E501
            auth_settings=auth_settings,
            async=params.get('async'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def ExportConfigurations_Get(self, export_configuration_id, owner_name, app_name, **kwargs):  # noqa: E501
        """ExportConfigurations_Get  # noqa: E501

        Get export configuration.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.ExportConfigurations_Get(export_configuration_id, owner_name, app_name, async=True)
        >>> result = thread.get()

        :param async bool
        :param string export_configuration_id: The id of the export configuration. (required)
        :param string owner_name: The name of the owner (required)
        :param string app_name: The name of the application (required)
        :return: ErrorResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async'):
            return self.ExportConfigurations_Get_with_http_info(export_configuration_id, owner_name, app_name, **kwargs)  # noqa: E501
        else:
            (data) = self.ExportConfigurations_Get_with_http_info(export_configuration_id, owner_name, app_name, **kwargs)  # noqa: E501
            return data

    def ExportConfigurations_Get_with_http_info(self, export_configuration_id, owner_name, app_name, **kwargs):  # noqa: E501
        """ExportConfigurations_Get  # noqa: E501

        Get export configuration.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.ExportConfigurations_Get_with_http_info(export_configuration_id, owner_name, app_name, async=True)
        >>> result = thread.get()

        :param async bool
        :param string export_configuration_id: The id of the export configuration. (required)
        :param string owner_name: The name of the owner (required)
        :param string app_name: The name of the application (required)
        :return: ErrorResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['export_configuration_id', 'owner_name', 'app_name']  # noqa: E501
        all_params.append('async')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method ExportConfigurations_Get" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'export_configuration_id' is set
        if ('export_configuration_id' not in params or
                params['export_configuration_id'] is None):
            raise ValueError("Missing the required parameter `export_configuration_id` when calling `ExportConfigurations_Get`")  # noqa: E501
        # verify the required parameter 'owner_name' is set
        if ('owner_name' not in params or
                params['owner_name'] is None):
            raise ValueError("Missing the required parameter `owner_name` when calling `ExportConfigurations_Get`")  # noqa: E501
        # verify the required parameter 'app_name' is set
        if ('app_name' not in params or
                params['app_name'] is None):
            raise ValueError("Missing the required parameter `app_name` when calling `ExportConfigurations_Get`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'export_configuration_id' in params:
            path_params['export_configuration_id'] = params['export_configuration_id']  # noqa: E501
        if 'owner_name' in params:
            path_params['owner_name'] = params['owner_name']  # noqa: E501
        if 'app_name' in params:
            path_params['app_name'] = params['app_name']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json', 'application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json', 'multipart/form-data', 'application/json-patch+json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['APIToken']  # noqa: E501

        return self.api_client.call_api(
            '/v0.1/apps/{owner_name}/{app_name}/export_configurations/{export_configuration_id}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ErrorResponse',  # noqa: E501
            auth_settings=auth_settings,
            async=params.get('async'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def ExportConfigurations_PartialUpdate(self, export_configuration_id, owner_name, app_name, body, **kwargs):  # noqa: E501
        """ExportConfigurations_PartialUpdate  # noqa: E501

        Partially update export configuration.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.ExportConfigurations_PartialUpdate(export_configuration_id, owner_name, app_name, body, async=True)
        >>> result = thread.get()

        :param async bool
        :param string export_configuration_id: The id of the export configuration. (required)
        :param string owner_name: The name of the owner (required)
        :param string app_name: The name of the application (required)
        :param object body: Export configurations. (required)
        :return: ErrorResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async'):
            return self.ExportConfigurations_PartialUpdate_with_http_info(export_configuration_id, owner_name, app_name, body, **kwargs)  # noqa: E501
        else:
            (data) = self.ExportConfigurations_PartialUpdate_with_http_info(export_configuration_id, owner_name, app_name, body, **kwargs)  # noqa: E501
            return data

    def ExportConfigurations_PartialUpdate_with_http_info(self, export_configuration_id, owner_name, app_name, body, **kwargs):  # noqa: E501
        """ExportConfigurations_PartialUpdate  # noqa: E501

        Partially update export configuration.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.ExportConfigurations_PartialUpdate_with_http_info(export_configuration_id, owner_name, app_name, body, async=True)
        >>> result = thread.get()

        :param async bool
        :param string export_configuration_id: The id of the export configuration. (required)
        :param string owner_name: The name of the owner (required)
        :param string app_name: The name of the application (required)
        :param object body: Export configurations. (required)
        :return: ErrorResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['export_configuration_id', 'owner_name', 'app_name', 'body']  # noqa: E501
        all_params.append('async')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method ExportConfigurations_PartialUpdate" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'export_configuration_id' is set
        if ('export_configuration_id' not in params or
                params['export_configuration_id'] is None):
            raise ValueError("Missing the required parameter `export_configuration_id` when calling `ExportConfigurations_PartialUpdate`")  # noqa: E501
        # verify the required parameter 'owner_name' is set
        if ('owner_name' not in params or
                params['owner_name'] is None):
            raise ValueError("Missing the required parameter `owner_name` when calling `ExportConfigurations_PartialUpdate`")  # noqa: E501
        # verify the required parameter 'app_name' is set
        if ('app_name' not in params or
                params['app_name'] is None):
            raise ValueError("Missing the required parameter `app_name` when calling `ExportConfigurations_PartialUpdate`")  # noqa: E501
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `ExportConfigurations_PartialUpdate`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'export_configuration_id' in params:
            path_params['export_configuration_id'] = params['export_configuration_id']  # noqa: E501
        if 'owner_name' in params:
            path_params['owner_name'] = params['owner_name']  # noqa: E501
        if 'app_name' in params:
            path_params['app_name'] = params['app_name']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json', 'application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['APIToken']  # noqa: E501

        return self.api_client.call_api(
            '/v0.1/apps/{owner_name}/{app_name}/export_configurations/{export_configuration_id}', 'PATCH',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ErrorResponse',  # noqa: E501
            auth_settings=auth_settings,
            async=params.get('async'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def ExportConfigurations_Delete(self, export_configuration_id, owner_name, app_name, **kwargs):  # noqa: E501
        """ExportConfigurations_Delete  # noqa: E501

        Delete export configuration.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.ExportConfigurations_Delete(export_configuration_id, owner_name, app_name, async=True)
        >>> result = thread.get()

        :param async bool
        :param string export_configuration_id: The id of the export configuration. (required)
        :param string owner_name: The name of the owner (required)
        :param string app_name: The name of the application (required)
        :return: ErrorResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async'):
            return self.ExportConfigurations_Delete_with_http_info(export_configuration_id, owner_name, app_name, **kwargs)  # noqa: E501
        else:
            (data) = self.ExportConfigurations_Delete_with_http_info(export_configuration_id, owner_name, app_name, **kwargs)  # noqa: E501
            return data

    def ExportConfigurations_Delete_with_http_info(self, export_configuration_id, owner_name, app_name, **kwargs):  # noqa: E501
        """ExportConfigurations_Delete  # noqa: E501

        Delete export configuration.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.ExportConfigurations_Delete_with_http_info(export_configuration_id, owner_name, app_name, async=True)
        >>> result = thread.get()

        :param async bool
        :param string export_configuration_id: The id of the export configuration. (required)
        :param string owner_name: The name of the owner (required)
        :param string app_name: The name of the application (required)
        :return: ErrorResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['export_configuration_id', 'owner_name', 'app_name']  # noqa: E501
        all_params.append('async')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method ExportConfigurations_Delete" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'export_configuration_id' is set
        if ('export_configuration_id' not in params or
                params['export_configuration_id'] is None):
            raise ValueError("Missing the required parameter `export_configuration_id` when calling `ExportConfigurations_Delete`")  # noqa: E501
        # verify the required parameter 'owner_name' is set
        if ('owner_name' not in params or
                params['owner_name'] is None):
            raise ValueError("Missing the required parameter `owner_name` when calling `ExportConfigurations_Delete`")  # noqa: E501
        # verify the required parameter 'app_name' is set
        if ('app_name' not in params or
                params['app_name'] is None):
            raise ValueError("Missing the required parameter `app_name` when calling `ExportConfigurations_Delete`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'export_configuration_id' in params:
            path_params['export_configuration_id'] = params['export_configuration_id']  # noqa: E501
        if 'owner_name' in params:
            path_params['owner_name'] = params['owner_name']  # noqa: E501
        if 'app_name' in params:
            path_params['app_name'] = params['app_name']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json', 'multipart/form-data', 'application/json-patch+json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['APIToken']  # noqa: E501

        return self.api_client.call_api(
            '/v0.1/apps/{owner_name}/{app_name}/export_configurations/{export_configuration_id}', 'DELETE',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ErrorResponse',  # noqa: E501
            auth_settings=auth_settings,
            async=params.get('async'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def ExportConfigurations_List(self, owner_name, app_name, **kwargs):  # noqa: E501
        """ExportConfigurations_List  # noqa: E501

        List export configurations.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.ExportConfigurations_List(owner_name, app_name, async=True)
        >>> result = thread.get()

        :param async bool
        :param string owner_name: The name of the owner (required)
        :param string app_name: The name of the application (required)
        :return: ErrorResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async'):
            return self.ExportConfigurations_List_with_http_info(owner_name, app_name, **kwargs)  # noqa: E501
        else:
            (data) = self.ExportConfigurations_List_with_http_info(owner_name, app_name, **kwargs)  # noqa: E501
            return data

    def ExportConfigurations_List_with_http_info(self, owner_name, app_name, **kwargs):  # noqa: E501
        """ExportConfigurations_List  # noqa: E501

        List export configurations.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.ExportConfigurations_List_with_http_info(owner_name, app_name, async=True)
        >>> result = thread.get()

        :param async bool
        :param string owner_name: The name of the owner (required)
        :param string app_name: The name of the application (required)
        :return: ErrorResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['owner_name', 'app_name']  # noqa: E501
        all_params.append('async')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method ExportConfigurations_List" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'owner_name' is set
        if ('owner_name' not in params or
                params['owner_name'] is None):
            raise ValueError("Missing the required parameter `owner_name` when calling `ExportConfigurations_List`")  # noqa: E501
        # verify the required parameter 'app_name' is set
        if ('app_name' not in params or
                params['app_name'] is None):
            raise ValueError("Missing the required parameter `app_name` when calling `ExportConfigurations_List`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'owner_name' in params:
            path_params['owner_name'] = params['owner_name']  # noqa: E501
        if 'app_name' in params:
            path_params['app_name'] = params['app_name']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json', 'application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json', 'multipart/form-data', 'application/json-patch+json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['APIToken']  # noqa: E501

        return self.api_client.call_api(
            '/v0.1/apps/{owner_name}/{app_name}/export_configurations', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ErrorResponse',  # noqa: E501
            auth_settings=auth_settings,
            async=params.get('async'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def ExportConfigurations_Create(self, owner_name, app_name, body, **kwargs):  # noqa: E501
        """ExportConfigurations_Create  # noqa: E501

        Create new export configuration  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.ExportConfigurations_Create(owner_name, app_name, body, async=True)
        >>> result = thread.get()

        :param async bool
        :param string owner_name: The name of the owner (required)
        :param string app_name: The name of the application (required)
        :param object body: Export configurations. (required)
        :return: ErrorResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async'):
            return self.ExportConfigurations_Create_with_http_info(owner_name, app_name, body, **kwargs)  # noqa: E501
        else:
            (data) = self.ExportConfigurations_Create_with_http_info(owner_name, app_name, body, **kwargs)  # noqa: E501
            return data

    def ExportConfigurations_Create_with_http_info(self, owner_name, app_name, body, **kwargs):  # noqa: E501
        """ExportConfigurations_Create  # noqa: E501

        Create new export configuration  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.ExportConfigurations_Create_with_http_info(owner_name, app_name, body, async=True)
        >>> result = thread.get()

        :param async bool
        :param string owner_name: The name of the owner (required)
        :param string app_name: The name of the application (required)
        :param object body: Export configurations. (required)
        :return: ErrorResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['owner_name', 'app_name', 'body']  # noqa: E501
        all_params.append('async')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method ExportConfigurations_Create" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'owner_name' is set
        if ('owner_name' not in params or
                params['owner_name'] is None):
            raise ValueError("Missing the required parameter `owner_name` when calling `ExportConfigurations_Create`")  # noqa: E501
        # verify the required parameter 'app_name' is set
        if ('app_name' not in params or
                params['app_name'] is None):
            raise ValueError("Missing the required parameter `app_name` when calling `ExportConfigurations_Create`")  # noqa: E501
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `ExportConfigurations_Create`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'owner_name' in params:
            path_params['owner_name'] = params['owner_name']  # noqa: E501
        if 'app_name' in params:
            path_params['app_name'] = params['app_name']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json', 'application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['APIToken']  # noqa: E501

        return self.api_client.call_api(
            '/v0.1/apps/{owner_name}/{app_name}/export_configurations', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ErrorResponse',  # noqa: E501
            auth_settings=auth_settings,
            async=params.get('async'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
