# coding: utf-8

"""
    App Center Client

    Microsoft Visual Studio App Center API  # noqa: E501

    OpenAPI spec version: preview
    Contact: benedetto.abbenanti@gmail.com
    Project Repository: https://github.com/b3nab/appcenter-sdks
"""

import pprint
import re  # noqa: F401

import six


class ActiveDeviceCounts(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'daily': 'array',
        'weekly': 'array',
        'monthly': 'array'
    }

    attribute_map = {
        'daily': 'daily',
        'weekly': 'weekly',
        'monthly': 'monthly'
    }

    def __init__(self, daily=None, weekly=None, monthly=None):  # noqa: E501
        """ActiveDeviceCounts - a model defined in Swagger"""  # noqa: E501
        self._daily = None
        self._weekly = None
        self._monthly = None
        self.discriminator = None
        if daily is not None:
            self.daily = daily
        if weekly is not None:
            self.weekly = weekly
        if monthly is not None:
            self.monthly = monthly

    @property
    def daily(self):
        """Gets the daily of this ActiveDeviceCounts.  # noqa: E501

        the active device count for each interval  # noqa: E501

        :return: The daily of this ActiveDeviceCounts.  # noqa: E501
        :rtype: array
        """
        return self._daily

    @daily.setter
    def daily(self, daily):
        """Sets the daily of this ActiveDeviceCounts.

        the active device count for each interval  # noqa: E501

        :param daily: The daily of this ActiveDeviceCounts.  # noqa: E501
        :type: array
        """

        self._daily = daily

    @property
    def weekly(self):
        """Gets the weekly of this ActiveDeviceCounts.  # noqa: E501

        the active device count for each interval with a week's retention  # noqa: E501

        :return: The weekly of this ActiveDeviceCounts.  # noqa: E501
        :rtype: array
        """
        return self._weekly

    @weekly.setter
    def weekly(self, weekly):
        """Sets the weekly of this ActiveDeviceCounts.

        the active device count for each interval with a week's retention  # noqa: E501

        :param weekly: The weekly of this ActiveDeviceCounts.  # noqa: E501
        :type: array
        """

        self._weekly = weekly

    @property
    def monthly(self):
        """Gets the monthly of this ActiveDeviceCounts.  # noqa: E501

        the active device count for each interval with a month's retention  # noqa: E501

        :return: The monthly of this ActiveDeviceCounts.  # noqa: E501
        :rtype: array
        """
        return self._monthly

    @monthly.setter
    def monthly(self, monthly):
        """Sets the monthly of this ActiveDeviceCounts.

        the active device count for each interval with a month's retention  # noqa: E501

        :param monthly: The monthly of this ActiveDeviceCounts.  # noqa: E501
        :type: array
        """

        self._monthly = monthly

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ActiveDeviceCounts):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
