# coding: utf-8

"""
    App Center Client

    Microsoft Visual Studio App Center API  # noqa: E501

    OpenAPI spec version: preview
    Contact: benedetto.abbenanti@gmail.com
    Project Repository: https://github.com/b3nab/appcenter-sdks
"""

import pprint
import re  # noqa: F401

import six


class AddAppTesterRequest(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'user_id': 'string',
        'release_id': 'integer'
    }

    attribute_map = {
        'user_id': 'user_id',
        'release_id': 'release_id'
    }

    def __init__(self, user_id=None, release_id=None):  # noqa: E501
        """AddAppTesterRequest - a model defined in Swagger"""  # noqa: E501
        self._user_id = None
        self._release_id = None
        self.discriminator = None
        self.user_id = user_id
        self.release_id = release_id

    @property
    def user_id(self):
        """Gets the user_id of this AddAppTesterRequest.  # noqa: E501

        The user ID of the tester that needs to be added  # noqa: E501

        :return: The user_id of this AddAppTesterRequest.  # noqa: E501
        :rtype: string
        """
        return self._user_id

    @user_id.setter
    def user_id(self, user_id):
        """Sets the user_id of this AddAppTesterRequest.

        The user ID of the tester that needs to be added  # noqa: E501

        :param user_id: The user_id of this AddAppTesterRequest.  # noqa: E501
        :type: string
        """
        if user_id is None:
            raise ValueError("Invalid value for `user_id`, must not be `None`")  # noqa: E501

        self._user_id = user_id

    @property
    def release_id(self):
        """Gets the release_id of this AddAppTesterRequest.  # noqa: E501

        The ID of the release the user was added to  # noqa: E501

        :return: The release_id of this AddAppTesterRequest.  # noqa: E501
        :rtype: integer
        """
        return self._release_id

    @release_id.setter
    def release_id(self, release_id):
        """Sets the release_id of this AddAppTesterRequest.

        The ID of the release the user was added to  # noqa: E501

        :param release_id: The release_id of this AddAppTesterRequest.  # noqa: E501
        :type: integer
        """
        if release_id is None:
            raise ValueError("Invalid value for `release_id`, must not be `None`")  # noqa: E501

        self._release_id = release_id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AddAppTesterRequest):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
