# coding: utf-8

"""
    App Center Client

    Microsoft Visual Studio App Center API  # noqa: E501

    OpenAPI spec version: preview
    Contact: benedetto.abbenanti@gmail.com
    Project Repository: https://github.com/b3nab/appcenter-sdks
"""

import pprint
import re  # noqa: F401

import six


class AlertingAccessTokenResponse(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    allowed enum values
    """
    github = "github"
    vsts = "vsts"
    jira = "jira"
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'access_token_id': 'string',
        'external_provider_name': 'string',
        'external_user_email': 'string',
        'external_account_name': 'string'
    }

    attribute_map = {
        'access_token_id': 'access_token_id',
        'external_provider_name': 'external_provider_name',
        'external_user_email': 'external_user_email',
        'external_account_name': 'external_account_name'
    }

    def __init__(self, access_token_id=None, external_provider_name=None, external_user_email=None, external_account_name=None):  # noqa: E501
        """AlertingAccessTokenResponse - a model defined in Swagger"""  # noqa: E501
        self._access_token_id = None
        self._external_provider_name = None
        self._external_user_email = None
        self._external_account_name = None
        self.discriminator = None
        self.access_token_id = access_token_id
        self.external_provider_name = external_provider_name
        self.external_user_email = external_user_email
        self.external_account_name = external_account_name

    @property
    def access_token_id(self):
        """Gets the access_token_id of this AlertingAccessTokenResponse.  # noqa: E501

        ID of the access token  # noqa: E501

        :return: The access_token_id of this AlertingAccessTokenResponse.  # noqa: E501
        :rtype: string
        """
        return self._access_token_id

    @access_token_id.setter
    def access_token_id(self, access_token_id):
        """Sets the access_token_id of this AlertingAccessTokenResponse.

        ID of the access token  # noqa: E501

        :param access_token_id: The access_token_id of this AlertingAccessTokenResponse.  # noqa: E501
        :type: string
        """
        if access_token_id is None:
            raise ValueError("Invalid value for `access_token_id`, must not be `None`")  # noqa: E501

        self._access_token_id = access_token_id

    @property
    def external_provider_name(self):
        """Gets the external_provider_name of this AlertingAccessTokenResponse.  # noqa: E501

        External provider name  # noqa: E501

        :return: The external_provider_name of this AlertingAccessTokenResponse.  # noqa: E501
        :rtype: string
        """
        return self._external_provider_name

    @external_provider_name.setter
    def external_provider_name(self, external_provider_name):
        """Sets the external_provider_name of this AlertingAccessTokenResponse.

        External provider name  # noqa: E501

        :param external_provider_name: The external_provider_name of this AlertingAccessTokenResponse.  # noqa: E501
        :type: string
        """
        if external_provider_name is None:
            raise ValueError("Invalid value for `external_provider_name`, must not be `None`")  # noqa: E501
        allowed_values = [undefined, undefined, undefined, ]  # noqa: E501

        self._external_provider_name = external_provider_name

    @property
    def external_user_email(self):
        """Gets the external_user_email of this AlertingAccessTokenResponse.  # noqa: E501

        The email of external user that used to authenticate aginst the external oauth provider  # noqa: E501

        :return: The external_user_email of this AlertingAccessTokenResponse.  # noqa: E501
        :rtype: string
        """
        return self._external_user_email

    @external_user_email.setter
    def external_user_email(self, external_user_email):
        """Sets the external_user_email of this AlertingAccessTokenResponse.

        The email of external user that used to authenticate aginst the external oauth provider  # noqa: E501

        :param external_user_email: The external_user_email of this AlertingAccessTokenResponse.  # noqa: E501
        :type: string
        """
        if external_user_email is None:
            raise ValueError("Invalid value for `external_user_email`, must not be `None`")  # noqa: E501

        self._external_user_email = external_user_email

    @property
    def external_account_name(self):
        """Gets the external_account_name of this AlertingAccessTokenResponse.  # noqa: E501

        The account name of external user that used to authenticate against the external oauth provider or basic auth  # noqa: E501

        :return: The external_account_name of this AlertingAccessTokenResponse.  # noqa: E501
        :rtype: string
        """
        return self._external_account_name

    @external_account_name.setter
    def external_account_name(self, external_account_name):
        """Sets the external_account_name of this AlertingAccessTokenResponse.

        The account name of external user that used to authenticate against the external oauth provider or basic auth  # noqa: E501

        :param external_account_name: The external_account_name of this AlertingAccessTokenResponse.  # noqa: E501
        :type: string
        """
        if external_account_name is None:
            raise ValueError("Invalid value for `external_account_name`, must not be `None`")  # noqa: E501

        self._external_account_name = external_account_name

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AlertingAccessTokenResponse):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
