# coding: utf-8

"""
    App Center Client

    Microsoft Visual Studio App Center API  # noqa: E501

    OpenAPI spec version: preview
    Contact: benedetto.abbenanti@gmail.com
    Project Repository: https://github.com/b3nab/appcenter-sdks
"""

import pprint
import re  # noqa: F401

import six


class AlertingEvent(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'event_timestamp': 'string',
        'event_id': 'string',
        'properties': 'object'
    }

    attribute_map = {
        'event_timestamp': 'event_timestamp',
        'event_id': 'event_id',
        'properties': 'properties'
    }

    def __init__(self, event_timestamp=None, event_id=None, properties=None):  # noqa: E501
        """AlertingEvent - a model defined in Swagger"""  # noqa: E501
        self._event_timestamp = None
        self._event_id = None
        self._properties = None
        self.discriminator = None
        self.event_timestamp = event_timestamp
        self.event_id = event_id
        if properties is not None:
            self.properties = properties

    @property
    def event_timestamp(self):
        """Gets the event_timestamp of this AlertingEvent.  # noqa: E501

        ISO 8601 date time when event was generated  # noqa: E501

        :return: The event_timestamp of this AlertingEvent.  # noqa: E501
        :rtype: string
        """
        return self._event_timestamp

    @event_timestamp.setter
    def event_timestamp(self, event_timestamp):
        """Sets the event_timestamp of this AlertingEvent.

        ISO 8601 date time when event was generated  # noqa: E501

        :param event_timestamp: The event_timestamp of this AlertingEvent.  # noqa: E501
        :type: string
        """
        if event_timestamp is None:
            raise ValueError("Invalid value for `event_timestamp`, must not be `None`")  # noqa: E501

        self._event_timestamp = event_timestamp

    @property
    def event_id(self):
        """Gets the event_id of this AlertingEvent.  # noqa: E501

        A unique identifier for this event instance. Useful for deduplication  # noqa: E501

        :return: The event_id of this AlertingEvent.  # noqa: E501
        :rtype: string
        """
        return self._event_id

    @event_id.setter
    def event_id(self, event_id):
        """Sets the event_id of this AlertingEvent.

        A unique identifier for this event instance. Useful for deduplication  # noqa: E501

        :param event_id: The event_id of this AlertingEvent.  # noqa: E501
        :type: string
        """
        if event_id is None:
            raise ValueError("Invalid value for `event_id`, must not be `None`")  # noqa: E501

        self._event_id = event_id

    @property
    def properties(self):
        """Gets the properties of this AlertingEvent.  # noqa: E501

        Obsolete. Use emailProperties.  # noqa: E501

        :return: The properties of this AlertingEvent.  # noqa: E501
        :rtype: object
        """
        return self._properties

    @properties.setter
    def properties(self, properties):
        """Sets the properties of this AlertingEvent.

        Obsolete. Use emailProperties.  # noqa: E501

        :param properties: The properties of this AlertingEvent.  # noqa: E501
        :type: object
        """

        self._properties = properties

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AlertingEvent):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
