# coding: utf-8

"""
    App Center Client

    Microsoft Visual Studio App Center API  # noqa: E501

    OpenAPI spec version: preview
    Contact: benedetto.abbenanti@gmail.com
    Project Repository: https://github.com/b3nab/appcenter-sdks
"""

import pprint
import re  # noqa: F401

import six


class AndroidProject(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'android_modules': 'array',
        'gradle_wrapper_path': 'string'
    }

    attribute_map = {
        'android_modules': 'android_modules',
        'gradle_wrapper_path': 'gradle_wrapper_path'
    }

    def __init__(self, android_modules=None, gradle_wrapper_path=None):  # noqa: E501
        """AndroidProject - a model defined in Swagger"""  # noqa: E501
        self._android_modules = None
        self._gradle_wrapper_path = None
        self.discriminator = None
        if android_modules is not None:
            self.android_modules = android_modules
        if gradle_wrapper_path is not None:
            self.gradle_wrapper_path = gradle_wrapper_path

    @property
    def android_modules(self):
        """Gets the android_modules of this AndroidProject.  # noqa: E501

        Android Gradle modules  # noqa: E501

        :return: The android_modules of this AndroidProject.  # noqa: E501
        :rtype: array
        """
        return self._android_modules

    @android_modules.setter
    def android_modules(self, android_modules):
        """Sets the android_modules of this AndroidProject.

        Android Gradle modules  # noqa: E501

        :param android_modules: The android_modules of this AndroidProject.  # noqa: E501
        :type: array
        """

        self._android_modules = android_modules

    @property
    def gradle_wrapper_path(self):
        """Gets the gradle_wrapper_path of this AndroidProject.  # noqa: E501

        The path of the Gradle wrapper  # noqa: E501

        :return: The gradle_wrapper_path of this AndroidProject.  # noqa: E501
        :rtype: string
        """
        return self._gradle_wrapper_path

    @gradle_wrapper_path.setter
    def gradle_wrapper_path(self, gradle_wrapper_path):
        """Sets the gradle_wrapper_path of this AndroidProject.

        The path of the Gradle wrapper  # noqa: E501

        :param gradle_wrapper_path: The gradle_wrapper_path of this AndroidProject.  # noqa: E501
        :type: string
        """

        self._gradle_wrapper_path = gradle_wrapper_path

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AndroidProject):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
