# coding: utf-8

"""
    App Center Client

    Microsoft Visual Studio App Center API  # noqa: E501

    OpenAPI spec version: preview
    Contact: benedetto.abbenanti@gmail.com
    Project Repository: https://github.com/b3nab/appcenter-sdks
"""

import pprint
import re  # noqa: F401

import six


class AppVersion(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'app_version_id': 'string',
        'app_id': 'string',
        'display_name': 'string',
        'app_version': 'string',
        'build_number': 'string'
    }

    attribute_map = {
        'app_version_id': 'app_version_id',
        'app_id': 'app_id',
        'display_name': 'display_name',
        'app_version': 'app_version',
        'build_number': 'build_number'
    }

    def __init__(self, app_version_id=None, app_id=None, display_name=None, app_version=None, build_number=None):  # noqa: E501
        """AppVersion - a model defined in Swagger"""  # noqa: E501
        self._app_version_id = None
        self._app_id = None
        self._display_name = None
        self._app_version = None
        self._build_number = None
        self.discriminator = None
        self.app_version_id = app_version_id
        self.app_id = app_id
        self.display_name = display_name
        self.app_version = app_version
        if build_number is not None:
            self.build_number = build_number

    @property
    def app_version_id(self):
        """Gets the app_version_id of this AppVersion.  # noqa: E501


        :return: The app_version_id of this AppVersion.  # noqa: E501
        :rtype: string
        """
        return self._app_version_id

    @app_version_id.setter
    def app_version_id(self, app_version_id):
        """Sets the app_version_id of this AppVersion.


        :param app_version_id: The app_version_id of this AppVersion.  # noqa: E501
        :type: string
        """
        if app_version_id is None:
            raise ValueError("Invalid value for `app_version_id`, must not be `None`")  # noqa: E501

        self._app_version_id = app_version_id

    @property
    def app_id(self):
        """Gets the app_id of this AppVersion.  # noqa: E501


        :return: The app_id of this AppVersion.  # noqa: E501
        :rtype: string
        """
        return self._app_id

    @app_id.setter
    def app_id(self, app_id):
        """Sets the app_id of this AppVersion.


        :param app_id: The app_id of this AppVersion.  # noqa: E501
        :type: string
        """
        if app_id is None:
            raise ValueError("Invalid value for `app_id`, must not be `None`")  # noqa: E501

        self._app_id = app_id

    @property
    def display_name(self):
        """Gets the display_name of this AppVersion.  # noqa: E501


        :return: The display_name of this AppVersion.  # noqa: E501
        :rtype: string
        """
        return self._display_name

    @display_name.setter
    def display_name(self, display_name):
        """Sets the display_name of this AppVersion.


        :param display_name: The display_name of this AppVersion.  # noqa: E501
        :type: string
        """
        if display_name is None:
            raise ValueError("Invalid value for `display_name`, must not be `None`")  # noqa: E501

        self._display_name = display_name

    @property
    def app_version(self):
        """Gets the app_version of this AppVersion.  # noqa: E501


        :return: The app_version of this AppVersion.  # noqa: E501
        :rtype: string
        """
        return self._app_version

    @app_version.setter
    def app_version(self, app_version):
        """Sets the app_version of this AppVersion.


        :param app_version: The app_version of this AppVersion.  # noqa: E501
        :type: string
        """
        if app_version is None:
            raise ValueError("Invalid value for `app_version`, must not be `None`")  # noqa: E501

        self._app_version = app_version

    @property
    def build_number(self):
        """Gets the build_number of this AppVersion.  # noqa: E501


        :return: The build_number of this AppVersion.  # noqa: E501
        :rtype: string
        """
        return self._build_number

    @build_number.setter
    def build_number(self, build_number):
        """Sets the build_number of this AppVersion.


        :param build_number: The build_number of this AppVersion.  # noqa: E501
        :type: string
        """

        self._build_number = build_number

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AppVersion):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
