# coding: utf-8

"""
    App Center Client

    Microsoft Visual Studio App Center API  # noqa: E501

    OpenAPI spec version: preview
    Contact: benedetto.abbenanti@gmail.com
    Project Repository: https://github.com/b3nab/appcenter-sdks
"""

import pprint
import re  # noqa: F401

import six


class ApplicationStatusRequest(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'username': 'string',
        'password': 'string',
        'bundle_identifier': 'string',
        'track_identifier': 'string',
        'build_version': 'string',
        'team_identifier': 'string',
        'train_version': 'string'
    }

    attribute_map = {
        'username': 'username',
        'password': 'password',
        'bundle_identifier': 'bundle_identifier',
        'track_identifier': 'track_identifier',
        'build_version': 'build_version',
        'team_identifier': 'team_identifier',
        'train_version': 'train_version'
    }

    def __init__(self, username=None, password=None, bundle_identifier=None, track_identifier=None, build_version=None, team_identifier=None, train_version=None):  # noqa: E501
        """ApplicationStatusRequest - a model defined in Swagger"""  # noqa: E501
        self._username = None
        self._password = None
        self._bundle_identifier = None
        self._track_identifier = None
        self._build_version = None
        self._team_identifier = None
        self._train_version = None
        self.discriminator = None
        self.username = username
        self.password = password
        self.bundle_identifier = bundle_identifier
        self.track_identifier = track_identifier
        if build_version is not None:
            self.build_version = build_version
        if team_identifier is not None:
            self.team_identifier = team_identifier
        if train_version is not None:
            self.train_version = train_version

    @property
    def username(self):
        """Gets the username of this ApplicationStatusRequest.  # noqa: E501

        The username for the Apple Developer account.  # noqa: E501

        :return: The username of this ApplicationStatusRequest.  # noqa: E501
        :rtype: string
        """
        return self._username

    @username.setter
    def username(self, username):
        """Sets the username of this ApplicationStatusRequest.

        The username for the Apple Developer account.  # noqa: E501

        :param username: The username of this ApplicationStatusRequest.  # noqa: E501
        :type: string
        """
        if username is None:
            raise ValueError("Invalid value for `username`, must not be `None`")  # noqa: E501

        self._username = username

    @property
    def password(self):
        """Gets the password of this ApplicationStatusRequest.  # noqa: E501

        The password for the Apple Developer account.  # noqa: E501

        :return: The password of this ApplicationStatusRequest.  # noqa: E501
        :rtype: string
        """
        return self._password

    @password.setter
    def password(self, password):
        """Sets the password of this ApplicationStatusRequest.

        The password for the Apple Developer account.  # noqa: E501

        :param password: The password of this ApplicationStatusRequest.  # noqa: E501
        :type: string
        """
        if password is None:
            raise ValueError("Invalid value for `password`, must not be `None`")  # noqa: E501

        self._password = password

    @property
    def bundle_identifier(self):
        """Gets the bundle_identifier of this ApplicationStatusRequest.  # noqa: E501

        Bundle Identifier of application in Apple Itunes portal.  # noqa: E501

        :return: The bundle_identifier of this ApplicationStatusRequest.  # noqa: E501
        :rtype: string
        """
        return self._bundle_identifier

    @bundle_identifier.setter
    def bundle_identifier(self, bundle_identifier):
        """Sets the bundle_identifier of this ApplicationStatusRequest.

        Bundle Identifier of application in Apple Itunes portal.  # noqa: E501

        :param bundle_identifier: The bundle_identifier of this ApplicationStatusRequest.  # noqa: E501
        :type: string
        """
        if bundle_identifier is None:
            raise ValueError("Invalid value for `bundle_identifier`, must not be `None`")  # noqa: E501

        self._bundle_identifier = bundle_identifier

    @property
    def track_identifier(self):
        """Gets the track_identifier of this ApplicationStatusRequest.  # noqa: E501

        Track Identifier for which the status is to be fetched.  # noqa: E501

        :return: The track_identifier of this ApplicationStatusRequest.  # noqa: E501
        :rtype: string
        """
        return self._track_identifier

    @track_identifier.setter
    def track_identifier(self, track_identifier):
        """Sets the track_identifier of this ApplicationStatusRequest.

        Track Identifier for which the status is to be fetched.  # noqa: E501

        :param track_identifier: The track_identifier of this ApplicationStatusRequest.  # noqa: E501
        :type: string
        """
        if track_identifier is None:
            raise ValueError("Invalid value for `track_identifier`, must not be `None`")  # noqa: E501

        self._track_identifier = track_identifier

    @property
    def build_version(self):
        """Gets the build_version of this ApplicationStatusRequest.  # noqa: E501

        The version of build for which real time status is to be fetched.  # noqa: E501

        :return: The build_version of this ApplicationStatusRequest.  # noqa: E501
        :rtype: string
        """
        return self._build_version

    @build_version.setter
    def build_version(self, build_version):
        """Sets the build_version of this ApplicationStatusRequest.

        The version of build for which real time status is to be fetched.  # noqa: E501

        :param build_version: The build_version of this ApplicationStatusRequest.  # noqa: E501
        :type: string
        """

        self._build_version = build_version

    @property
    def team_identifier(self):
        """Gets the team_identifier of this ApplicationStatusRequest.  # noqa: E501

        Identifier of the team to use when logged in.  # noqa: E501

        :return: The team_identifier of this ApplicationStatusRequest.  # noqa: E501
        :rtype: string
        """
        return self._team_identifier

    @team_identifier.setter
    def team_identifier(self, team_identifier):
        """Sets the team_identifier of this ApplicationStatusRequest.

        Identifier of the team to use when logged in.  # noqa: E501

        :param team_identifier: The team_identifier of this ApplicationStatusRequest.  # noqa: E501
        :type: string
        """

        self._team_identifier = team_identifier

    @property
    def train_version(self):
        """Gets the train_version of this ApplicationStatusRequest.  # noqa: E501

        The Train version for which the status is to be fetched.  # noqa: E501

        :return: The train_version of this ApplicationStatusRequest.  # noqa: E501
        :rtype: string
        """
        return self._train_version

    @train_version.setter
    def train_version(self, train_version):
        """Sets the train_version of this ApplicationStatusRequest.

        The Train version for which the status is to be fetched.  # noqa: E501

        :param train_version: The train_version of this ApplicationStatusRequest.  # noqa: E501
        :type: string
        """

        self._train_version = train_version

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ApplicationStatusRequest):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
