# coding: utf-8

"""
    App Center Client

    Microsoft Visual Studio App Center API  # noqa: E501

    OpenAPI spec version: preview
    Contact: benedetto.abbenanti@gmail.com
    Project Repository: https://github.com/b3nab/appcenter-sdks
"""

import pprint
import re  # noqa: F401

import six


class ApplicationStatusResponse(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'version_type': 'string',
        'version': 'string'
    }

    attribute_map = {
        'version_type': 'version_type',
        'version': 'version'
    }

    def __init__(self, version_type=None, version=None):  # noqa: E501
        """ApplicationStatusResponse - a model defined in Swagger"""  # noqa: E501
        self._version_type = None
        self._version = None
        self.discriminator = None
        self.version_type = version_type
        if version is not None:
            self.version = version

    @property
    def version_type(self):
        """Gets the version_type of this ApplicationStatusResponse.  # noqa: E501

        The type of version being returned (production/edit/test flight).  # noqa: E501

        :return: The version_type of this ApplicationStatusResponse.  # noqa: E501
        :rtype: string
        """
        return self._version_type

    @version_type.setter
    def version_type(self, version_type):
        """Sets the version_type of this ApplicationStatusResponse.

        The type of version being returned (production/edit/test flight).  # noqa: E501

        :param version_type: The version_type of this ApplicationStatusResponse.  # noqa: E501
        :type: string
        """
        if version_type is None:
            raise ValueError("Invalid value for `version_type`, must not be `None`")  # noqa: E501

        self._version_type = version_type

    @property
    def version(self):
        """Gets the version of this ApplicationStatusResponse.  # noqa: E501

        The version of the application  # noqa: E501

        :return: The version of this ApplicationStatusResponse.  # noqa: E501
        :rtype: string
        """
        return self._version

    @version.setter
    def version(self, version):
        """Sets the version of this ApplicationStatusResponse.

        The version of the application  # noqa: E501

        :param version: The version of this ApplicationStatusResponse.  # noqa: E501
        :type: string
        """

        self._version = version

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ApplicationStatusResponse):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
