# coding: utf-8

"""
    App Center Client

    Microsoft Visual Studio App Center API  # noqa: E501

    OpenAPI spec version: preview
    Contact: benedetto.abbenanti@gmail.com
    Project Repository: https://github.com/b3nab/appcenter-sdks
"""

import pprint
import re  # noqa: F401

import six


class ArchIdentifier(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'architecture': 'string',
        'uuid': 'string'
    }

    attribute_map = {
        'architecture': 'architecture',
        'uuid': 'uuid'
    }

    def __init__(self, architecture=None, uuid=None):  # noqa: E501
        """ArchIdentifier - a model defined in Swagger"""  # noqa: E501
        self._architecture = None
        self._uuid = None
        self.discriminator = None
        self.architecture = architecture
        self.uuid = uuid

    @property
    def architecture(self):
        """Gets the architecture of this ArchIdentifier.  # noqa: E501

        The architecture that the UUID belongs to, i.e. armv7 or arm64.  # noqa: E501

        :return: The architecture of this ArchIdentifier.  # noqa: E501
        :rtype: string
        """
        return self._architecture

    @architecture.setter
    def architecture(self, architecture):
        """Sets the architecture of this ArchIdentifier.

        The architecture that the UUID belongs to, i.e. armv7 or arm64.  # noqa: E501

        :param architecture: The architecture of this ArchIdentifier.  # noqa: E501
        :type: string
        """
        if architecture is None:
            raise ValueError("Invalid value for `architecture`, must not be `None`")  # noqa: E501

        self._architecture = architecture

    @property
    def uuid(self):
        """Gets the uuid of this ArchIdentifier.  # noqa: E501

        The unique identifier.  # noqa: E501

        :return: The uuid of this ArchIdentifier.  # noqa: E501
        :rtype: string
        """
        return self._uuid

    @uuid.setter
    def uuid(self, uuid):
        """Sets the uuid of this ArchIdentifier.

        The unique identifier.  # noqa: E501

        :param uuid: The uuid of this ArchIdentifier.  # noqa: E501
        :type: string
        """
        if uuid is None:
            raise ValueError("Invalid value for `uuid`, must not be `None`")  # noqa: E501

        self._uuid = uuid

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ArchIdentifier):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
