# coding: utf-8

"""
    App Center Client

    Microsoft Visual Studio App Center API  # noqa: E501

    OpenAPI spec version: preview
    Contact: benedetto.abbenanti@gmail.com
    Project Repository: https://github.com/b3nab/appcenter-sdks
"""

import pprint
import re  # noqa: F401

import six


class AudienceSummary(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    allowed enum values
    """
    Calculating = "Calculating"
    Ready = "Ready"
    Disabled = "Disabled"
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'name': 'string',
        'description': 'string',
        'estimated_count': 'integer',
        'definition': 'string',
        'state': 'string'
    }

    attribute_map = {
        'name': 'name',
        'description': 'description',
        'estimated_count': 'estimated_count',
        'definition': 'definition',
        'state': 'state'
    }

    def __init__(self, name=None, description=None, estimated_count=None, definition=None, state=None):  # noqa: E501
        """AudienceSummary - a model defined in Swagger"""  # noqa: E501
        self._name = None
        self._description = None
        self._estimated_count = None
        self._definition = None
        self._state = None
        self.discriminator = None
        if name is not None:
            self.name = name
        if description is not None:
            self.description = description
        if estimated_count is not None:
            self.estimated_count = estimated_count
        if definition is not None:
            self.definition = definition
        if state is not None:
            self.state = state

    @property
    def name(self):
        """Gets the name of this AudienceSummary.  # noqa: E501

        Audience name.  # noqa: E501

        :return: The name of this AudienceSummary.  # noqa: E501
        :rtype: string
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this AudienceSummary.

        Audience name.  # noqa: E501

        :param name: The name of this AudienceSummary.  # noqa: E501
        :type: string
        """

        self._name = name

    @property
    def description(self):
        """Gets the description of this AudienceSummary.  # noqa: E501

        Audience description.  # noqa: E501

        :return: The description of this AudienceSummary.  # noqa: E501
        :rtype: string
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this AudienceSummary.

        Audience description.  # noqa: E501

        :param description: The description of this AudienceSummary.  # noqa: E501
        :type: string
        """

        self._description = description

    @property
    def estimated_count(self):
        """Gets the estimated_count of this AudienceSummary.  # noqa: E501

        Estimated audience size.  # noqa: E501

        :return: The estimated_count of this AudienceSummary.  # noqa: E501
        :rtype: integer
        """
        return self._estimated_count

    @estimated_count.setter
    def estimated_count(self, estimated_count):
        """Sets the estimated_count of this AudienceSummary.

        Estimated audience size.  # noqa: E501

        :param estimated_count: The estimated_count of this AudienceSummary.  # noqa: E501
        :type: integer
        """

        self._estimated_count = estimated_count

    @property
    def definition(self):
        """Gets the definition of this AudienceSummary.  # noqa: E501

        Audience definition in OData format.  # noqa: E501

        :return: The definition of this AudienceSummary.  # noqa: E501
        :rtype: string
        """
        return self._definition

    @definition.setter
    def definition(self, definition):
        """Sets the definition of this AudienceSummary.

        Audience definition in OData format.  # noqa: E501

        :param definition: The definition of this AudienceSummary.  # noqa: E501
        :type: string
        """

        self._definition = definition

    @property
    def state(self):
        """Gets the state of this AudienceSummary.  # noqa: E501

        Audience state.  # noqa: E501

        :return: The state of this AudienceSummary.  # noqa: E501
        :rtype: string
        """
        return self._state

    @state.setter
    def state(self, state):
        """Sets the state of this AudienceSummary.

        Audience state.  # noqa: E501

        :param state: The state of this AudienceSummary.  # noqa: E501
        :type: string
        """
        allowed_values = [undefinedundefinedundefined]  # noqa: E501

        self._state = state

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AudienceSummary):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
