# coding: utf-8

"""
    App Center Client

    Microsoft Visual Studio App Center API  # noqa: E501

    OpenAPI spec version: preview
    Contact: benedetto.abbenanti@gmail.com
    Project Repository: https://github.com/b3nab/appcenter-sdks
"""

import pprint
import re  # noqa: F401

import six


class BasicAppResponse(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    allowed enum values
    """
    org = "org"
    user = "user"
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'string',
        'description': 'string',
        'display_name': 'string',
        'release_type': 'string',
        'icon_url': 'string',
        'icon_source': 'string',
        'name': 'string',
        'os': 'string',
        'owner': ''
    }

    attribute_map = {
        'id': 'id',
        'description': 'description',
        'display_name': 'display_name',
        'release_type': 'release_type',
        'icon_url': 'icon_url',
        'icon_source': 'icon_source',
        'name': 'name',
        'os': 'os',
        'owner': 'owner'
    }

    def __init__(self, id=None, description=None, display_name=None, release_type=None, icon_url=None, icon_source=None, name=None, os=None, owner=None):  # noqa: E501
        """BasicAppResponse - a model defined in Swagger"""  # noqa: E501
        self._id = None
        self._description = None
        self._display_name = None
        self._release_type = None
        self._icon_url = None
        self._icon_source = None
        self._name = None
        self._os = None
        self._owner = None
        self.discriminator = None
        self.id = id
        if description is not None:
            self.description = description
        self.display_name = display_name
        if release_type is not None:
            self.release_type = release_type
        if icon_url is not None:
            self.icon_url = icon_url
        if icon_source is not None:
            self.icon_source = icon_source
        self.name = name
        self.os = os
        self.owner = owner

    @property
    def id(self):
        """Gets the id of this BasicAppResponse.  # noqa: E501

        The unique ID (UUID) of the app  # noqa: E501

        :return: The id of this BasicAppResponse.  # noqa: E501
        :rtype: string
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this BasicAppResponse.

        The unique ID (UUID) of the app  # noqa: E501

        :param id: The id of this BasicAppResponse.  # noqa: E501
        :type: string
        """
        if id is None:
            raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def description(self):
        """Gets the description of this BasicAppResponse.  # noqa: E501

        The description of the app  # noqa: E501

        :return: The description of this BasicAppResponse.  # noqa: E501
        :rtype: string
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this BasicAppResponse.

        The description of the app  # noqa: E501

        :param description: The description of this BasicAppResponse.  # noqa: E501
        :type: string
        """

        self._description = description

    @property
    def display_name(self):
        """Gets the display_name of this BasicAppResponse.  # noqa: E501

        The display name of the app  # noqa: E501

        :return: The display_name of this BasicAppResponse.  # noqa: E501
        :rtype: string
        """
        return self._display_name

    @display_name.setter
    def display_name(self, display_name):
        """Sets the display_name of this BasicAppResponse.

        The display name of the app  # noqa: E501

        :param display_name: The display_name of this BasicAppResponse.  # noqa: E501
        :type: string
        """
        if display_name is None:
            raise ValueError("Invalid value for `display_name`, must not be `None`")  # noqa: E501

        self._display_name = display_name

    @property
    def release_type(self):
        """Gets the release_type of this BasicAppResponse.  # noqa: E501

        A one-word descriptive release-type value that starts with a capital letter but is otherwise lowercase  # noqa: E501

        :return: The release_type of this BasicAppResponse.  # noqa: E501
        :rtype: string
        """
        return self._release_type

    @release_type.setter
    def release_type(self, release_type):
        """Sets the release_type of this BasicAppResponse.

        A one-word descriptive release-type value that starts with a capital letter but is otherwise lowercase  # noqa: E501

        :param release_type: The release_type of this BasicAppResponse.  # noqa: E501
        :type: string
        """

        self._release_type = release_type

    @property
    def icon_url(self):
        """Gets the icon_url of this BasicAppResponse.  # noqa: E501

        The string representation of the URL pointing to the app's icon  # noqa: E501

        :return: The icon_url of this BasicAppResponse.  # noqa: E501
        :rtype: string
        """
        return self._icon_url

    @icon_url.setter
    def icon_url(self, icon_url):
        """Sets the icon_url of this BasicAppResponse.

        The string representation of the URL pointing to the app's icon  # noqa: E501

        :param icon_url: The icon_url of this BasicAppResponse.  # noqa: E501
        :type: string
        """

        self._icon_url = icon_url

    @property
    def icon_source(self):
        """Gets the icon_source of this BasicAppResponse.  # noqa: E501

        The string representation of the source of the app's icon  # noqa: E501

        :return: The icon_source of this BasicAppResponse.  # noqa: E501
        :rtype: string
        """
        return self._icon_source

    @icon_source.setter
    def icon_source(self, icon_source):
        """Sets the icon_source of this BasicAppResponse.

        The string representation of the source of the app's icon  # noqa: E501

        :param icon_source: The icon_source of this BasicAppResponse.  # noqa: E501
        :type: string
        """

        self._icon_source = icon_source

    @property
    def name(self):
        """Gets the name of this BasicAppResponse.  # noqa: E501

        The name of the app used in URLs  # noqa: E501

        :return: The name of this BasicAppResponse.  # noqa: E501
        :rtype: string
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this BasicAppResponse.

        The name of the app used in URLs  # noqa: E501

        :param name: The name of this BasicAppResponse.  # noqa: E501
        :type: string
        """
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def os(self):
        """Gets the os of this BasicAppResponse.  # noqa: E501

        The OS the app will be running on  # noqa: E501

        :return: The os of this BasicAppResponse.  # noqa: E501
        :rtype: string
        """
        return self._os

    @os.setter
    def os(self, os):
        """Sets the os of this BasicAppResponse.

        The OS the app will be running on  # noqa: E501

        :param os: The os of this BasicAppResponse.  # noqa: E501
        :type: string
        """
        if os is None:
            raise ValueError("Invalid value for `os`, must not be `None`")  # noqa: E501
        allowed_values = [undefined, undefined, ]  # noqa: E501

        self._os = os

    @property
    def owner(self):
        """Gets the owner of this BasicAppResponse.  # noqa: E501

        The information about the app's owner  # noqa: E501

        :return: The owner of this BasicAppResponse.  # noqa: E501
        :rtype: 
        """
        return self._owner

    @owner.setter
    def owner(self, owner):
        """Sets the owner of this BasicAppResponse.

        The information about the app's owner  # noqa: E501

        :param owner: The owner of this BasicAppResponse.  # noqa: E501
        :type: 
        """
        if owner is None:
            raise ValueError("Invalid value for `owner`, must not be `None`")  # noqa: E501

        self._owner = owner

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, BasicAppResponse):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
