# coding: utf-8

"""
    App Center Client

    Microsoft Visual Studio App Center API  # noqa: E501

    OpenAPI spec version: preview
    Contact: benedetto.abbenanti@gmail.com
    Project Repository: https://github.com/b3nab/appcenter-sdks
"""

import pprint
import re  # noqa: F401

import six


class BranchConfigurationToolsets(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'xcode': '',
        'javascript': '',
        'xamarin': '',
        'android': ''
    }

    attribute_map = {
        'xcode': 'xcode',
        'javascript': 'javascript',
        'xamarin': 'xamarin',
        'android': 'android'
    }

    def __init__(self, xcode=None, javascript=None, xamarin=None, android=None):  # noqa: E501
        """BranchConfigurationToolsets - a model defined in Swagger"""  # noqa: E501
        self._xcode = None
        self._javascript = None
        self._xamarin = None
        self._android = None
        self.discriminator = None
        if xcode is not None:
            self.xcode = xcode
        if javascript is not None:
            self.javascript = javascript
        if xamarin is not None:
            self.xamarin = xamarin
        if android is not None:
            self.android = android

    @property
    def xcode(self):
        """Gets the xcode of this BranchConfigurationToolsets.  # noqa: E501

        Build configuration when Xcode is part of the build steps  # noqa: E501

        :return: The xcode of this BranchConfigurationToolsets.  # noqa: E501
        :rtype: 
        """
        return self._xcode

    @xcode.setter
    def xcode(self, xcode):
        """Sets the xcode of this BranchConfigurationToolsets.

        Build configuration when Xcode is part of the build steps  # noqa: E501

        :param xcode: The xcode of this BranchConfigurationToolsets.  # noqa: E501
        :type: 
        """

        self._xcode = xcode

    @property
    def javascript(self):
        """Gets the javascript of this BranchConfigurationToolsets.  # noqa: E501

        Build configuration when React Native, or other JavaScript tech, is part of the build steps  # noqa: E501

        :return: The javascript of this BranchConfigurationToolsets.  # noqa: E501
        :rtype: 
        """
        return self._javascript

    @javascript.setter
    def javascript(self, javascript):
        """Sets the javascript of this BranchConfigurationToolsets.

        Build configuration when React Native, or other JavaScript tech, is part of the build steps  # noqa: E501

        :param javascript: The javascript of this BranchConfigurationToolsets.  # noqa: E501
        :type: 
        """

        self._javascript = javascript

    @property
    def xamarin(self):
        """Gets the xamarin of this BranchConfigurationToolsets.  # noqa: E501

        Build configuration for Xamarin projects  # noqa: E501

        :return: The xamarin of this BranchConfigurationToolsets.  # noqa: E501
        :rtype: 
        """
        return self._xamarin

    @xamarin.setter
    def xamarin(self, xamarin):
        """Sets the xamarin of this BranchConfigurationToolsets.

        Build configuration for Xamarin projects  # noqa: E501

        :param xamarin: The xamarin of this BranchConfigurationToolsets.  # noqa: E501
        :type: 
        """

        self._xamarin = xamarin

    @property
    def android(self):
        """Gets the android of this BranchConfigurationToolsets.  # noqa: E501

        Build configuration for Android projects  # noqa: E501

        :return: The android of this BranchConfigurationToolsets.  # noqa: E501
        :rtype: 
        """
        return self._android

    @android.setter
    def android(self, android):
        """Sets the android of this BranchConfigurationToolsets.

        Build configuration for Android projects  # noqa: E501

        :param android: The android of this BranchConfigurationToolsets.  # noqa: E501
        :type: 
        """

        self._android = android

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, BranchConfigurationToolsets):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
