# coding: utf-8

"""
    App Center Client

    Microsoft Visual Studio App Center API  # noqa: E501

    OpenAPI spec version: preview
    Contact: benedetto.abbenanti@gmail.com
    Project Repository: https://github.com/b3nab/appcenter-sdks
"""

import pprint
import re  # noqa: F401

import six


class BuildParams(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'source_version': 'string',
        'debug': 'boolean'
    }

    attribute_map = {
        'source_version': 'source_version',
        'debug': 'debug'
    }

    def __init__(self, source_version=None, debug=None):  # noqa: E501
        """BuildParams - a model defined in Swagger"""  # noqa: E501
        self._source_version = None
        self._debug = None
        self.discriminator = None
        if source_version is not None:
            self.source_version = source_version
        if debug is not None:
            self.debug = debug

    @property
    def source_version(self):
        """Gets the source_version of this BuildParams.  # noqa: E501

        Version to build which represents the full Git commit reference  # noqa: E501

        :return: The source_version of this BuildParams.  # noqa: E501
        :rtype: string
        """
        return self._source_version

    @source_version.setter
    def source_version(self, source_version):
        """Sets the source_version of this BuildParams.

        Version to build which represents the full Git commit reference  # noqa: E501

        :param source_version: The source_version of this BuildParams.  # noqa: E501
        :type: string
        """

        self._source_version = source_version

    @property
    def debug(self):
        """Gets the debug of this BuildParams.  # noqa: E501

        Run build in debug mode  # noqa: E501

        :return: The debug of this BuildParams.  # noqa: E501
        :rtype: boolean
        """
        return self._debug

    @debug.setter
    def debug(self, debug):
        """Sets the debug of this BuildParams.

        Run build in debug mode  # noqa: E501

        :param debug: The debug of this BuildParams.  # noqa: E501
        :type: boolean
        """

        self._debug = debug

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, BuildParams):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
