# coding: utf-8

"""
    App Center Client

    Microsoft Visual Studio App Center API  # noqa: E501

    OpenAPI spec version: preview
    Contact: benedetto.abbenanti@gmail.com
    Project Repository: https://github.com/b3nab/appcenter-sdks
"""

import pprint
import re  # noqa: F401

import six


class DataSubjectRightStatusResponse(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    allowed enum values
    """
    None = "None"
    Created = "Created"
    Queued = "Queued"
    InProgress = "InProgress"
    Completed = "Completed"
    Failed = "Failed"
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'sas_url': 'string',
        'sas_url_expired': 'boolean',
        'status': 'string',
        'message': 'string'
    }

    attribute_map = {
        'sas_url': 'sas_url',
        'sas_url_expired': 'sas_url_expired',
        'status': 'status',
        'message': 'message'
    }

    def __init__(self, sas_url=None, sas_url_expired=None, status=None, message=None):  # noqa: E501
        """DataSubjectRightStatusResponse - a model defined in Swagger"""  # noqa: E501
        self._sas_url = None
        self._sas_url_expired = None
        self._status = None
        self._message = None
        self.discriminator = None
        if sas_url is not None:
            self.sas_url = sas_url
        if sas_url_expired is not None:
            self.sas_url_expired = sas_url_expired
        self.status = status
        self.message = message

    @property
    def sas_url(self):
        """Gets the sas_url of this DataSubjectRightStatusResponse.  # noqa: E501

        Azure Storage shared access signature (SAS) URL for exported user data.  # noqa: E501

        :return: The sas_url of this DataSubjectRightStatusResponse.  # noqa: E501
        :rtype: string
        """
        return self._sas_url

    @sas_url.setter
    def sas_url(self, sas_url):
        """Sets the sas_url of this DataSubjectRightStatusResponse.

        Azure Storage shared access signature (SAS) URL for exported user data.  # noqa: E501

        :param sas_url: The sas_url of this DataSubjectRightStatusResponse.  # noqa: E501
        :type: string
        """

        self._sas_url = sas_url

    @property
    def sas_url_expired(self):
        """Gets the sas_url_expired of this DataSubjectRightStatusResponse.  # noqa: E501

        Whether Azure Storage shared access signature (SAS) URL has expired or not.  # noqa: E501

        :return: The sas_url_expired of this DataSubjectRightStatusResponse.  # noqa: E501
        :rtype: boolean
        """
        return self._sas_url_expired

    @sas_url_expired.setter
    def sas_url_expired(self, sas_url_expired):
        """Sets the sas_url_expired of this DataSubjectRightStatusResponse.

        Whether Azure Storage shared access signature (SAS) URL has expired or not.  # noqa: E501

        :param sas_url_expired: The sas_url_expired of this DataSubjectRightStatusResponse.  # noqa: E501
        :type: boolean
        """

        self._sas_url_expired = sas_url_expired

    @property
    def status(self):
        """Gets the status of this DataSubjectRightStatusResponse.  # noqa: E501

        Status of data subject right request  # noqa: E501

        :return: The status of this DataSubjectRightStatusResponse.  # noqa: E501
        :rtype: string
        """
        return self._status

    @status.setter
    def status(self, status):
        """Sets the status of this DataSubjectRightStatusResponse.

        Status of data subject right request  # noqa: E501

        :param status: The status of this DataSubjectRightStatusResponse.  # noqa: E501
        :type: string
        """
        if status is None:
            raise ValueError("Invalid value for `status`, must not be `None`")  # noqa: E501
        allowed_values = [undefined, undefined, undefined, undefined, undefined, undefined, ]  # noqa: E501

        self._status = status

    @property
    def message(self):
        """Gets the message of this DataSubjectRightStatusResponse.  # noqa: E501

        explanation message of the status  # noqa: E501

        :return: The message of this DataSubjectRightStatusResponse.  # noqa: E501
        :rtype: string
        """
        return self._message

    @message.setter
    def message(self, message):
        """Sets the message of this DataSubjectRightStatusResponse.

        explanation message of the status  # noqa: E501

        :param message: The message of this DataSubjectRightStatusResponse.  # noqa: E501
        :type: string
        """
        if message is None:
            raise ValueError("Invalid value for `message`, must not be `None`")  # noqa: E501

        self._message = message

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, DataSubjectRightStatusResponse):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
