# coding: utf-8

"""
    App Center Client

    Microsoft Visual Studio App Center API  # noqa: E501

    OpenAPI spec version: preview
    Contact: benedetto.abbenanti@gmail.com
    Project Repository: https://github.com/b3nab/appcenter-sdks
"""

import pprint
import re  # noqa: F401

import six


class DeviceConfiguration(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'name': 'string',
        'id': 'string',
        'tier': 'number',
        'image': '',
        'model': '',
        'os': 'string',
        'os_name': 'string',
        'market_share': 'number'
    }

    attribute_map = {
        'name': 'name',
        'id': 'id',
        'tier': 'tier',
        'image': 'image',
        'model': 'model',
        'os': 'os',
        'os_name': 'os_name',
        'market_share': 'market_share'
    }

    def __init__(self, name=None, id=None, tier=None, image=None, model=None, os=None, os_name=None, market_share=None):  # noqa: E501
        """DeviceConfiguration - a model defined in Swagger"""  # noqa: E501
        self._name = None
        self._id = None
        self._tier = None
        self._image = None
        self._model = None
        self._os = None
        self._os_name = None
        self._market_share = None
        self.discriminator = None
        if name is not None:
            self.name = name
        if id is not None:
            self.id = id
        if tier is not None:
            self.tier = tier
        if image is not None:
            self.image = image
        if model is not None:
            self.model = model
        if os is not None:
            self.os = os
        if os_name is not None:
            self.os_name = os_name
        if market_share is not None:
            self.market_share = market_share

    @property
    def name(self):
        """Gets the name of this DeviceConfiguration.  # noqa: E501

        The name of the device model and OS version  # noqa: E501

        :return: The name of this DeviceConfiguration.  # noqa: E501
        :rtype: string
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this DeviceConfiguration.

        The name of the device model and OS version  # noqa: E501

        :param name: The name of this DeviceConfiguration.  # noqa: E501
        :type: string
        """

        self._name = name

    @property
    def id(self):
        """Gets the id of this DeviceConfiguration.  # noqa: E501

        The unique id of the device configuration  # noqa: E501

        :return: The id of this DeviceConfiguration.  # noqa: E501
        :rtype: string
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this DeviceConfiguration.

        The unique id of the device configuration  # noqa: E501

        :param id: The id of this DeviceConfiguration.  # noqa: E501
        :type: string
        """

        self._id = id

    @property
    def tier(self):
        """Gets the tier of this DeviceConfiguration.  # noqa: E501

        The tier  # noqa: E501

        :return: The tier of this DeviceConfiguration.  # noqa: E501
        :rtype: number
        """
        return self._tier

    @tier.setter
    def tier(self, tier):
        """Sets the tier of this DeviceConfiguration.

        The tier  # noqa: E501

        :param tier: The tier of this DeviceConfiguration.  # noqa: E501
        :type: number
        """

        self._tier = tier

    @property
    def image(self):
        """Gets the image of this DeviceConfiguration.  # noqa: E501


        :return: The image of this DeviceConfiguration.  # noqa: E501
        :rtype: 
        """
        return self._image

    @image.setter
    def image(self, image):
        """Sets the image of this DeviceConfiguration.


        :param image: The image of this DeviceConfiguration.  # noqa: E501
        :type: 
        """

        self._image = image

    @property
    def model(self):
        """Gets the model of this DeviceConfiguration.  # noqa: E501


        :return: The model of this DeviceConfiguration.  # noqa: E501
        :rtype: 
        """
        return self._model

    @model.setter
    def model(self, model):
        """Sets the model of this DeviceConfiguration.


        :param model: The model of this DeviceConfiguration.  # noqa: E501
        :type: 
        """

        self._model = model

    @property
    def os(self):
        """Gets the os of this DeviceConfiguration.  # noqa: E501


        :return: The os of this DeviceConfiguration.  # noqa: E501
        :rtype: string
        """
        return self._os

    @os.setter
    def os(self, os):
        """Sets the os of this DeviceConfiguration.


        :param os: The os of this DeviceConfiguration.  # noqa: E501
        :type: string
        """

        self._os = os

    @property
    def os_name(self):
        """Gets the os_name of this DeviceConfiguration.  # noqa: E501


        :return: The os_name of this DeviceConfiguration.  # noqa: E501
        :rtype: string
        """
        return self._os_name

    @os_name.setter
    def os_name(self, os_name):
        """Sets the os_name of this DeviceConfiguration.


        :param os_name: The os_name of this DeviceConfiguration.  # noqa: E501
        :type: string
        """

        self._os_name = os_name

    @property
    def market_share(self):
        """Gets the market_share of this DeviceConfiguration.  # noqa: E501


        :return: The market_share of this DeviceConfiguration.  # noqa: E501
        :rtype: number
        """
        return self._market_share

    @market_share.setter
    def market_share(self, market_share):
        """Sets the market_share of this DeviceConfiguration.


        :param market_share: The market_share of this DeviceConfiguration.  # noqa: E501
        :type: number
        """

        self._market_share = market_share

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, DeviceConfiguration):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
