# coding: utf-8

"""
    App Center Client

    Microsoft Visual Studio App Center API  # noqa: E501

    OpenAPI spec version: preview
    Contact: benedetto.abbenanti@gmail.com
    Project Repository: https://github.com/b3nab/appcenter-sdks
"""

import pprint
import re  # noqa: F401

import six


class DeviceInfoRequest(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'udid': 'string',
        'model': 'string',
        'os_build': 'string',
        'os_version': 'string',
        'serial': 'string',
        'imei': 'string',
        'owner_id': 'string'
    }

    attribute_map = {
        'udid': 'udid',
        'model': 'model',
        'os_build': 'os_build',
        'os_version': 'os_version',
        'serial': 'serial',
        'imei': 'imei',
        'owner_id': 'owner_id'
    }

    def __init__(self, udid=None, model=None, os_build=None, os_version=None, serial=None, imei=None, owner_id=None):  # noqa: E501
        """DeviceInfoRequest - a model defined in Swagger"""  # noqa: E501
        self._udid = None
        self._model = None
        self._os_build = None
        self._os_version = None
        self._serial = None
        self._imei = None
        self._owner_id = None
        self.discriminator = None
        self.udid = udid
        self.model = model
        if os_build is not None:
            self.os_build = os_build
        if os_version is not None:
            self.os_version = os_version
        if serial is not None:
            self.serial = serial
        if imei is not None:
            self.imei = imei
        if owner_id is not None:
            self.owner_id = owner_id

    @property
    def udid(self):
        """Gets the udid of this DeviceInfoRequest.  # noqa: E501

        The Unique Device IDentifier of the device  # noqa: E501

        :return: The udid of this DeviceInfoRequest.  # noqa: E501
        :rtype: string
        """
        return self._udid

    @udid.setter
    def udid(self, udid):
        """Sets the udid of this DeviceInfoRequest.

        The Unique Device IDentifier of the device  # noqa: E501

        :param udid: The udid of this DeviceInfoRequest.  # noqa: E501
        :type: string
        """
        if udid is None:
            raise ValueError("Invalid value for `udid`, must not be `None`")  # noqa: E501

        self._udid = udid

    @property
    def model(self):
        """Gets the model of this DeviceInfoRequest.  # noqa: E501

        The model identifier of the device, in the format iDeviceM,N  # noqa: E501

        :return: The model of this DeviceInfoRequest.  # noqa: E501
        :rtype: string
        """
        return self._model

    @model.setter
    def model(self, model):
        """Sets the model of this DeviceInfoRequest.

        The model identifier of the device, in the format iDeviceM,N  # noqa: E501

        :param model: The model of this DeviceInfoRequest.  # noqa: E501
        :type: string
        """
        if model is None:
            raise ValueError("Invalid value for `model`, must not be `None`")  # noqa: E501

        self._model = model

    @property
    def os_build(self):
        """Gets the os_build of this DeviceInfoRequest.  # noqa: E501

        The build number of the last known OS version running on the device  # noqa: E501

        :return: The os_build of this DeviceInfoRequest.  # noqa: E501
        :rtype: string
        """
        return self._os_build

    @os_build.setter
    def os_build(self, os_build):
        """Sets the os_build of this DeviceInfoRequest.

        The build number of the last known OS version running on the device  # noqa: E501

        :param os_build: The os_build of this DeviceInfoRequest.  # noqa: E501
        :type: string
        """

        self._os_build = os_build

    @property
    def os_version(self):
        """Gets the os_version of this DeviceInfoRequest.  # noqa: E501

        The last known OS version running on the device  # noqa: E501

        :return: The os_version of this DeviceInfoRequest.  # noqa: E501
        :rtype: string
        """
        return self._os_version

    @os_version.setter
    def os_version(self, os_version):
        """Sets the os_version of this DeviceInfoRequest.

        The last known OS version running on the device  # noqa: E501

        :param os_version: The os_version of this DeviceInfoRequest.  # noqa: E501
        :type: string
        """

        self._os_version = os_version

    @property
    def serial(self):
        """Gets the serial of this DeviceInfoRequest.  # noqa: E501

        The device's serial number. Always empty or undefined at present.  # noqa: E501

        :return: The serial of this DeviceInfoRequest.  # noqa: E501
        :rtype: string
        """
        return self._serial

    @serial.setter
    def serial(self, serial):
        """Sets the serial of this DeviceInfoRequest.

        The device's serial number. Always empty or undefined at present.  # noqa: E501

        :param serial: The serial of this DeviceInfoRequest.  # noqa: E501
        :type: string
        """

        self._serial = serial

    @property
    def imei(self):
        """Gets the imei of this DeviceInfoRequest.  # noqa: E501

        The device's International Mobile Equipment Identity number. Always empty or undefined at present.  # noqa: E501

        :return: The imei of this DeviceInfoRequest.  # noqa: E501
        :rtype: string
        """
        return self._imei

    @imei.setter
    def imei(self, imei):
        """Sets the imei of this DeviceInfoRequest.

        The device's International Mobile Equipment Identity number. Always empty or undefined at present.  # noqa: E501

        :param imei: The imei of this DeviceInfoRequest.  # noqa: E501
        :type: string
        """

        self._imei = imei

    @property
    def owner_id(self):
        """Gets the owner_id of this DeviceInfoRequest.  # noqa: E501

        The user ID of the device owner.  # noqa: E501

        :return: The owner_id of this DeviceInfoRequest.  # noqa: E501
        :rtype: string
        """
        return self._owner_id

    @owner_id.setter
    def owner_id(self, owner_id):
        """Sets the owner_id of this DeviceInfoRequest.

        The user ID of the device owner.  # noqa: E501

        :param owner_id: The owner_id of this DeviceInfoRequest.  # noqa: E501
        :type: string
        """

        self._owner_id = owner_id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, DeviceInfoRequest):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
