# coding: utf-8

"""
    App Center Client

    Microsoft Visual Studio App Center API  # noqa: E501

    OpenAPI spec version: preview
    Contact: benedetto.abbenanti@gmail.com
    Project Repository: https://github.com/b3nab/appcenter-sdks
"""

import pprint
import re  # noqa: F401

import six


class DeviceSetOwner(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'device_set_owner': 'object',
        'type': 'string',
        'id': 'string',
        'display_name': 'string',
        'name': 'string'
    }

    attribute_map = {
        'device_set_owner': 'device_set_owner',
        'type': 'type',
        'id': 'id',
        'display_name': 'display_name',
        'name': 'name'
    }

    def __init__(self, device_set_owner=None, type=None, id=None, display_name=None, name=None):  # noqa: E501
        """DeviceSetOwner - a model defined in Swagger"""  # noqa: E501
        self._device_set_owner = None
        self._type = None
        self._id = None
        self._display_name = None
        self._name = None
        self.discriminator = None
        if device_set_owner is not None:
            self.device_set_owner = device_set_owner
        self.type = type
        self.id = id
        if display_name is not None:
            self.display_name = display_name
        self.name = name

    @property
    def device_set_owner(self):
        """Gets the device_set_owner of this DeviceSetOwner.  # noqa: E501

        The owner of a device set  # noqa: E501

        :return: The device_set_owner of this DeviceSetOwner.  # noqa: E501
        :rtype: object
        """
        return self._device_set_owner

    @device_set_owner.setter
    def device_set_owner(self, device_set_owner):
        """Sets the device_set_owner of this DeviceSetOwner.

        The owner of a device set  # noqa: E501

        :param device_set_owner: The device_set_owner of this DeviceSetOwner.  # noqa: E501
        :type: object
        """

        self._device_set_owner = device_set_owner

    @property
    def type(self):
        """Gets the type of this DeviceSetOwner.  # noqa: E501

        Type of account  # noqa: E501

        :return: The type of this DeviceSetOwner.  # noqa: E501
        :rtype: string
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this DeviceSetOwner.

        Type of account  # noqa: E501

        :param type: The type of this DeviceSetOwner.  # noqa: E501
        :type: string
        """
        if type is None:
            raise ValueError("Invalid value for `type`, must not be `None`")  # noqa: E501

        self._type = type

    @property
    def id(self):
        """Gets the id of this DeviceSetOwner.  # noqa: E501

        Account ID  # noqa: E501

        :return: The id of this DeviceSetOwner.  # noqa: E501
        :rtype: string
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this DeviceSetOwner.

        Account ID  # noqa: E501

        :param id: The id of this DeviceSetOwner.  # noqa: E501
        :type: string
        """
        if id is None:
            raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def display_name(self):
        """Gets the display_name of this DeviceSetOwner.  # noqa: E501

        Display name of the account  # noqa: E501

        :return: The display_name of this DeviceSetOwner.  # noqa: E501
        :rtype: string
        """
        return self._display_name

    @display_name.setter
    def display_name(self, display_name):
        """Sets the display_name of this DeviceSetOwner.

        Display name of the account  # noqa: E501

        :param display_name: The display_name of this DeviceSetOwner.  # noqa: E501
        :type: string
        """

        self._display_name = display_name

    @property
    def name(self):
        """Gets the name of this DeviceSetOwner.  # noqa: E501

        Name of the account  # noqa: E501

        :return: The name of this DeviceSetOwner.  # noqa: E501
        :rtype: string
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this DeviceSetOwner.

        Name of the account  # noqa: E501

        :param name: The name of this DeviceSetOwner.  # noqa: E501
        :type: string
        """
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, DeviceSetOwner):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
