# coding: utf-8

"""
    App Center Client

    Microsoft Visual Studio App Center API  # noqa: E501

    OpenAPI spec version: preview
    Contact: benedetto.abbenanti@gmail.com
    Project Repository: https://github.com/b3nab/appcenter-sdks
"""

import pprint
import re  # noqa: F401

import six


class DeviceSetUpdate(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'device_set_update_information': '',
        'devices': 'array',
        'name': 'string'
    }

    attribute_map = {
        'device_set_update_information': 'device_set_update_information',
        'devices': 'devices',
        'name': 'name'
    }

    def __init__(self, device_set_update_information=None, devices=None, name=None):  # noqa: E501
        """DeviceSetUpdate - a model defined in Swagger"""  # noqa: E501
        self._device_set_update_information = None
        self._devices = None
        self._name = None
        self.discriminator = None
        if device_set_update_information is not None:
            self.device_set_update_information = device_set_update_information
        self.devices = devices
        self.name = name

    @property
    def device_set_update_information(self):
        """Gets the device_set_update_information of this DeviceSetUpdate.  # noqa: E501

        The name of the device set and the list of device IDs  # noqa: E501

        :return: The device_set_update_information of this DeviceSetUpdate.  # noqa: E501
        :rtype: 
        """
        return self._device_set_update_information

    @device_set_update_information.setter
    def device_set_update_information(self, device_set_update_information):
        """Sets the device_set_update_information of this DeviceSetUpdate.

        The name of the device set and the list of device IDs  # noqa: E501

        :param device_set_update_information: The device_set_update_information of this DeviceSetUpdate.  # noqa: E501
        :type: 
        """

        self._device_set_update_information = device_set_update_information

    @property
    def devices(self):
        """Gets the devices of this DeviceSetUpdate.  # noqa: E501

        List of device IDs  # noqa: E501

        :return: The devices of this DeviceSetUpdate.  # noqa: E501
        :rtype: array
        """
        return self._devices

    @devices.setter
    def devices(self, devices):
        """Sets the devices of this DeviceSetUpdate.

        List of device IDs  # noqa: E501

        :param devices: The devices of this DeviceSetUpdate.  # noqa: E501
        :type: array
        """
        if devices is None:
            raise ValueError("Invalid value for `devices`, must not be `None`")  # noqa: E501

        self._devices = devices

    @property
    def name(self):
        """Gets the name of this DeviceSetUpdate.  # noqa: E501

        The name of the device set  # noqa: E501

        :return: The name of this DeviceSetUpdate.  # noqa: E501
        :rtype: string
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this DeviceSetUpdate.

        The name of the device set  # noqa: E501

        :param name: The name of this DeviceSetUpdate.  # noqa: E501
        :type: string
        """
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, DeviceSetUpdate):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
