# coding: utf-8

"""
    App Center Client

    Microsoft Visual Studio App Center API  # noqa: E501

    OpenAPI spec version: preview
    Contact: benedetto.abbenanti@gmail.com
    Project Repository: https://github.com/b3nab/appcenter-sdks
"""

import pprint
import re  # noqa: F401

import six


class DistributionGroupResponse(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    allowed enum values
    """
    appcenter = "appcenter"
    hockeyapp = "hockeyapp"
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'string',
        'name': 'string',
        'display_name': 'string',
        'origin': 'string',
        'is_public': 'boolean'
    }

    attribute_map = {
        'id': 'id',
        'name': 'name',
        'display_name': 'display_name',
        'origin': 'origin',
        'is_public': 'is_public'
    }

    def __init__(self, id=None, name=None, display_name=None, origin=None, is_public=None):  # noqa: E501
        """DistributionGroupResponse - a model defined in Swagger"""  # noqa: E501
        self._id = None
        self._name = None
        self._display_name = None
        self._origin = None
        self._is_public = None
        self.discriminator = None
        self.id = id
        self.name = name
        if display_name is not None:
            self.display_name = display_name
        self.origin = origin
        self.is_public = is_public

    @property
    def id(self):
        """Gets the id of this DistributionGroupResponse.  # noqa: E501

        The unique ID of the distribution group  # noqa: E501

        :return: The id of this DistributionGroupResponse.  # noqa: E501
        :rtype: string
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this DistributionGroupResponse.

        The unique ID of the distribution group  # noqa: E501

        :param id: The id of this DistributionGroupResponse.  # noqa: E501
        :type: string
        """
        if id is None:
            raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def name(self):
        """Gets the name of this DistributionGroupResponse.  # noqa: E501

        The name of the distribution group used in URLs  # noqa: E501

        :return: The name of this DistributionGroupResponse.  # noqa: E501
        :rtype: string
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this DistributionGroupResponse.

        The name of the distribution group used in URLs  # noqa: E501

        :param name: The name of this DistributionGroupResponse.  # noqa: E501
        :type: string
        """
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def display_name(self):
        """Gets the display_name of this DistributionGroupResponse.  # noqa: E501

        The name of the distribution group  # noqa: E501

        :return: The display_name of this DistributionGroupResponse.  # noqa: E501
        :rtype: string
        """
        return self._display_name

    @display_name.setter
    def display_name(self, display_name):
        """Sets the display_name of this DistributionGroupResponse.

        The name of the distribution group  # noqa: E501

        :param display_name: The display_name of this DistributionGroupResponse.  # noqa: E501
        :type: string
        """

        self._display_name = display_name

    @property
    def origin(self):
        """Gets the origin of this DistributionGroupResponse.  # noqa: E501

        The creation origin of this distribution group  # noqa: E501

        :return: The origin of this DistributionGroupResponse.  # noqa: E501
        :rtype: string
        """
        return self._origin

    @origin.setter
    def origin(self, origin):
        """Sets the origin of this DistributionGroupResponse.

        The creation origin of this distribution group  # noqa: E501

        :param origin: The origin of this DistributionGroupResponse.  # noqa: E501
        :type: string
        """
        if origin is None:
            raise ValueError("Invalid value for `origin`, must not be `None`")  # noqa: E501
        allowed_values = [undefined, undefined, ]  # noqa: E501

        self._origin = origin

    @property
    def is_public(self):
        """Gets the is_public of this DistributionGroupResponse.  # noqa: E501

        Whether the distribution group is public  # noqa: E501

        :return: The is_public of this DistributionGroupResponse.  # noqa: E501
        :rtype: boolean
        """
        return self._is_public

    @is_public.setter
    def is_public(self, is_public):
        """Sets the is_public of this DistributionGroupResponse.

        Whether the distribution group is public  # noqa: E501

        :param is_public: The is_public of this DistributionGroupResponse.  # noqa: E501
        :type: boolean
        """
        if is_public is None:
            raise ValueError("Invalid value for `is_public`, must not be `None`")  # noqa: E501

        self._is_public = is_public

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, DistributionGroupResponse):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
