# coding: utf-8

"""
    App Center Client

    Microsoft Visual Studio App Center API  # noqa: E501

    OpenAPI spec version: preview
    Contact: benedetto.abbenanti@gmail.com
    Project Repository: https://github.com/b3nab/appcenter-sdks
"""

import pprint
import re  # noqa: F401

import six


class DistributionGroupWithUsersResponse(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'string',
        'name': 'string',
        'total_user_count': 'number',
        'total_groups_count': 'number',
        'notified_user_count': 'number',
        'is_public': 'boolean',
        'users': 'array',
        'aad_groups': 'array'
    }

    attribute_map = {
        'id': 'id',
        'name': 'name',
        'total_user_count': 'total_user_count',
        'total_groups_count': 'total_groups_count',
        'notified_user_count': 'notified_user_count',
        'is_public': 'is_public',
        'users': 'users',
        'aad_groups': 'aad_groups'
    }

    def __init__(self, id=None, name=None, total_user_count=None, total_groups_count=None, notified_user_count=None, is_public=None, users=None, aad_groups=None):  # noqa: E501
        """DistributionGroupWithUsersResponse - a model defined in Swagger"""  # noqa: E501
        self._id = None
        self._name = None
        self._total_user_count = None
        self._total_groups_count = None
        self._notified_user_count = None
        self._is_public = None
        self._users = None
        self._aad_groups = None
        self.discriminator = None
        self.id = id
        self.name = name
        self.total_user_count = total_user_count
        if total_groups_count is not None:
            self.total_groups_count = total_groups_count
        self.notified_user_count = notified_user_count
        if is_public is not None:
            self.is_public = is_public
        self.users = users
        if aad_groups is not None:
            self.aad_groups = aad_groups

    @property
    def id(self):
        """Gets the id of this DistributionGroupWithUsersResponse.  # noqa: E501

        The unique ID of the distribution group  # noqa: E501

        :return: The id of this DistributionGroupWithUsersResponse.  # noqa: E501
        :rtype: string
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this DistributionGroupWithUsersResponse.

        The unique ID of the distribution group  # noqa: E501

        :param id: The id of this DistributionGroupWithUsersResponse.  # noqa: E501
        :type: string
        """
        if id is None:
            raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def name(self):
        """Gets the name of this DistributionGroupWithUsersResponse.  # noqa: E501

        The name of the distribution group used in URLs  # noqa: E501

        :return: The name of this DistributionGroupWithUsersResponse.  # noqa: E501
        :rtype: string
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this DistributionGroupWithUsersResponse.

        The name of the distribution group used in URLs  # noqa: E501

        :param name: The name of this DistributionGroupWithUsersResponse.  # noqa: E501
        :type: string
        """
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def total_user_count(self):
        """Gets the total_user_count of this DistributionGroupWithUsersResponse.  # noqa: E501

        The count of users in the distribution group  # noqa: E501

        :return: The total_user_count of this DistributionGroupWithUsersResponse.  # noqa: E501
        :rtype: number
        """
        return self._total_user_count

    @total_user_count.setter
    def total_user_count(self, total_user_count):
        """Sets the total_user_count of this DistributionGroupWithUsersResponse.

        The count of users in the distribution group  # noqa: E501

        :param total_user_count: The total_user_count of this DistributionGroupWithUsersResponse.  # noqa: E501
        :type: number
        """
        if total_user_count is None:
            raise ValueError("Invalid value for `total_user_count`, must not be `None`")  # noqa: E501

        self._total_user_count = total_user_count

    @property
    def total_groups_count(self):
        """Gets the total_groups_count of this DistributionGroupWithUsersResponse.  # noqa: E501

        The count of aad groups in the distribution group  # noqa: E501

        :return: The total_groups_count of this DistributionGroupWithUsersResponse.  # noqa: E501
        :rtype: number
        """
        return self._total_groups_count

    @total_groups_count.setter
    def total_groups_count(self, total_groups_count):
        """Sets the total_groups_count of this DistributionGroupWithUsersResponse.

        The count of aad groups in the distribution group  # noqa: E501

        :param total_groups_count: The total_groups_count of this DistributionGroupWithUsersResponse.  # noqa: E501
        :type: number
        """

        self._total_groups_count = total_groups_count

    @property
    def notified_user_count(self):
        """Gets the notified_user_count of this DistributionGroupWithUsersResponse.  # noqa: E501

        The count of non-pending users in the distribution group who will be notified by new releases  # noqa: E501

        :return: The notified_user_count of this DistributionGroupWithUsersResponse.  # noqa: E501
        :rtype: number
        """
        return self._notified_user_count

    @notified_user_count.setter
    def notified_user_count(self, notified_user_count):
        """Sets the notified_user_count of this DistributionGroupWithUsersResponse.

        The count of non-pending users in the distribution group who will be notified by new releases  # noqa: E501

        :param notified_user_count: The notified_user_count of this DistributionGroupWithUsersResponse.  # noqa: E501
        :type: number
        """
        if notified_user_count is None:
            raise ValueError("Invalid value for `notified_user_count`, must not be `None`")  # noqa: E501

        self._notified_user_count = notified_user_count

    @property
    def is_public(self):
        """Gets the is_public of this DistributionGroupWithUsersResponse.  # noqa: E501

        Whether the distribution group is public  # noqa: E501

        :return: The is_public of this DistributionGroupWithUsersResponse.  # noqa: E501
        :rtype: boolean
        """
        return self._is_public

    @is_public.setter
    def is_public(self, is_public):
        """Sets the is_public of this DistributionGroupWithUsersResponse.

        Whether the distribution group is public  # noqa: E501

        :param is_public: The is_public of this DistributionGroupWithUsersResponse.  # noqa: E501
        :type: boolean
        """

        self._is_public = is_public

    @property
    def users(self):
        """Gets the users of this DistributionGroupWithUsersResponse.  # noqa: E501

        The distribution group users  # noqa: E501

        :return: The users of this DistributionGroupWithUsersResponse.  # noqa: E501
        :rtype: array
        """
        return self._users

    @users.setter
    def users(self, users):
        """Sets the users of this DistributionGroupWithUsersResponse.

        The distribution group users  # noqa: E501

        :param users: The users of this DistributionGroupWithUsersResponse.  # noqa: E501
        :type: array
        """
        if users is None:
            raise ValueError("Invalid value for `users`, must not be `None`")  # noqa: E501

        self._users = users

    @property
    def aad_groups(self):
        """Gets the aad_groups of this DistributionGroupWithUsersResponse.  # noqa: E501

        The distribution group aad groups  # noqa: E501

        :return: The aad_groups of this DistributionGroupWithUsersResponse.  # noqa: E501
        :rtype: array
        """
        return self._aad_groups

    @aad_groups.setter
    def aad_groups(self, aad_groups):
        """Sets the aad_groups of this DistributionGroupWithUsersResponse.

        The distribution group aad groups  # noqa: E501

        :param aad_groups: The aad_groups of this DistributionGroupWithUsersResponse.  # noqa: E501
        :type: array
        """

        self._aad_groups = aad_groups

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, DistributionGroupWithUsersResponse):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
