# coding: utf-8

"""
    App Center Client

    Microsoft Visual Studio App Center API  # noqa: E501

    OpenAPI spec version: preview
    Contact: benedetto.abbenanti@gmail.com
    Project Repository: https://github.com/b3nab/appcenter-sdks
"""

import pprint
import re  # noqa: F401

import six


class Exception(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    allowed enum values
    """
    ios = "ios"
    android = "android"
    xamarin = "xamarin"
    react-native = "react-native"
    ndk = "ndk"
    unity = "unity"
    other = "other"
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'reason': 'string',
        'type': 'string',
        'frames': 'array',
        'relevant': 'boolean',
        'inner_exceptions': 'array',
        'platform': 'string'
    }

    attribute_map = {
        'reason': 'reason',
        'type': 'type',
        'frames': 'frames',
        'relevant': 'relevant',
        'inner_exceptions': 'inner_exceptions',
        'platform': 'platform'
    }

    def __init__(self, reason=None, type=None, frames=None, relevant=None, inner_exceptions=None, platform=None):  # noqa: E501
        """Exception - a model defined in Swagger"""  # noqa: E501
        self._reason = None
        self._type = None
        self._frames = None
        self._relevant = None
        self._inner_exceptions = None
        self._platform = None
        self.discriminator = None
        if reason is not None:
            self.reason = reason
        if type is not None:
            self.type = type
        self.frames = frames
        if relevant is not None:
            self.relevant = relevant
        if inner_exceptions is not None:
            self.inner_exceptions = inner_exceptions
        if platform is not None:
            self.platform = platform

    @property
    def reason(self):
        """Gets the reason of this Exception.  # noqa: E501

        Reason of the exception  # noqa: E501

        :return: The reason of this Exception.  # noqa: E501
        :rtype: string
        """
        return self._reason

    @reason.setter
    def reason(self, reason):
        """Sets the reason of this Exception.

        Reason of the exception  # noqa: E501

        :param reason: The reason of this Exception.  # noqa: E501
        :type: string
        """

        self._reason = reason

    @property
    def type(self):
        """Gets the type of this Exception.  # noqa: E501

        Type of the exception (NSSomethingException, NullPointerException)  # noqa: E501

        :return: The type of this Exception.  # noqa: E501
        :rtype: string
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this Exception.

        Type of the exception (NSSomethingException, NullPointerException)  # noqa: E501

        :param type: The type of this Exception.  # noqa: E501
        :type: string
        """

        self._type = type

    @property
    def frames(self):
        """Gets the frames of this Exception.  # noqa: E501

        frames of the excetpion  # noqa: E501

        :return: The frames of this Exception.  # noqa: E501
        :rtype: array
        """
        return self._frames

    @frames.setter
    def frames(self, frames):
        """Sets the frames of this Exception.

        frames of the excetpion  # noqa: E501

        :param frames: The frames of this Exception.  # noqa: E501
        :type: array
        """
        if frames is None:
            raise ValueError("Invalid value for `frames`, must not be `None`")  # noqa: E501

        self._frames = frames

    @property
    def relevant(self):
        """Gets the relevant of this Exception.  # noqa: E501

        relevant exception (crashed)  # noqa: E501

        :return: The relevant of this Exception.  # noqa: E501
        :rtype: boolean
        """
        return self._relevant

    @relevant.setter
    def relevant(self, relevant):
        """Sets the relevant of this Exception.

        relevant exception (crashed)  # noqa: E501

        :param relevant: The relevant of this Exception.  # noqa: E501
        :type: boolean
        """

        self._relevant = relevant

    @property
    def inner_exceptions(self):
        """Gets the inner_exceptions of this Exception.  # noqa: E501


        :return: The inner_exceptions of this Exception.  # noqa: E501
        :rtype: array
        """
        return self._inner_exceptions

    @inner_exceptions.setter
    def inner_exceptions(self, inner_exceptions):
        """Sets the inner_exceptions of this Exception.


        :param inner_exceptions: The inner_exceptions of this Exception.  # noqa: E501
        :type: array
        """

        self._inner_exceptions = inner_exceptions

    @property
    def platform(self):
        """Gets the platform of this Exception.  # noqa: E501

        SDK/Platform this thread is beeing generated from  # noqa: E501

        :return: The platform of this Exception.  # noqa: E501
        :rtype: string
        """
        return self._platform

    @platform.setter
    def platform(self, platform):
        """Sets the platform of this Exception.

        SDK/Platform this thread is beeing generated from  # noqa: E501

        :param platform: The platform of this Exception.  # noqa: E501
        :type: string
        """
        allowed_values = [undefinedundefinedundefinedundefinedundefinedundefinedundefined]  # noqa: E501

        self._platform = platform

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Exception):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
