# coding: utf-8

"""
    App Center Client

    Microsoft Visual Studio App Center API  # noqa: E501

    OpenAPI spec version: preview
    Contact: benedetto.abbenanti@gmail.com
    Project Repository: https://github.com/b3nab/appcenter-sdks
"""

import pprint
import re  # noqa: F401

import six


class JavaScriptToolset(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'package_json_paths': 'array',
        'javascript_solutions': 'array'
    }

    attribute_map = {
        'package_json_paths': 'package_json_paths',
        'javascript_solutions': 'javascript_solutions'
    }

    def __init__(self, package_json_paths=None, javascript_solutions=None):  # noqa: E501
        """JavaScriptToolset - a model defined in Swagger"""  # noqa: E501
        self._package_json_paths = None
        self._javascript_solutions = None
        self.discriminator = None
        if package_json_paths is not None:
            self.package_json_paths = package_json_paths
        if javascript_solutions is not None:
            self.javascript_solutions = javascript_solutions

    @property
    def package_json_paths(self):
        """Gets the package_json_paths of this JavaScriptToolset.  # noqa: E501

        Paths for detected package.json files  # noqa: E501

        :return: The package_json_paths of this JavaScriptToolset.  # noqa: E501
        :rtype: array
        """
        return self._package_json_paths

    @package_json_paths.setter
    def package_json_paths(self, package_json_paths):
        """Sets the package_json_paths of this JavaScriptToolset.

        Paths for detected package.json files  # noqa: E501

        :param package_json_paths: The package_json_paths of this JavaScriptToolset.  # noqa: E501
        :type: array
        """

        self._package_json_paths = package_json_paths

    @property
    def javascript_solutions(self):
        """Gets the javascript_solutions of this JavaScriptToolset.  # noqa: E501

        The React Native solutions detected  # noqa: E501

        :return: The javascript_solutions of this JavaScriptToolset.  # noqa: E501
        :rtype: array
        """
        return self._javascript_solutions

    @javascript_solutions.setter
    def javascript_solutions(self, javascript_solutions):
        """Sets the javascript_solutions of this JavaScriptToolset.

        The React Native solutions detected  # noqa: E501

        :param javascript_solutions: The javascript_solutions of this JavaScriptToolset.  # noqa: E501
        :type: array
        """

        self._javascript_solutions = javascript_solutions

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, JavaScriptToolset):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
