# coding: utf-8

"""
    App Center Client

    Microsoft Visual Studio App Center API  # noqa: E501

    OpenAPI spec version: preview
    Contact: benedetto.abbenanti@gmail.com
    Project Repository: https://github.com/b3nab/appcenter-sdks
"""

import pprint
import re  # noqa: F401

import six


class LinkAADtoUserRequest(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    allowed enum values
    """
    admin = "admin"
    collaborator = "collaborator"
    member = "member"
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'aad_tenant_ids': 'array',
        'role': 'string'
    }

    attribute_map = {
        'aad_tenant_ids': 'aad_tenant_ids',
        'role': 'role'
    }

    def __init__(self, aad_tenant_ids=None, role=None):  # noqa: E501
        """LinkAADtoUserRequest - a model defined in Swagger"""  # noqa: E501
        self._aad_tenant_ids = None
        self._role = None
        self.discriminator = None
        self.aad_tenant_ids = aad_tenant_ids
        if role is not None:
            self.role = role

    @property
    def aad_tenant_ids(self):
        """Gets the aad_tenant_ids of this LinkAADtoUserRequest.  # noqa: E501

        An array of AAD tenant data needed to link the user to the tenants  # noqa: E501

        :return: The aad_tenant_ids of this LinkAADtoUserRequest.  # noqa: E501
        :rtype: array
        """
        return self._aad_tenant_ids

    @aad_tenant_ids.setter
    def aad_tenant_ids(self, aad_tenant_ids):
        """Sets the aad_tenant_ids of this LinkAADtoUserRequest.

        An array of AAD tenant data needed to link the user to the tenants  # noqa: E501

        :param aad_tenant_ids: The aad_tenant_ids of this LinkAADtoUserRequest.  # noqa: E501
        :type: array
        """
        if aad_tenant_ids is None:
            raise ValueError("Invalid value for `aad_tenant_ids`, must not be `None`")  # noqa: E501

        self._aad_tenant_ids = aad_tenant_ids

    @property
    def role(self):
        """Gets the role of this LinkAADtoUserRequest.  # noqa: E501

        The role of the user to be added  # noqa: E501

        :return: The role of this LinkAADtoUserRequest.  # noqa: E501
        :rtype: string
        """
        return self._role

    @role.setter
    def role(self, role):
        """Sets the role of this LinkAADtoUserRequest.

        The role of the user to be added  # noqa: E501

        :param role: The role of this LinkAADtoUserRequest.  # noqa: E501
        :type: string
        """
        allowed_values = [undefinedundefinedundefined]  # noqa: E501

        self._role = role

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, LinkAADtoUserRequest):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
