# coding: utf-8

"""
    App Center Client

    Microsoft Visual Studio App Center API  # noqa: E501

    OpenAPI spec version: preview
    Contact: benedetto.abbenanti@gmail.com
    Project Repository: https://github.com/b3nab/appcenter-sdks
"""

import pprint
import re  # noqa: F401

import six


class NotificationConfigAppleResult(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    allowed enum values
    """
    production = "production"
    sandbox = "sandbox"
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'endpoint_type': 'string',
        'cert_expiration': 'string',
        'cert_filename': 'string'
    }

    attribute_map = {
        'endpoint_type': 'endpoint_type',
        'cert_expiration': 'cert_expiration',
        'cert_filename': 'cert_filename'
    }

    def __init__(self, endpoint_type=None, cert_expiration=None, cert_filename=None):  # noqa: E501
        """NotificationConfigAppleResult - a model defined in Swagger"""  # noqa: E501
        self._endpoint_type = None
        self._cert_expiration = None
        self._cert_filename = None
        self.discriminator = None
        self.endpoint_type = endpoint_type
        self.cert_expiration = cert_expiration
        self.cert_filename = cert_filename

    @property
    def endpoint_type(self):
        """Gets the endpoint_type of this NotificationConfigAppleResult.  # noqa: E501

        Type of endpoint the certificate or token are associated with  # noqa: E501

        :return: The endpoint_type of this NotificationConfigAppleResult.  # noqa: E501
        :rtype: string
        """
        return self._endpoint_type

    @endpoint_type.setter
    def endpoint_type(self, endpoint_type):
        """Sets the endpoint_type of this NotificationConfigAppleResult.

        Type of endpoint the certificate or token are associated with  # noqa: E501

        :param endpoint_type: The endpoint_type of this NotificationConfigAppleResult.  # noqa: E501
        :type: string
        """
        if endpoint_type is None:
            raise ValueError("Invalid value for `endpoint_type`, must not be `None`")  # noqa: E501
        allowed_values = [undefined, undefined, ]  # noqa: E501

        self._endpoint_type = endpoint_type

    @property
    def cert_expiration(self):
        """Gets the cert_expiration of this NotificationConfigAppleResult.  # noqa: E501

        Certificate expiration date.  # noqa: E501

        :return: The cert_expiration of this NotificationConfigAppleResult.  # noqa: E501
        :rtype: string
        """
        return self._cert_expiration

    @cert_expiration.setter
    def cert_expiration(self, cert_expiration):
        """Sets the cert_expiration of this NotificationConfigAppleResult.

        Certificate expiration date.  # noqa: E501

        :param cert_expiration: The cert_expiration of this NotificationConfigAppleResult.  # noqa: E501
        :type: string
        """
        if cert_expiration is None:
            raise ValueError("Invalid value for `cert_expiration`, must not be `None`")  # noqa: E501

        self._cert_expiration = cert_expiration

    @property
    def cert_filename(self):
        """Gets the cert_filename of this NotificationConfigAppleResult.  # noqa: E501

        Certificate file name  # noqa: E501

        :return: The cert_filename of this NotificationConfigAppleResult.  # noqa: E501
        :rtype: string
        """
        return self._cert_filename

    @cert_filename.setter
    def cert_filename(self, cert_filename):
        """Sets the cert_filename of this NotificationConfigAppleResult.

        Certificate file name  # noqa: E501

        :param cert_filename: The cert_filename of this NotificationConfigAppleResult.  # noqa: E501
        :type: string
        """
        if cert_filename is None:
            raise ValueError("Invalid value for `cert_filename`, must not be `None`")  # noqa: E501

        self._cert_filename = cert_filename

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, NotificationConfigAppleResult):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
