# coding: utf-8

"""
    App Center Client

    Microsoft Visual Studio App Center API  # noqa: E501

    OpenAPI spec version: preview
    Contact: benedetto.abbenanti@gmail.com
    Project Repository: https://github.com/b3nab/appcenter-sdks
"""

import pprint
import re  # noqa: F401

import six


class NotificationDetailsResult(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    allowed enum values
    """
    Queued = "Queued"
    Sending = "Sending"
    Completed = "Completed"
    Failed = "Failed"
    NoTargetFound = "NoTargetFound"
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'notification_content': 'object',
        'failure_outcomes': 'array'
    }

    attribute_map = {
        'notification_content': 'notification_content',
        'failure_outcomes': 'failure_outcomes'
    }

    def __init__(self, notification_content=None, failure_outcomes=None):  # noqa: E501
        """NotificationDetailsResult - a model defined in Swagger"""  # noqa: E501
        self._notification_content = None
        self._failure_outcomes = None
        self.discriminator = None
        self.notification_content = notification_content
        if failure_outcomes is not None:
            self.failure_outcomes = failure_outcomes

    @property
    def notification_content(self):
        """Gets the notification_content of this NotificationDetailsResult.  # noqa: E501

        Notification definition object  # noqa: E501

        :return: The notification_content of this NotificationDetailsResult.  # noqa: E501
        :rtype: object
        """
        return self._notification_content

    @notification_content.setter
    def notification_content(self, notification_content):
        """Sets the notification_content of this NotificationDetailsResult.

        Notification definition object  # noqa: E501

        :param notification_content: The notification_content of this NotificationDetailsResult.  # noqa: E501
        :type: object
        """
        if notification_content is None:
            raise ValueError("Invalid value for `notification_content`, must not be `None`")  # noqa: E501

        self._notification_content = notification_content

    @property
    def failure_outcomes(self):
        """Gets the failure_outcomes of this NotificationDetailsResult.  # noqa: E501

        Failture outcome counts  # noqa: E501

        :return: The failure_outcomes of this NotificationDetailsResult.  # noqa: E501
        :rtype: array
        """
        return self._failure_outcomes

    @failure_outcomes.setter
    def failure_outcomes(self, failure_outcomes):
        """Sets the failure_outcomes of this NotificationDetailsResult.

        Failture outcome counts  # noqa: E501

        :param failure_outcomes: The failure_outcomes of this NotificationDetailsResult.  # noqa: E501
        :type: array
        """

        self._failure_outcomes = failure_outcomes

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, NotificationDetailsResult):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
