# coding: utf-8

"""
    App Center Client

    Microsoft Visual Studio App Center API  # noqa: E501

    OpenAPI spec version: preview
    Contact: benedetto.abbenanti@gmail.com
    Project Repository: https://github.com/b3nab/appcenter-sdks
"""

import pprint
import re  # noqa: F401

import six


class OrganizationUserResponse(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'email': 'string',
        'display_name': 'string',
        'joined_at': 'string',
        'name': 'string',
        'role': 'string'
    }

    attribute_map = {
        'email': 'email',
        'display_name': 'display_name',
        'joined_at': 'joined_at',
        'name': 'name',
        'role': 'role'
    }

    def __init__(self, email=None, display_name=None, joined_at=None, name=None, role=None):  # noqa: E501
        """OrganizationUserResponse - a model defined in Swagger"""  # noqa: E501
        self._email = None
        self._display_name = None
        self._joined_at = None
        self._name = None
        self._role = None
        self.discriminator = None
        self.email = email
        self.display_name = display_name
        self.joined_at = joined_at
        self.name = name
        self.role = role

    @property
    def email(self):
        """Gets the email of this OrganizationUserResponse.  # noqa: E501

        The email address of the user  # noqa: E501

        :return: The email of this OrganizationUserResponse.  # noqa: E501
        :rtype: string
        """
        return self._email

    @email.setter
    def email(self, email):
        """Sets the email of this OrganizationUserResponse.

        The email address of the user  # noqa: E501

        :param email: The email of this OrganizationUserResponse.  # noqa: E501
        :type: string
        """
        if email is None:
            raise ValueError("Invalid value for `email`, must not be `None`")  # noqa: E501

        self._email = email

    @property
    def display_name(self):
        """Gets the display_name of this OrganizationUserResponse.  # noqa: E501

        The full name of the user. Might for example be first and last name  # noqa: E501

        :return: The display_name of this OrganizationUserResponse.  # noqa: E501
        :rtype: string
        """
        return self._display_name

    @display_name.setter
    def display_name(self, display_name):
        """Sets the display_name of this OrganizationUserResponse.

        The full name of the user. Might for example be first and last name  # noqa: E501

        :param display_name: The display_name of this OrganizationUserResponse.  # noqa: E501
        :type: string
        """
        if display_name is None:
            raise ValueError("Invalid value for `display_name`, must not be `None`")  # noqa: E501

        self._display_name = display_name

    @property
    def joined_at(self):
        """Gets the joined_at of this OrganizationUserResponse.  # noqa: E501

        The date when the user joined the organization  # noqa: E501

        :return: The joined_at of this OrganizationUserResponse.  # noqa: E501
        :rtype: string
        """
        return self._joined_at

    @joined_at.setter
    def joined_at(self, joined_at):
        """Sets the joined_at of this OrganizationUserResponse.

        The date when the user joined the organization  # noqa: E501

        :param joined_at: The joined_at of this OrganizationUserResponse.  # noqa: E501
        :type: string
        """
        if joined_at is None:
            raise ValueError("Invalid value for `joined_at`, must not be `None`")  # noqa: E501

        self._joined_at = joined_at

    @property
    def name(self):
        """Gets the name of this OrganizationUserResponse.  # noqa: E501

        The unique name that is used to identify the user.  # noqa: E501

        :return: The name of this OrganizationUserResponse.  # noqa: E501
        :rtype: string
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this OrganizationUserResponse.

        The unique name that is used to identify the user.  # noqa: E501

        :param name: The name of this OrganizationUserResponse.  # noqa: E501
        :type: string
        """
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def role(self):
        """Gets the role of this OrganizationUserResponse.  # noqa: E501

        The role the user has within the organization  # noqa: E501

        :return: The role of this OrganizationUserResponse.  # noqa: E501
        :rtype: string
        """
        return self._role

    @role.setter
    def role(self, role):
        """Sets the role of this OrganizationUserResponse.

        The role the user has within the organization  # noqa: E501

        :param role: The role of this OrganizationUserResponse.  # noqa: E501
        :type: string
        """
        if role is None:
            raise ValueError("Invalid value for `role`, must not be `None`")  # noqa: E501

        self._role = role

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, OrganizationUserResponse):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
