# coding: utf-8

"""
    App Center Client

    Microsoft Visual Studio App Center API  # noqa: E501

    OpenAPI spec version: preview
    Contact: benedetto.abbenanti@gmail.com
    Project Repository: https://github.com/b3nab/appcenter-sdks
"""

import pprint
import re  # noqa: F401

import six


class OverviewResponse(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    allowed enum values
    """
    East Asia = "East Asia"
    Southeast Asia = "Southeast Asia"
    Australia Central = "Australia Central"
    Australia Central 2 = "Australia Central 2"
    Australia East = "Australia East"
    Australia Southeast = "Australia Southeast"
    Brazil South = "Brazil South"
    Canada Central = "Canada Central"
    Canada East = "Canada East"
    Central India = "Central India"
    South India = "South India"
    West India = "West India"
    North Europe = "North Europe"
    West Europe = "West Europe"
    France Central = "France Central"
    France South = "France South"
    Germany Central = "Germany Central"
    Germany Northeast = "Germany Northeast"
    Japan East = "Japan East"
    Japan West = "Japan West"
    Korea Central = "Korea Central"
    Korea South = "Korea South"
    South Africa North = "South Africa North"
    South Africa West = "South Africa West"
    UK South = "UK South"
    UK West = "UK West"
    Central US = "Central US"
    East US = "East US"
    East US 2 = "East US 2"
    US Gov Arizona = "US Gov Arizona"
    US Gov Texas = "US Gov Texas"
    North Central US = "North Central US"
    South Central US = "South Central US"
    West US = "West US"
    West US 2 = "West US 2"
    West Central US = "West Central US"
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'database_location': 'string',
        'account_name': 'string',
        'database_id': 'string',
        'throughput': 'integer'
    }

    attribute_map = {
        'database_location': 'database_location',
        'account_name': 'account_name',
        'database_id': 'database_id',
        'throughput': 'throughput'
    }

    def __init__(self, database_location=None, account_name=None, database_id=None, throughput=None):  # noqa: E501
        """OverviewResponse - a model defined in Swagger"""  # noqa: E501
        self._database_location = None
        self._account_name = None
        self._database_id = None
        self._throughput = None
        self.discriminator = None
        if database_location is not None:
            self.database_location = database_location
        if account_name is not None:
            self.account_name = account_name
        if database_id is not None:
            self.database_id = database_id
        if throughput is not None:
            self.throughput = throughput

    @property
    def database_location(self):
        """Gets the database_location of this OverviewResponse.  # noqa: E501


        :return: The database_location of this OverviewResponse.  # noqa: E501
        :rtype: string
        """
        return self._database_location

    @database_location.setter
    def database_location(self, database_location):
        """Sets the database_location of this OverviewResponse.


        :param database_location: The database_location of this OverviewResponse.  # noqa: E501
        :type: string
        """
        allowed_values = [undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, ]  # noqa: E501

        self._database_location = database_location

    @property
    def account_name(self):
        """Gets the account_name of this OverviewResponse.  # noqa: E501


        :return: The account_name of this OverviewResponse.  # noqa: E501
        :rtype: string
        """
        return self._account_name

    @account_name.setter
    def account_name(self, account_name):
        """Sets the account_name of this OverviewResponse.


        :param account_name: The account_name of this OverviewResponse.  # noqa: E501
        :type: string
        """

        self._account_name = account_name

    @property
    def database_id(self):
        """Gets the database_id of this OverviewResponse.  # noqa: E501


        :return: The database_id of this OverviewResponse.  # noqa: E501
        :rtype: string
        """
        return self._database_id

    @database_id.setter
    def database_id(self, database_id):
        """Sets the database_id of this OverviewResponse.


        :param database_id: The database_id of this OverviewResponse.  # noqa: E501
        :type: string
        """

        self._database_id = database_id

    @property
    def throughput(self):
        """Gets the throughput of this OverviewResponse.  # noqa: E501


        :return: The throughput of this OverviewResponse.  # noqa: E501
        :rtype: integer
        """
        return self._throughput

    @throughput.setter
    def throughput(self, throughput):
        """Sets the throughput of this OverviewResponse.


        :param throughput: The throughput of this OverviewResponse.  # noqa: E501
        :type: integer
        """

        self._throughput = throughput

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, OverviewResponse):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
