# coding: utf-8

"""
    App Center Client

    Microsoft Visual Studio App Center API  # noqa: E501

    OpenAPI spec version: preview
    Contact: benedetto.abbenanti@gmail.com
    Project Repository: https://github.com/b3nab/appcenter-sdks
"""

import pprint
import re  # noqa: F401

import six


class PrivateSharedConnectionResponse(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    allowed enum values
    """
    apple = "apple"
    jira = "jira"
    googleplay = "googleplay"
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'string',
        'display_name': 'string',
        'service_type': 'string',
        'is_valid': 'boolean',
        'is2_f_a': 'boolean'
    }

    attribute_map = {
        'id': 'id',
        'display_name': 'display_name',
        'service_type': 'service_type',
        'is_valid': 'is_valid',
        'is2_f_a': 'is2_f_a'
    }

    def __init__(self, id=None, display_name=None, service_type=None, is_valid=None, is2_f_a=None):  # noqa: E501
        """PrivateSharedConnectionResponse - a model defined in Swagger"""  # noqa: E501
        self._id = None
        self._display_name = None
        self._service_type = None
        self._is_valid = None
        self._is2_f_a = None
        self.discriminator = None
        self.id = id
        if display_name is not None:
            self.display_name = display_name
        if service_type is not None:
            self.service_type = service_type
        if is_valid is not None:
            self.is_valid = is_valid
        if is2_f_a is not None:
            self.is2_f_a = is2_f_a

    @property
    def id(self):
        """Gets the id of this PrivateSharedConnectionResponse.  # noqa: E501

        id of the shared connection  # noqa: E501

        :return: The id of this PrivateSharedConnectionResponse.  # noqa: E501
        :rtype: string
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this PrivateSharedConnectionResponse.

        id of the shared connection  # noqa: E501

        :param id: The id of this PrivateSharedConnectionResponse.  # noqa: E501
        :type: string
        """
        if id is None:
            raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def display_name(self):
        """Gets the display_name of this PrivateSharedConnectionResponse.  # noqa: E501

        display name of shared connection  # noqa: E501

        :return: The display_name of this PrivateSharedConnectionResponse.  # noqa: E501
        :rtype: string
        """
        return self._display_name

    @display_name.setter
    def display_name(self, display_name):
        """Sets the display_name of this PrivateSharedConnectionResponse.

        display name of shared connection  # noqa: E501

        :param display_name: The display_name of this PrivateSharedConnectionResponse.  # noqa: E501
        :type: string
        """

        self._display_name = display_name

    @property
    def service_type(self):
        """Gets the service_type of this PrivateSharedConnectionResponse.  # noqa: E501

        service type of shared connection can be apple|googleplay|jira|applecertificate  # noqa: E501

        :return: The service_type of this PrivateSharedConnectionResponse.  # noqa: E501
        :rtype: string
        """
        return self._service_type

    @service_type.setter
    def service_type(self, service_type):
        """Sets the service_type of this PrivateSharedConnectionResponse.

        service type of shared connection can be apple|googleplay|jira|applecertificate  # noqa: E501

        :param service_type: The service_type of this PrivateSharedConnectionResponse.  # noqa: E501
        :type: string
        """
        allowed_values = [undefined, undefined, undefined, ]  # noqa: E501

        self._service_type = service_type

    @property
    def is_valid(self):
        """Gets the is_valid of this PrivateSharedConnectionResponse.  # noqa: E501

        whether the credentials are valid or not  # noqa: E501

        :return: The is_valid of this PrivateSharedConnectionResponse.  # noqa: E501
        :rtype: boolean
        """
        return self._is_valid

    @is_valid.setter
    def is_valid(self, is_valid):
        """Sets the is_valid of this PrivateSharedConnectionResponse.

        whether the credentials are valid or not  # noqa: E501

        :param is_valid: The is_valid of this PrivateSharedConnectionResponse.  # noqa: E501
        :type: boolean
        """

        self._is_valid = is_valid

    @property
    def is2_f_a(self):
        """Gets the is2_f_a of this PrivateSharedConnectionResponse.  # noqa: E501

        if the account is a 2FA account or not  # noqa: E501

        :return: The is2_f_a of this PrivateSharedConnectionResponse.  # noqa: E501
        :rtype: boolean
        """
        return self._is2_f_a

    @is2_f_a.setter
    def is2_f_a(self, is2_f_a):
        """Sets the is2_f_a of this PrivateSharedConnectionResponse.

        if the account is a 2FA account or not  # noqa: E501

        :param is2_f_a: The is2_f_a of this PrivateSharedConnectionResponse.  # noqa: E501
        :type: boolean
        """

        self._is2_f_a = is2_f_a

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PrivateSharedConnectionResponse):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
