# coding: utf-8

"""
    App Center Client

    Microsoft Visual Studio App Center API  # noqa: E501

    OpenAPI spec version: preview
    Contact: benedetto.abbenanti@gmail.com
    Project Repository: https://github.com/b3nab/appcenter-sdks
"""

import pprint
import re  # noqa: F401

import six


class ProvisioningProfileFile(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'file_name': 'string',
        'file_id': 'string',
        'upload_id': 'string',
        'target_bundle_identifier': 'string'
    }

    attribute_map = {
        'file_name': 'file_name',
        'file_id': 'file_id',
        'upload_id': 'upload_id',
        'target_bundle_identifier': 'target_bundle_identifier'
    }

    def __init__(self, file_name=None, file_id=None, upload_id=None, target_bundle_identifier=None):  # noqa: E501
        """ProvisioningProfileFile - a model defined in Swagger"""  # noqa: E501
        self._file_name = None
        self._file_id = None
        self._upload_id = None
        self._target_bundle_identifier = None
        self.discriminator = None
        if file_name is not None:
            self.file_name = file_name
        if file_id is not None:
            self.file_id = file_id
        if upload_id is not None:
            self.upload_id = upload_id
        if target_bundle_identifier is not None:
            self.target_bundle_identifier = target_bundle_identifier

    @property
    def file_name(self):
        """Gets the file_name of this ProvisioningProfileFile.  # noqa: E501

        Name of uploaded provisioning profile  # noqa: E501

        :return: The file_name of this ProvisioningProfileFile.  # noqa: E501
        :rtype: string
        """
        return self._file_name

    @file_name.setter
    def file_name(self, file_name):
        """Sets the file_name of this ProvisioningProfileFile.

        Name of uploaded provisioning profile  # noqa: E501

        :param file_name: The file_name of this ProvisioningProfileFile.  # noqa: E501
        :type: string
        """

        self._file_name = file_name

    @property
    def file_id(self):
        """Gets the file_id of this ProvisioningProfileFile.  # noqa: E501

        File id from secure file storage  # noqa: E501

        :return: The file_id of this ProvisioningProfileFile.  # noqa: E501
        :rtype: string
        """
        return self._file_id

    @file_id.setter
    def file_id(self, file_id):
        """Sets the file_id of this ProvisioningProfileFile.

        File id from secure file storage  # noqa: E501

        :param file_id: The file_id of this ProvisioningProfileFile.  # noqa: E501
        :type: string
        """

        self._file_id = file_id

    @property
    def upload_id(self):
        """Gets the upload_id of this ProvisioningProfileFile.  # noqa: E501

        Upload id to App Center File Upload Store  # noqa: E501

        :return: The upload_id of this ProvisioningProfileFile.  # noqa: E501
        :rtype: string
        """
        return self._upload_id

    @upload_id.setter
    def upload_id(self, upload_id):
        """Sets the upload_id of this ProvisioningProfileFile.

        Upload id to App Center File Upload Store  # noqa: E501

        :param upload_id: The upload_id of this ProvisioningProfileFile.  # noqa: E501
        :type: string
        """

        self._upload_id = upload_id

    @property
    def target_bundle_identifier(self):
        """Gets the target_bundle_identifier of this ProvisioningProfileFile.  # noqa: E501

        Target the provisioning profile is used to sign  # noqa: E501

        :return: The target_bundle_identifier of this ProvisioningProfileFile.  # noqa: E501
        :rtype: string
        """
        return self._target_bundle_identifier

    @target_bundle_identifier.setter
    def target_bundle_identifier(self, target_bundle_identifier):
        """Sets the target_bundle_identifier of this ProvisioningProfileFile.

        Target the provisioning profile is used to sign  # noqa: E501

        :param target_bundle_identifier: The target_bundle_identifier of this ProvisioningProfileFile.  # noqa: E501
        :type: string
        """

        self._target_bundle_identifier = target_bundle_identifier

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ProvisioningProfileFile):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
