# coding: utf-8

"""
    App Center Client

    Microsoft Visual Studio App Center API  # noqa: E501

    OpenAPI spec version: preview
    Contact: benedetto.abbenanti@gmail.com
    Project Repository: https://github.com/b3nab/appcenter-sdks
"""

import pprint
import re  # noqa: F401

import six


class PublishDevicesResponse(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'profile_file_name': 'string',
        'profiles_zip_base64': 'string'
    }

    attribute_map = {
        'profile_file_name': 'profile_file_name',
        'profiles_zip_base64': 'profiles_zip_base64'
    }

    def __init__(self, profile_file_name=None, profiles_zip_base64=None):  # noqa: E501
        """PublishDevicesResponse - a model defined in Swagger"""  # noqa: E501
        self._profile_file_name = None
        self._profiles_zip_base64 = None
        self.discriminator = None
        if profile_file_name is not None:
            self.profile_file_name = profile_file_name
        self.profiles_zip_base64 = profiles_zip_base64

    @property
    def profile_file_name(self):
        """Gets the profile_file_name of this PublishDevicesResponse.  # noqa: E501

        The file name for the provisioning profile.  # noqa: E501

        :return: The profile_file_name of this PublishDevicesResponse.  # noqa: E501
        :rtype: string
        """
        return self._profile_file_name

    @profile_file_name.setter
    def profile_file_name(self, profile_file_name):
        """Sets the profile_file_name of this PublishDevicesResponse.

        The file name for the provisioning profile.  # noqa: E501

        :param profile_file_name: The profile_file_name of this PublishDevicesResponse.  # noqa: E501
        :type: string
        """

        self._profile_file_name = profile_file_name

    @property
    def profiles_zip_base64(self):
        """Gets the profiles_zip_base64 of this PublishDevicesResponse.  # noqa: E501

        The updated provisioning profiles zip base64 encoded.  # noqa: E501

        :return: The profiles_zip_base64 of this PublishDevicesResponse.  # noqa: E501
        :rtype: string
        """
        return self._profiles_zip_base64

    @profiles_zip_base64.setter
    def profiles_zip_base64(self, profiles_zip_base64):
        """Sets the profiles_zip_base64 of this PublishDevicesResponse.

        The updated provisioning profiles zip base64 encoded.  # noqa: E501

        :param profiles_zip_base64: The profiles_zip_base64 of this PublishDevicesResponse.  # noqa: E501
        :type: string
        """
        if profiles_zip_base64 is None:
            raise ValueError("Invalid value for `profiles_zip_base64`, must not be `None`")  # noqa: E501

        self._profiles_zip_base64 = profiles_zip_base64

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PublishDevicesResponse):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
