# coding: utf-8

"""
    App Center Client

    Microsoft Visual Studio App Center API  # noqa: E501

    OpenAPI spec version: preview
    Contact: benedetto.abbenanti@gmail.com
    Project Repository: https://github.com/b3nab/appcenter-sdks
"""

import pprint
import re  # noqa: F401

import six


class SessionDurationsDistribution(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'distribution': 'array',
        'previous_average_duration': 'string',
        'average_duration': 'string'
    }

    attribute_map = {
        'distribution': 'distribution',
        'previous_average_duration': 'previous_average_duration',
        'average_duration': 'average_duration'
    }

    def __init__(self, distribution=None, previous_average_duration=None, average_duration=None):  # noqa: E501
        """SessionDurationsDistribution - a model defined in Swagger"""  # noqa: E501
        self._distribution = None
        self._previous_average_duration = None
        self._average_duration = None
        self.discriminator = None
        if distribution is not None:
            self.distribution = distribution
        if previous_average_duration is not None:
            self.previous_average_duration = previous_average_duration
        if average_duration is not None:
            self.average_duration = average_duration

    @property
    def distribution(self):
        """Gets the distribution of this SessionDurationsDistribution.  # noqa: E501

        the count of sessions in these buckets  # noqa: E501

        :return: The distribution of this SessionDurationsDistribution.  # noqa: E501
        :rtype: array
        """
        return self._distribution

    @distribution.setter
    def distribution(self, distribution):
        """Sets the distribution of this SessionDurationsDistribution.

        the count of sessions in these buckets  # noqa: E501

        :param distribution: The distribution of this SessionDurationsDistribution.  # noqa: E501
        :type: array
        """

        self._distribution = distribution

    @property
    def previous_average_duration(self):
        """Gets the previous_average_duration of this SessionDurationsDistribution.  # noqa: E501

        the previous average session duration for previous time range  # noqa: E501

        :return: The previous_average_duration of this SessionDurationsDistribution.  # noqa: E501
        :rtype: string
        """
        return self._previous_average_duration

    @previous_average_duration.setter
    def previous_average_duration(self, previous_average_duration):
        """Sets the previous_average_duration of this SessionDurationsDistribution.

        the previous average session duration for previous time range  # noqa: E501

        :param previous_average_duration: The previous_average_duration of this SessionDurationsDistribution.  # noqa: E501
        :type: string
        """

        self._previous_average_duration = previous_average_duration

    @property
    def average_duration(self):
        """Gets the average_duration of this SessionDurationsDistribution.  # noqa: E501

        the average session duration for current time range  # noqa: E501

        :return: The average_duration of this SessionDurationsDistribution.  # noqa: E501
        :rtype: string
        """
        return self._average_duration

    @average_duration.setter
    def average_duration(self, average_duration):
        """Sets the average_duration of this SessionDurationsDistribution.

        the average session duration for current time range  # noqa: E501

        :param average_duration: The average_duration of this SessionDurationsDistribution.  # noqa: E501
        :type: string
        """

        self._average_duration = average_duration

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SessionDurationsDistribution):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
