# coding: utf-8

"""
    App Center Client

    Microsoft Visual Studio App Center API  # noqa: E501

    OpenAPI spec version: preview
    Contact: benedetto.abbenanti@gmail.com
    Project Repository: https://github.com/b3nab/appcenter-sdks
"""

import pprint
import re  # noqa: F401

import six


class SessionsPerDevice(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'average_sessions_per_user': 'number',
        'previous_average_sessions_per_user': 'number',
        'total_count': 'integer',
        'previous_total_count': 'integer',
        'sessions_per_user': 'array'
    }

    attribute_map = {
        'average_sessions_per_user': 'average_sessions_per_user',
        'previous_average_sessions_per_user': 'previous_average_sessions_per_user',
        'total_count': 'total_count',
        'previous_total_count': 'previous_total_count',
        'sessions_per_user': 'sessions_per_user'
    }

    def __init__(self, average_sessions_per_user=None, previous_average_sessions_per_user=None, total_count=None, previous_total_count=None, sessions_per_user=None):  # noqa: E501
        """SessionsPerDevice - a model defined in Swagger"""  # noqa: E501
        self._average_sessions_per_user = None
        self._previous_average_sessions_per_user = None
        self._total_count = None
        self._previous_total_count = None
        self._sessions_per_user = None
        self.discriminator = None
        if average_sessions_per_user is not None:
            self.average_sessions_per_user = average_sessions_per_user
        if previous_average_sessions_per_user is not None:
            self.previous_average_sessions_per_user = previous_average_sessions_per_user
        if total_count is not None:
            self.total_count = total_count
        if previous_total_count is not None:
            self.previous_total_count = previous_total_count
        if sessions_per_user is not None:
            self.sessions_per_user = sessions_per_user

    @property
    def average_sessions_per_user(self):
        """Gets the average_sessions_per_user of this SessionsPerDevice.  # noqa: E501

        average seesion per user  # noqa: E501

        :return: The average_sessions_per_user of this SessionsPerDevice.  # noqa: E501
        :rtype: number
        """
        return self._average_sessions_per_user

    @average_sessions_per_user.setter
    def average_sessions_per_user(self, average_sessions_per_user):
        """Sets the average_sessions_per_user of this SessionsPerDevice.

        average seesion per user  # noqa: E501

        :param average_sessions_per_user: The average_sessions_per_user of this SessionsPerDevice.  # noqa: E501
        :type: number
        """

        self._average_sessions_per_user = average_sessions_per_user

    @property
    def previous_average_sessions_per_user(self):
        """Gets the previous_average_sessions_per_user of this SessionsPerDevice.  # noqa: E501

        previous average session per user  # noqa: E501

        :return: The previous_average_sessions_per_user of this SessionsPerDevice.  # noqa: E501
        :rtype: number
        """
        return self._previous_average_sessions_per_user

    @previous_average_sessions_per_user.setter
    def previous_average_sessions_per_user(self, previous_average_sessions_per_user):
        """Sets the previous_average_sessions_per_user of this SessionsPerDevice.

        previous average session per user  # noqa: E501

        :param previous_average_sessions_per_user: The previous_average_sessions_per_user of this SessionsPerDevice.  # noqa: E501
        :type: number
        """

        self._previous_average_sessions_per_user = previous_average_sessions_per_user

    @property
    def total_count(self):
        """Gets the total_count of this SessionsPerDevice.  # noqa: E501

        total session per device count  # noqa: E501

        :return: The total_count of this SessionsPerDevice.  # noqa: E501
        :rtype: integer
        """
        return self._total_count

    @total_count.setter
    def total_count(self, total_count):
        """Sets the total_count of this SessionsPerDevice.

        total session per device count  # noqa: E501

        :param total_count: The total_count of this SessionsPerDevice.  # noqa: E501
        :type: integer
        """

        self._total_count = total_count

    @property
    def previous_total_count(self):
        """Gets the previous_total_count of this SessionsPerDevice.  # noqa: E501

        previous total count  # noqa: E501

        :return: The previous_total_count of this SessionsPerDevice.  # noqa: E501
        :rtype: integer
        """
        return self._previous_total_count

    @previous_total_count.setter
    def previous_total_count(self, previous_total_count):
        """Sets the previous_total_count of this SessionsPerDevice.

        previous total count  # noqa: E501

        :param previous_total_count: The previous_total_count of this SessionsPerDevice.  # noqa: E501
        :type: integer
        """

        self._previous_total_count = previous_total_count

    @property
    def sessions_per_user(self):
        """Gets the sessions_per_user of this SessionsPerDevice.  # noqa: E501

        the session count for each interval per device  # noqa: E501

        :return: The sessions_per_user of this SessionsPerDevice.  # noqa: E501
        :rtype: array
        """
        return self._sessions_per_user

    @sessions_per_user.setter
    def sessions_per_user(self, sessions_per_user):
        """Sets the sessions_per_user of this SessionsPerDevice.

        the session count for each interval per device  # noqa: E501

        :param sessions_per_user: The sessions_per_user of this SessionsPerDevice.  # noqa: E501
        :type: array
        """

        self._sessions_per_user = sessions_per_user

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SessionsPerDevice):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
