# coding: utf-8

"""
    App Center Client

    Microsoft Visual Studio App Center API  # noqa: E501

    OpenAPI spec version: preview
    Contact: benedetto.abbenanti@gmail.com
    Project Repository: https://github.com/b3nab/appcenter-sdks
"""

import pprint
import re  # noqa: F401

import six


class SharedConnectionRequest(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    allowed enum values
    """
    credentials = "credentials"
    certificate = "certificate"
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'display_name': 'string',
        'service_type': 'string',
        'credential_type': 'string'
    }

    attribute_map = {
        'display_name': 'display_name',
        'service_type': 'service_type',
        'credential_type': 'credential_type'
    }

    def __init__(self, display_name=None, service_type=None, credential_type=credentials):  # noqa: E501
        """SharedConnectionRequest - a model defined in Swagger"""  # noqa: E501
        self._display_name = None
        self._service_type = None
        self._credential_type = None
        self.discriminator = None
        if display_name is not None:
            self.display_name = display_name
        if service_type is not None:
            self.service_type = service_type
        if credential_type is not None:
            self.credential_type = credential_type

    @property
    def display_name(self):
        """Gets the display_name of this SharedConnectionRequest.  # noqa: E501

        display name of shared connection  # noqa: E501

        :return: The display_name of this SharedConnectionRequest.  # noqa: E501
        :rtype: string
        """
        return self._display_name

    @display_name.setter
    def display_name(self, display_name):
        """Sets the display_name of this SharedConnectionRequest.

        display name of shared connection  # noqa: E501

        :param display_name: The display_name of this SharedConnectionRequest.  # noqa: E501
        :type: string
        """

        self._display_name = display_name

    @property
    def service_type(self):
        """Gets the service_type of this SharedConnectionRequest.  # noqa: E501

        service type of shared connection can be apple|googleplay|jira|applecertificate  # noqa: E501

        :return: The service_type of this SharedConnectionRequest.  # noqa: E501
        :rtype: string
        """
        return self._service_type

    @service_type.setter
    def service_type(self, service_type):
        """Sets the service_type of this SharedConnectionRequest.

        service type of shared connection can be apple|googleplay|jira|applecertificate  # noqa: E501

        :param service_type: The service_type of this SharedConnectionRequest.  # noqa: E501
        :type: string
        """
        allowed_values = [undefined, undefined, ]  # noqa: E501

        self._service_type = service_type

    @property
    def credential_type(self):
        """Gets the credential_type of this SharedConnectionRequest.  # noqa: E501

        credential type of the shared connection. Values can be credentials|certificate  # noqa: E501

        :return: The credential_type of this SharedConnectionRequest.  # noqa: E501
        :rtype: string
        """
        return self._credential_type

    @credential_type.setter
    def credential_type(self, credential_type):
        """Sets the credential_type of this SharedConnectionRequest.

        credential type of the shared connection. Values can be credentials|certificate  # noqa: E501

        :param credential_type: The credential_type of this SharedConnectionRequest.  # noqa: E501
        :type: string
        """
        allowed_values = [undefinedundefined]  # noqa: E501

        self._credential_type = credential_type

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SharedConnectionRequest):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
