# coding: utf-8

"""
    App Center Client

    Microsoft Visual Studio App Center API  # noqa: E501

    OpenAPI spec version: preview
    Contact: benedetto.abbenanti@gmail.com
    Project Repository: https://github.com/b3nab/appcenter-sdks
"""

import pprint
import re  # noqa: F401

import six


class UWPSolution(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'path': 'string',
        'configurations': 'array'
    }

    attribute_map = {
        'path': 'path',
        'configurations': 'configurations'
    }

    def __init__(self, path=None, configurations=None):  # noqa: E501
        """UWPSolution - a model defined in Swagger"""  # noqa: E501
        self._path = None
        self._configurations = None
        self.discriminator = None
        self.path = path
        self.configurations = configurations

    @property
    def path(self):
        """Gets the path of this UWPSolution.  # noqa: E501

        The path to the UWP solution  # noqa: E501

        :return: The path of this UWPSolution.  # noqa: E501
        :rtype: string
        """
        return self._path

    @path.setter
    def path(self, path):
        """Sets the path of this UWPSolution.

        The path to the UWP solution  # noqa: E501

        :param path: The path of this UWPSolution.  # noqa: E501
        :type: string
        """
        if path is None:
            raise ValueError("Invalid value for `path`, must not be `None`")  # noqa: E501

        self._path = path

    @property
    def configurations(self):
        """Gets the configurations of this UWPSolution.  # noqa: E501

        The possible configurations detected for the UWP solution  # noqa: E501

        :return: The configurations of this UWPSolution.  # noqa: E501
        :rtype: array
        """
        return self._configurations

    @configurations.setter
    def configurations(self, configurations):
        """Sets the configurations of this UWPSolution.

        The possible configurations detected for the UWP solution  # noqa: E501

        :param configurations: The configurations of this UWPSolution.  # noqa: E501
        :type: array
        """
        if configurations is None:
            raise ValueError("Invalid value for `configurations`, must not be `None`")  # noqa: E501

        self._configurations = configurations

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, UWPSolution):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
