# coding: utf-8

"""
    App Center Client

    Microsoft Visual Studio App Center API  # noqa: E501

    OpenAPI spec version: preview
    Contact: benedetto.abbenanti@gmail.com
    Project Repository: https://github.com/b3nab/appcenter-sdks
"""

import pprint
import re  # noqa: F401

import six


class UserAuthResponse(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    allowed enum values
    """
    appcenter = "appcenter"
    hockeyapp = "hockeyapp"
    codepush = "codepush"
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'string',
        'display_name': 'string',
        'email': 'string',
        'external_provider': 'string',
        'external_user_id': 'string',
        'name': 'string',
        'origin': 'string'
    }

    attribute_map = {
        'id': 'id',
        'display_name': 'display_name',
        'email': 'email',
        'external_provider': 'external_provider',
        'external_user_id': 'external_user_id',
        'name': 'name',
        'origin': 'origin'
    }

    def __init__(self, id=None, display_name=None, email=None, external_provider=None, external_user_id=None, name=None, origin=None):  # noqa: E501
        """UserAuthResponse - a model defined in Swagger"""  # noqa: E501
        self._id = None
        self._display_name = None
        self._email = None
        self._external_provider = None
        self._external_user_id = None
        self._name = None
        self._origin = None
        self.discriminator = None
        self.id = id
        self.display_name = display_name
        self.email = email
        if external_provider is not None:
            self.external_provider = external_provider
        if external_user_id is not None:
            self.external_user_id = external_user_id
        self.name = name
        self.origin = origin

    @property
    def id(self):
        """Gets the id of this UserAuthResponse.  # noqa: E501

        The unique id (UUID) of the user  # noqa: E501

        :return: The id of this UserAuthResponse.  # noqa: E501
        :rtype: string
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this UserAuthResponse.

        The unique id (UUID) of the user  # noqa: E501

        :param id: The id of this UserAuthResponse.  # noqa: E501
        :type: string
        """
        if id is None:
            raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def display_name(self):
        """Gets the display_name of this UserAuthResponse.  # noqa: E501

        The full name of the user. Might for example be first and last name  # noqa: E501

        :return: The display_name of this UserAuthResponse.  # noqa: E501
        :rtype: string
        """
        return self._display_name

    @display_name.setter
    def display_name(self, display_name):
        """Sets the display_name of this UserAuthResponse.

        The full name of the user. Might for example be first and last name  # noqa: E501

        :param display_name: The display_name of this UserAuthResponse.  # noqa: E501
        :type: string
        """
        if display_name is None:
            raise ValueError("Invalid value for `display_name`, must not be `None`")  # noqa: E501

        self._display_name = display_name

    @property
    def email(self):
        """Gets the email of this UserAuthResponse.  # noqa: E501

        The email address of the user  # noqa: E501

        :return: The email of this UserAuthResponse.  # noqa: E501
        :rtype: string
        """
        return self._email

    @email.setter
    def email(self, email):
        """Sets the email of this UserAuthResponse.

        The email address of the user  # noqa: E501

        :param email: The email of this UserAuthResponse.  # noqa: E501
        :type: string
        """
        if email is None:
            raise ValueError("Invalid value for `email`, must not be `None`")  # noqa: E501

        self._email = email

    @property
    def external_provider(self):
        """Gets the external_provider of this UserAuthResponse.  # noqa: E501

        The name of the external auth provider  # noqa: E501

        :return: The external_provider of this UserAuthResponse.  # noqa: E501
        :rtype: string
        """
        return self._external_provider

    @external_provider.setter
    def external_provider(self, external_provider):
        """Sets the external_provider of this UserAuthResponse.

        The name of the external auth provider  # noqa: E501

        :param external_provider: The external_provider of this UserAuthResponse.  # noqa: E501
        :type: string
        """

        self._external_provider = external_provider

    @property
    def external_user_id(self):
        """Gets the external_user_id of this UserAuthResponse.  # noqa: E501

        The user ID given by the external provider  # noqa: E501

        :return: The external_user_id of this UserAuthResponse.  # noqa: E501
        :rtype: string
        """
        return self._external_user_id

    @external_user_id.setter
    def external_user_id(self, external_user_id):
        """Sets the external_user_id of this UserAuthResponse.

        The user ID given by the external provider  # noqa: E501

        :param external_user_id: The external_user_id of this UserAuthResponse.  # noqa: E501
        :type: string
        """

        self._external_user_id = external_user_id

    @property
    def name(self):
        """Gets the name of this UserAuthResponse.  # noqa: E501

        The unique name that is used to identify the user  # noqa: E501

        :return: The name of this UserAuthResponse.  # noqa: E501
        :rtype: string
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this UserAuthResponse.

        The unique name that is used to identify the user  # noqa: E501

        :param name: The name of this UserAuthResponse.  # noqa: E501
        :type: string
        """
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def origin(self):
        """Gets the origin of this UserAuthResponse.  # noqa: E501

        The creation origin of this user  # noqa: E501

        :return: The origin of this UserAuthResponse.  # noqa: E501
        :rtype: string
        """
        return self._origin

    @origin.setter
    def origin(self, origin):
        """Sets the origin of this UserAuthResponse.

        The creation origin of this user  # noqa: E501

        :param origin: The origin of this UserAuthResponse.  # noqa: E501
        :type: string
        """
        if origin is None:
            raise ValueError("Invalid value for `origin`, must not be `None`")  # noqa: E501
        allowed_values = [undefinedundefinedundefined]  # noqa: E501

        self._origin = origin

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, UserAuthResponse):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
