# coding: utf-8

"""
    App Center Client

    Microsoft Visual Studio App Center API  # noqa: E501

    OpenAPI spec version: preview
    Contact: benedetto.abbenanti@gmail.com
    Project Repository: https://github.com/b3nab/appcenter-sdks
"""

import pprint
import re  # noqa: F401

import six


class UserDataResponse(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'string',
        'display_name': 'string',
        'name': 'string',
        'avatar_url': 'string'
    }

    attribute_map = {
        'id': 'id',
        'display_name': 'display_name',
        'name': 'name',
        'avatar_url': 'avatar_url'
    }

    def __init__(self, id=None, display_name=None, name=None, avatar_url=None):  # noqa: E501
        """UserDataResponse - a model defined in Swagger"""  # noqa: E501
        self._id = None
        self._display_name = None
        self._name = None
        self._avatar_url = None
        self.discriminator = None
        if id is not None:
            self.id = id
        if display_name is not None:
            self.display_name = display_name
        if name is not None:
            self.name = name
        if avatar_url is not None:
            self.avatar_url = avatar_url

    @property
    def id(self):
        """Gets the id of this UserDataResponse.  # noqa: E501

        The unique id (UUID) of the user  # noqa: E501

        :return: The id of this UserDataResponse.  # noqa: E501
        :rtype: string
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this UserDataResponse.

        The unique id (UUID) of the user  # noqa: E501

        :param id: The id of this UserDataResponse.  # noqa: E501
        :type: string
        """

        self._id = id

    @property
    def display_name(self):
        """Gets the display_name of this UserDataResponse.  # noqa: E501

        The display name of the user  # noqa: E501

        :return: The display_name of this UserDataResponse.  # noqa: E501
        :rtype: string
        """
        return self._display_name

    @display_name.setter
    def display_name(self, display_name):
        """Sets the display_name of this UserDataResponse.

        The display name of the user  # noqa: E501

        :param display_name: The display_name of this UserDataResponse.  # noqa: E501
        :type: string
        """

        self._display_name = display_name

    @property
    def name(self):
        """Gets the name of this UserDataResponse.  # noqa: E501

        The name of the user  # noqa: E501

        :return: The name of this UserDataResponse.  # noqa: E501
        :rtype: string
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this UserDataResponse.

        The name of the user  # noqa: E501

        :param name: The name of this UserDataResponse.  # noqa: E501
        :type: string
        """

        self._name = name

    @property
    def avatar_url(self):
        """Gets the avatar_url of this UserDataResponse.  # noqa: E501

        The url at which the user's avatar can be reached  # noqa: E501

        :return: The avatar_url of this UserDataResponse.  # noqa: E501
        :rtype: string
        """
        return self._avatar_url

    @avatar_url.setter
    def avatar_url(self, avatar_url):
        """Sets the avatar_url of this UserDataResponse.

        The url at which the user's avatar can be reached  # noqa: E501

        :param avatar_url: The avatar_url of this UserDataResponse.  # noqa: E501
        :type: string
        """

        self._avatar_url = avatar_url

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, UserDataResponse):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
