# coding: utf-8

"""
    App Center Client

    Microsoft Visual Studio App Center API  # noqa: E501

    OpenAPI spec version: preview
    Contact: benedetto.abbenanti@gmail.com
    Project Repository: https://github.com/b3nab/appcenter-sdks
"""

import pprint
import re  # noqa: F401

import six


class UserProfileResponse(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    allowed enum values
    """
    appcenter = "appcenter"
    hockeyapp = "hockeyapp"
    codepush = "codepush"
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'string',
        'avatar_url': 'string',
        'can_change_password': 'boolean',
        'display_name': 'string',
        'email': 'string',
        'name': 'string',
        'permissions': 'array',
        'origin': 'string'
    }

    attribute_map = {
        'id': 'id',
        'avatar_url': 'avatar_url',
        'can_change_password': 'can_change_password',
        'display_name': 'display_name',
        'email': 'email',
        'name': 'name',
        'permissions': 'permissions',
        'origin': 'origin'
    }

    def __init__(self, id=None, avatar_url=None, can_change_password=None, display_name=None, email=None, name=None, permissions=None, origin=None):  # noqa: E501
        """UserProfileResponse - a model defined in Swagger"""  # noqa: E501
        self._id = None
        self._avatar_url = None
        self._can_change_password = None
        self._display_name = None
        self._email = None
        self._name = None
        self._permissions = None
        self._origin = None
        self.discriminator = None
        self.id = id
        if avatar_url is not None:
            self.avatar_url = avatar_url
        if can_change_password is not None:
            self.can_change_password = can_change_password
        self.display_name = display_name
        self.email = email
        self.name = name
        if permissions is not None:
            self.permissions = permissions
        self.origin = origin

    @property
    def id(self):
        """Gets the id of this UserProfileResponse.  # noqa: E501

        The unique id (UUID) of the user  # noqa: E501

        :return: The id of this UserProfileResponse.  # noqa: E501
        :rtype: string
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this UserProfileResponse.

        The unique id (UUID) of the user  # noqa: E501

        :param id: The id of this UserProfileResponse.  # noqa: E501
        :type: string
        """
        if id is None:
            raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def avatar_url(self):
        """Gets the avatar_url of this UserProfileResponse.  # noqa: E501

        The avatar URL of the user  # noqa: E501

        :return: The avatar_url of this UserProfileResponse.  # noqa: E501
        :rtype: string
        """
        return self._avatar_url

    @avatar_url.setter
    def avatar_url(self, avatar_url):
        """Sets the avatar_url of this UserProfileResponse.

        The avatar URL of the user  # noqa: E501

        :param avatar_url: The avatar_url of this UserProfileResponse.  # noqa: E501
        :type: string
        """

        self._avatar_url = avatar_url

    @property
    def can_change_password(self):
        """Gets the can_change_password of this UserProfileResponse.  # noqa: E501

        User is required to send an old password in order to change the password.  # noqa: E501

        :return: The can_change_password of this UserProfileResponse.  # noqa: E501
        :rtype: boolean
        """
        return self._can_change_password

    @can_change_password.setter
    def can_change_password(self, can_change_password):
        """Sets the can_change_password of this UserProfileResponse.

        User is required to send an old password in order to change the password.  # noqa: E501

        :param can_change_password: The can_change_password of this UserProfileResponse.  # noqa: E501
        :type: boolean
        """

        self._can_change_password = can_change_password

    @property
    def display_name(self):
        """Gets the display_name of this UserProfileResponse.  # noqa: E501

        The full name of the user. Might for example be first and last name  # noqa: E501

        :return: The display_name of this UserProfileResponse.  # noqa: E501
        :rtype: string
        """
        return self._display_name

    @display_name.setter
    def display_name(self, display_name):
        """Sets the display_name of this UserProfileResponse.

        The full name of the user. Might for example be first and last name  # noqa: E501

        :param display_name: The display_name of this UserProfileResponse.  # noqa: E501
        :type: string
        """
        if display_name is None:
            raise ValueError("Invalid value for `display_name`, must not be `None`")  # noqa: E501

        self._display_name = display_name

    @property
    def email(self):
        """Gets the email of this UserProfileResponse.  # noqa: E501

        The email address of the user  # noqa: E501

        :return: The email of this UserProfileResponse.  # noqa: E501
        :rtype: string
        """
        return self._email

    @email.setter
    def email(self, email):
        """Sets the email of this UserProfileResponse.

        The email address of the user  # noqa: E501

        :param email: The email of this UserProfileResponse.  # noqa: E501
        :type: string
        """
        if email is None:
            raise ValueError("Invalid value for `email`, must not be `None`")  # noqa: E501

        self._email = email

    @property
    def name(self):
        """Gets the name of this UserProfileResponse.  # noqa: E501

        The unique name that is used to identify the user.  # noqa: E501

        :return: The name of this UserProfileResponse.  # noqa: E501
        :rtype: string
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this UserProfileResponse.

        The unique name that is used to identify the user.  # noqa: E501

        :param name: The name of this UserProfileResponse.  # noqa: E501
        :type: string
        """
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def permissions(self):
        """Gets the permissions of this UserProfileResponse.  # noqa: E501

        The permissions the user has for the app  # noqa: E501

        :return: The permissions of this UserProfileResponse.  # noqa: E501
        :rtype: array
        """
        return self._permissions

    @permissions.setter
    def permissions(self, permissions):
        """Sets the permissions of this UserProfileResponse.

        The permissions the user has for the app  # noqa: E501

        :param permissions: The permissions of this UserProfileResponse.  # noqa: E501
        :type: array
        """

        self._permissions = permissions

    @property
    def origin(self):
        """Gets the origin of this UserProfileResponse.  # noqa: E501

        The creation origin of this user  # noqa: E501

        :return: The origin of this UserProfileResponse.  # noqa: E501
        :rtype: string
        """
        return self._origin

    @origin.setter
    def origin(self, origin):
        """Sets the origin of this UserProfileResponse.

        The creation origin of this user  # noqa: E501

        :param origin: The origin of this UserProfileResponse.  # noqa: E501
        :type: string
        """
        if origin is None:
            raise ValueError("Invalid value for `origin`, must not be `None`")  # noqa: E501
        allowed_values = [undefinedundefinedundefined]  # noqa: E501

        self._origin = origin

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, UserProfileResponse):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
