# coding: utf-8

# flake8: noqa
"""
    App Center Client

    Microsoft Visual Studio App Center API  # noqa: E501

    OpenAPI spec version: preview
    Contact: benedetto.abbenanti@gmail.com
    Project Repository: https://github.com/b3nab/appcenter-sdks
"""

from __future__ import absolute_import

# import models into model package
from GetInAppUpdateTokenResponse.clsGetInAppUpdateTokenResponse import GetInAppUpdateTokenResponse
from ApiTokensCreateResponse.clsApiTokensCreateResponse import ApiTokensCreateResponse
from ApiTokensCreateRequest.clsApiTokensCreateRequest import ApiTokensCreateRequest
from ApiTokensGetResponse.clsApiTokensGetResponse import ApiTokensGetResponse
from Status.clsStatus import Status
from Failure.clsFailure import Failure
from ErrorResponse.clsErrorResponse import ErrorResponse
from ErrorDetails.clsErrorDetails import ErrorDetails
from SuccessResponse.clsSuccessResponse import SuccessResponse
from AADTenantAddRequest.clsAADTenantAddRequest import AADTenantAddRequest
from AADTenantResponse.clsAADTenantResponse import AADTenantResponse
from AddAppTesterRequest.clsAddAppTesterRequest import AddAppTesterRequest
from AddAppTesterResponse.clsAddAppTesterResponse import AddAppTesterResponse
from ApiTokensPostRequest.clsApiTokensPostRequest import ApiTokensPostRequest
from AppPatchRequest.clsAppPatchRequest import AppPatchRequest
from AppRepoPatchRequest.clsAppRepoPatchRequest import AppRepoPatchRequest
from AppRepoPostRequest.clsAppRepoPostRequest import AppRepoPostRequest
from AppRequest.clsAppRequest import AppRequest
from AppAddRequest.clsAppAddRequest import AppAddRequest
from AppDeleteRequest.clsAppDeleteRequest import AppDeleteRequest
from AzureSubscriptionAddRequest.clsAzureSubscriptionAddRequest import AzureSubscriptionAddRequest
from AzureSubscriptionUpdateBillableRequest.clsAzureSubscriptionUpdateBillableRequest import AzureSubscriptionUpdateBillableRequest
from AzureSubscriptionPatchRequest.clsAzureSubscriptionPatchRequest import AzureSubscriptionPatchRequest
from AzureSubscriptionAddToAppRequest.clsAzureSubscriptionAddToAppRequest import AzureSubscriptionAddToAppRequest
from DistributionGroupPatchRequest.clsDistributionGroupPatchRequest import DistributionGroupPatchRequest
from DistributionGroupRequest.clsDistributionGroupRequest import DistributionGroupRequest
from AppDistributionGroupUsersRequest.clsAppDistributionGroupUsersRequest import AppDistributionGroupUsersRequest
from DistributionGroupUserRequest.clsDistributionGroupUserRequest import DistributionGroupUserRequest
from DistributionGroupAppAddRequest.clsDistributionGroupAppAddRequest import DistributionGroupAppAddRequest
from DistributionGroupAppsDeleteRequest.clsDistributionGroupAppsDeleteRequest import DistributionGroupAppsDeleteRequest
from DistributionGroupAADGroupsDeleteRequest.clsDistributionGroupAADGroupsDeleteRequest import DistributionGroupAADGroupsDeleteRequest
from DataDeletionRequest.clsDataDeletionRequest import DataDeletionRequest
from DistributionGroupAADGroupRequest.clsDistributionGroupAADGroupRequest import DistributionGroupAADGroupRequest
from DistributionGroupAADGroupBase.clsDistributionGroupAADGroupBase import DistributionGroupAADGroupBase
from DistributionGroupsUserVerifyRequest.clsDistributionGroupsUserVerifyRequest import DistributionGroupsUserVerifyRequest
from DistributionGroupIdRequest.clsDistributionGroupIdRequest import DistributionGroupIdRequest
from EmailVerificationRequest.clsEmailVerificationRequest import EmailVerificationRequest
from ExternalRepositoryProvider.clsExternalRepositoryProvider import ExternalRepositoryProvider
from ExternalUserRequest.clsExternalUserRequest import ExternalUserRequest
from ExternalAppId.clsExternalAppId import ExternalAppId
from FeaturePatchRequest.clsFeaturePatchRequest import FeaturePatchRequest
from FeatureCreateRequest.clsFeatureCreateRequest import FeatureCreateRequest
from GrantAdminRoleRequest.clsGrantAdminRoleRequest import GrantAdminRoleRequest
from InternalBulkAppResponse.clsInternalBulkAppResponse import InternalBulkAppResponse
from InternalHockeyAppCompatibilityResponse.clsInternalHockeyAppCompatibilityResponse import InternalHockeyAppCompatibilityResponse
from InternalHockeyAppCutoverStatusResponse.clsInternalHockeyAppCutoverStatusResponse import InternalHockeyAppCutoverStatusResponse
from InternalUserRequest.clsInternalUserRequest import InternalUserRequest
from OrganizationPatchRequest.clsOrganizationPatchRequest import OrganizationPatchRequest
from OrganizationRequest.clsOrganizationRequest import OrganizationRequest
from OrganizationUserPatchRequest.clsOrganizationUserPatchRequest import OrganizationUserPatchRequest
from AddOrganizationAdminRequest.clsAddOrganizationAdminRequest import AddOrganizationAdminRequest
from TransferAppAdminRequest.clsTransferAppAdminRequest import TransferAppAdminRequest
from PasswordUpdateRequest.clsPasswordUpdateRequest import PasswordUpdateRequest
from PostRepositoryProviderMappingRequest.clsPostRepositoryProviderMappingRequest import PostRepositoryProviderMappingRequest
from GetOrCreateRepositoryProviderMappingRequest.clsGetOrCreateRepositoryProviderMappingRequest import GetOrCreateRepositoryProviderMappingRequest
from ResendVerificationRequest.clsResendVerificationRequest import ResendVerificationRequest
from ResetPasswordUsingTokenRequest.clsResetPasswordUsingTokenRequest import ResetPasswordUsingTokenRequest
from UserAppPermissionsUpdateRequest.clsUserAppPermissionsUpdateRequest import UserAppPermissionsUpdateRequest
from UserInvitationPermissionsUpdateRequest.clsUserInvitationPermissionsUpdateRequest import UserInvitationPermissionsUpdateRequest
from UserEmailRequest.clsUserEmailRequest import UserEmailRequest
from UserNameUpdateRequest.clsUserNameUpdateRequest import UserNameUpdateRequest
from UserUpdateRequest.clsUserUpdateRequest import UserUpdateRequest
from UserUpdateRequestInternal.clsUserUpdateRequestInternal import UserUpdateRequestInternal
from UserSettingRequest.clsUserSettingRequest import UserSettingRequest
from AccountResponse.clsAccountResponse import AccountResponse
from ApiTokenDeleteResponse.clsApiTokenDeleteResponse import ApiTokenDeleteResponse
from ApiTokenGetUserResponse.clsApiTokenGetUserResponse import ApiTokenGetUserResponse
from ApiTokenResponse.clsApiTokenResponse import ApiTokenResponse
from AppGroupResponse.clsAppGroupResponse import AppGroupResponse
from AppInvitationDetailResponse.clsAppInvitationDetailResponse import AppInvitationDetailResponse
from AppRepoResponse.clsAppRepoResponse import AppRepoResponse
from BasicAppResponse.clsBasicAppResponse import BasicAppResponse
from AppResponse.clsAppResponse import AppResponse
from TesterAppResponse.clsTesterAppResponse import TesterAppResponse
from OrgDistributionGroupAppResponse.clsOrgDistributionGroupAppResponse import OrgDistributionGroupAppResponse
from AppResponseInternal.clsAppResponseInternal import AppResponseInternal
from AppUserPermissionResponse.clsAppUserPermissionResponse import AppUserPermissionResponse
from AppWithTeamPermissionsResponse.clsAppWithTeamPermissionsResponse import AppWithTeamPermissionsResponse
from OrgUserPermissionResponse.clsOrgUserPermissionResponse import OrgUserPermissionResponse
from AzureSubscriptionResponse.clsAzureSubscriptionResponse import AzureSubscriptionResponse
from DistributionGroupResponse.clsDistributionGroupResponse import DistributionGroupResponse
from DistributionGroupDetailsResponse.clsDistributionGroupDetailsResponse import DistributionGroupDetailsResponse
from OrgDistributionGroupDetailsResponse.clsOrgDistributionGroupDetailsResponse import OrgDistributionGroupDetailsResponse
from GeneralDistributionGroupDetailsResponse.clsGeneralDistributionGroupDetailsResponse import GeneralDistributionGroupDetailsResponse
from DistributionGroupUserDeleteResponse.clsDistributionGroupUserDeleteResponse import DistributionGroupUserDeleteResponse
from CloseAccountOrganizationResponse.clsCloseAccountOrganizationResponse import CloseAccountOrganizationResponse
from DistributionGroupUserGetResponse.clsDistributionGroupUserGetResponse import DistributionGroupUserGetResponse
from DistributionGroupUserPostResponse.clsDistributionGroupUserPostResponse import DistributionGroupUserPostResponse
from DistributionGroupTesterGetResponse.clsDistributionGroupTesterGetResponse import DistributionGroupTesterGetResponse
from DistributionGroupAADGroupPostResponse.clsDistributionGroupAADGroupPostResponse import DistributionGroupAADGroupPostResponse
from DistributionGroupAadGroupsDeleteResponse.clsDistributionGroupAadGroupsDeleteResponse import DistributionGroupAadGroupsDeleteResponse
from DistributionGroupWithUsersResponse.clsDistributionGroupWithUsersResponse import DistributionGroupWithUsersResponse
from FeatureFlagsResponse.clsFeatureFlagsResponse import FeatureFlagsResponse
from FeatureResponse.clsFeatureResponse import FeatureResponse
from InternalUserSignupResponse.clsInternalUserSignupResponse import InternalUserSignupResponse
from InvitationDetailResponse.clsInvitationDetailResponse import InvitationDetailResponse
from GDPRInvitationDetailResponse.clsGDPRInvitationDetailResponse import GDPRInvitationDetailResponse
from OrgNameAvailabilityResponse.clsOrgNameAvailabilityResponse import OrgNameAvailabilityResponse
from OrganizationInvitationDetailResponse.clsOrganizationInvitationDetailResponse import OrganizationInvitationDetailResponse
from OrganizationInvitationSimpleDetailResponse.clsOrganizationInvitationSimpleDetailResponse import OrganizationInvitationSimpleDetailResponse
from OrganizationResponse.clsOrganizationResponse import OrganizationResponse
from OrganizationResponseInternal.clsOrganizationResponseInternal import OrganizationResponseInternal
from OrganizationResponseManagement.clsOrganizationResponseManagement import OrganizationResponseManagement
from OrganizationUserResponse.clsOrganizationUserResponse import OrganizationUserResponse
from OrganizationAADGroupResponse.clsOrganizationAADGroupResponse import OrganizationAADGroupResponse
from TeamAppUpdateRequest.clsTeamAppUpdateRequest import TeamAppUpdateRequest
from TeamRequest.clsTeamRequest import TeamRequest
from TeamResponse.clsTeamResponse import TeamResponse
from TeamAppResponse.clsTeamAppResponse import TeamAppResponse
from StatusResponse.clsStatusResponse import StatusResponse
from PurgeResponse.clsPurgeResponse import PurgeResponse
from ServiceBusStatusResponse.clsServiceBusStatusResponse import ServiceBusStatusResponse
from SubscriptionMetrics.clsSubscriptionMetrics import SubscriptionMetrics
from TeamUserResponse.clsTeamUserResponse import TeamUserResponse
from UserAuthResponse.clsUserAuthResponse import UserAuthResponse
from UserLiteProfileResponse.clsUserLiteProfileResponse import UserLiteProfileResponse
from UserNameAvailabilityResponse.clsUserNameAvailabilityResponse import UserNameAvailabilityResponse
from AppIntegration.clsAppIntegration import AppIntegration
from AppIntegrationResponse.clsAppIntegrationResponse import AppIntegrationResponse
from AppMembershipsResponse.clsAppMembershipsResponse import AppMembershipsResponse
from UserProfileResponse.clsUserProfileResponse import UserProfileResponse
from UserProfileResponseInternal.clsUserProfileResponseInternal import UserProfileResponseInternal
from UserProfileResponseManagement.clsUserProfileResponseManagement import UserProfileResponseManagement
from UserSettingResponse.clsUserSettingResponse import UserSettingResponse
from Owner.clsOwner import Owner
from AADGroup.clsAADGroup import AADGroup
from AADUser.clsAADUser import AADUser
from MSAUser.clsMSAUser import MSAUser
from LinkAADtoUserRequest.clsLinkAADtoUserRequest import LinkAADtoUserRequest
from AddUserAsRoleRequest.clsAddUserAsRoleRequest import AddUserAsRoleRequest
from SharedConnectionPatchRequest.clsSharedConnectionPatchRequest import SharedConnectionPatchRequest
from SharedConnectionRequest.clsSharedConnectionRequest import SharedConnectionRequest
from SharedConnectionResponse.clsSharedConnectionResponse import SharedConnectionResponse
from PrivateSharedConnectionResponse.clsPrivateSharedConnectionResponse import PrivateSharedConnectionResponse
from AppleConnectionSecretRequest.clsAppleConnectionSecretRequest import AppleConnectionSecretRequest
from AppleCredentialsMultifactorSecretRequest.clsAppleCredentialsMultifactorSecretRequest import AppleCredentialsMultifactorSecretRequest
from AppleCredentialsSecretRequest.clsAppleCredentialsSecretRequest import AppleCredentialsSecretRequest
from AppleCertificateSecretRequest.clsAppleCertificateSecretRequest import AppleCertificateSecretRequest
from PrivateAppleSecretResponse.clsPrivateAppleSecretResponse import PrivateAppleSecretResponse
from PrivateAppleCredentialsSecretResponse.clsPrivateAppleCredentialsSecretResponse import PrivateAppleCredentialsSecretResponse
from PrivateAppleCertificateSecretResponse.clsPrivateAppleCertificateSecretResponse import PrivateAppleCertificateSecretResponse
from AppleSecretDetails.clsAppleSecretDetails import AppleSecretDetails
from AppleMultifactorSecretDetails.clsAppleMultifactorSecretDetails import AppleMultifactorSecretDetails
from AppleSecretDetailsResponse.clsAppleSecretDetailsResponse import AppleSecretDetailsResponse
from AppleConnectionSecretResponse.clsAppleConnectionSecretResponse import AppleConnectionSecretResponse
from AppleConnectionNonSecretResponse.clsAppleConnectionNonSecretResponse import AppleConnectionNonSecretResponse
from AppleCredentialNonSecretDetailsResponse.clsAppleCredentialNonSecretDetailsResponse import AppleCredentialNonSecretDetailsResponse
from AppleCertificateNonSecretDetailsResponse.clsAppleCertificateNonSecretDetailsResponse import AppleCertificateNonSecretDetailsResponse
from AppleCertificateSecretDetailsResponse.clsAppleCertificateSecretDetailsResponse import AppleCertificateSecretDetailsResponse
from AppleCertificateSecretDetails.clsAppleCertificateSecretDetails import AppleCertificateSecretDetails
from AppleCertificateDetails.clsAppleCertificateDetails import AppleCertificateDetails
from AppleCertificateNonSecretDetails.clsAppleCertificateNonSecretDetails import AppleCertificateNonSecretDetails
from JiraConnectionSecretRequest.clsJiraConnectionSecretRequest import JiraConnectionSecretRequest
from JiraConnectionSecretResponse.clsJiraConnectionSecretResponse import JiraConnectionSecretResponse
from PrivateJiraConnectionSecretResponse.clsPrivateJiraConnectionSecretResponse import PrivateJiraConnectionSecretResponse
from JiraSecretDetails.clsJiraSecretDetails import JiraSecretDetails
from JiraSecretDetailsResponse.clsJiraSecretDetailsResponse import JiraSecretDetailsResponse
from GooglePlayConnectionSecretRequest.clsGooglePlayConnectionSecretRequest import GooglePlayConnectionSecretRequest
from GooglePlayConnectionSecretResponse.clsGooglePlayConnectionSecretResponse import GooglePlayConnectionSecretResponse
from PrivateGooglePlayConnectionSecretResponse.clsPrivateGooglePlayConnectionSecretResponse import PrivateGooglePlayConnectionSecretResponse
from GooglePlayConnectionNonSecretResponse.clsGooglePlayConnectionNonSecretResponse import GooglePlayConnectionNonSecretResponse
from GooglePlayCredentialNonSecretDetailsResponse.clsGooglePlayCredentialNonSecretDetailsResponse import GooglePlayCredentialNonSecretDetailsResponse
from JiraConnectionNonSecretResponse.clsJiraConnectionNonSecretResponse import JiraConnectionNonSecretResponse
from JiraCredentialNonSecretDetailsResponse.clsJiraCredentialNonSecretDetailsResponse import JiraCredentialNonSecretDetailsResponse
from ApiTokenResponsev2.clsApiTokenResponsev2 import ApiTokenResponsev2
from UserDataResponse.clsUserDataResponse import UserDataResponse
from ErrorDetailsv2.clsErrorDetailsv2 import ErrorDetailsv2
from ErrorResponsev2.clsErrorResponsev2 import ErrorResponsev2
from FileAsset.clsFileAsset import FileAsset
from SourceRepository.clsSourceRepository import SourceRepository
from SourceRepositories.clsSourceRepositories import SourceRepositories
from GitHubInstallationLite.clsGitHubInstallationLite import GitHubInstallationLite
from GitHubAccountLite.clsGitHubAccountLite import GitHubAccountLite
from GitHubInstallationRepository.clsGitHubInstallationRepository import GitHubInstallationRepository
from GitHubInstallationRepositories.clsGitHubInstallationRepositories import GitHubInstallationRepositories
from GitHubBillingAccount.clsGitHubBillingAccount import GitHubBillingAccount
from GitHubPullRequestLite.clsGitHubPullRequestLite import GitHubPullRequestLite
from GitHubBranchLite.clsGitHubBranchLite import GitHubBranchLite
from GitHubRepositoryLite.clsGitHubRepositoryLite import GitHubRepositoryLite
from IosAppExtensionInfo.clsIosAppExtensionInfo import IosAppExtensionInfo
from ProvisioningProfileFile.clsProvisioningProfileFile import ProvisioningProfileFile
from VSTSProfile.clsVSTSProfile import VSTSProfile
from VSTSProject.clsVSTSProject import VSTSProject
from VSTSAccount.clsVSTSAccount import VSTSAccount
from VSTSAccounts.clsVSTSAccounts import VSTSAccounts
from DownloadContainer.clsDownloadContainer import DownloadContainer
from WebSocketContainer.clsWebSocketContainer import WebSocketContainer
from XcodeArchiveProject.clsXcodeArchiveProject import XcodeArchiveProject
from XcodeScheme.clsXcodeScheme import XcodeScheme
from XcodeToolset.clsXcodeToolset import XcodeToolset
from XcodeSchemeContainer.clsXcodeSchemeContainer import XcodeSchemeContainer
from XamarinToolset.clsXamarinToolset import XamarinToolset
from XamarinSolution.clsXamarinSolution import XamarinSolution
from AndroidProject.clsAndroidProject import AndroidProject
from AndroidModule.clsAndroidModule import AndroidModule
from JavaScriptToolset.clsJavaScriptToolset import JavaScriptToolset
from JavaScriptSolution.clsJavaScriptSolution import JavaScriptSolution
from UWPToolset.clsUWPToolset import UWPToolset
from UWPSolution.clsUWPSolution import UWPSolution
from TestCloudToolset.clsTestCloudToolset import TestCloudToolset
from TestCloudProject.clsTestCloudProject import TestCloudProject
from TestCloudProjectFrameworkProperties.clsTestCloudProjectFrameworkProperties import TestCloudProjectFrameworkProperties
from ToolsetProjects.clsToolsetProjects import ToolsetProjects
from BuildScripts.clsBuildScripts import BuildScripts
from ToolsetProject.clsToolsetProject import ToolsetProject
from BranchStatusCollection.clsBranchStatusCollection import BranchStatusCollection
from BranchStatus.clsBranchStatus import BranchStatus
from BranchProperties.clsBranchProperties import BranchProperties
from BranchConfiguration.clsBranchConfiguration import BranchConfiguration
from BranchConfigurationToolsets.clsBranchConfigurationToolsets import BranchConfigurationToolsets
from BranchConfigurationArtifactVersioning.clsBranchConfigurationArtifactVersioning import BranchConfigurationArtifactVersioning
from XcodeBranchConfigurationProperties.clsXcodeBranchConfigurationProperties import XcodeBranchConfigurationProperties
from AndroidBranchConfigurationProperties.clsAndroidBranchConfigurationProperties import AndroidBranchConfigurationProperties
from JavaScriptBranchConfigurationProperties.clsJavaScriptBranchConfigurationProperties import JavaScriptBranchConfigurationProperties
from XamarinBranchConfigurationProperties.clsXamarinBranchConfigurationProperties import XamarinBranchConfigurationProperties
from Branch.clsBranch import Branch
from Commit.clsCommit import Commit
from CommitDetails.clsCommitDetails import CommitDetails
from CommitDetailsList.clsCommitDetailsList import CommitDetailsList
from RepoConfig.clsRepoConfig import RepoConfig
from RepoConfigs.clsRepoConfigs import RepoConfigs
from RepoInfo.clsRepoInfo import RepoInfo
from XcodeVersions.clsXcodeVersions import XcodeVersions
from XcodeVersion.clsXcodeVersion import XcodeVersion
from XamarinSDKBundles.clsXamarinSDKBundles import XamarinSDKBundles
from XamarinSDKBundle.clsXamarinSDKBundle import XamarinSDKBundle
from Builds.clsBuilds import Builds
from BuildParams.clsBuildParams import BuildParams
from Build.clsBuild import Build
from BuildPatch.clsBuildPatch import BuildPatch
from BuildLog.clsBuildLog import BuildLog
from DistributionRequest.clsDistributionRequest import DistributionRequest
from DistributionResponse.clsDistributionResponse import DistributionResponse
from BuildServiceStatus.clsBuildServiceStatus import BuildServiceStatus
from BuildAgentQueue.clsBuildAgentQueue import BuildAgentQueue
from ValidationErrorResponse.clsValidationErrorResponse import ValidationErrorResponse
from BuildAgentQueuesResponse.clsBuildAgentQueuesResponse import BuildAgentQueuesResponse
from BuildAgentQueueResponse.clsBuildAgentQueueResponse import BuildAgentQueueResponse
from AgentQueuesResponse.clsAgentQueuesResponse import AgentQueuesResponse
from AgentQueueResponse.clsAgentQueueResponse import AgentQueueResponse
from AppBuildFeatures.clsAppBuildFeatures import AppBuildFeatures
from AppBuildFeature.clsAppBuildFeature import AppBuildFeature
from DestinationDetails.clsDestinationDetails import DestinationDetails
from FileValidationDetails.clsFileValidationDetails import FileValidationDetails
from BuildConcurrencyResponse.clsBuildConcurrencyResponse import BuildConcurrencyResponse
from CreateReleaseUploadRequest.clsCreateReleaseUploadRequest import CreateReleaseUploadRequest
from CreateReleaseUploadResponse.clsCreateReleaseUploadResponse import CreateReleaseUploadResponse
from GetReleaseStatusResponse.clsGetReleaseStatusResponse import GetReleaseStatusResponse
from PatchReleaseUploadStatusRequest.clsPatchReleaseUploadStatusRequest import PatchReleaseUploadStatusRequest
from PatchReleaseUploadStatusResponse.clsPatchReleaseUploadStatusResponse import PatchReleaseUploadStatusResponse
from TesterAppWithReleaseResponse.clsTesterAppWithReleaseResponse import TesterAppWithReleaseResponse
from TesterAppRelease.clsTesterAppRelease import TesterAppRelease
from SendNotificationRequest.clsSendNotificationRequest import SendNotificationRequest
from UserInteractionMetricsResponse.clsUserInteractionMetricsResponse import UserInteractionMetricsResponse
from ReleaseUpdateResponse.clsReleaseUpdateResponse import ReleaseUpdateResponse
from ReleaseDetailsUpdateResponse.clsReleaseDetailsUpdateResponse import ReleaseDetailsUpdateResponse
from ReleaseProvisionResponse.clsReleaseProvisionResponse import ReleaseProvisionResponse
from PrivateReleaseDetailsResponse.clsPrivateReleaseDetailsResponse import PrivateReleaseDetailsResponse
from PrivateBasicReleaseDetailsResponse.clsPrivateBasicReleaseDetailsResponse import PrivateBasicReleaseDetailsResponse
from DistributionGroupReleasesResponse.clsDistributionGroupReleasesResponse import DistributionGroupReleasesResponse
from DistributionGroupRelease.clsDistributionGroupRelease import DistributionGroupRelease
from BasicReleaseDetailsResponse.clsBasicReleaseDetailsResponse import BasicReleaseDetailsResponse
from ReleaseDetailsResponse.clsReleaseDetailsResponse import ReleaseDetailsResponse
from ReleaseUploadBeginResponse.clsReleaseUploadBeginResponse import ReleaseUploadBeginResponse
from GDPRValidationRequest.clsGDPRValidationRequest import GDPRValidationRequest
from ReleaseUploadBeginRequest.clsReleaseUploadBeginRequest import ReleaseUploadBeginRequest
from ReleaseUploadEndRequest.clsReleaseUploadEndRequest import ReleaseUploadEndRequest
from ReleaseUploadEndResponse.clsReleaseUploadEndResponse import ReleaseUploadEndResponse
from ReleaseCreateRequest.clsReleaseCreateRequest import ReleaseCreateRequest
from ReleaseUpdateRequest.clsReleaseUpdateRequest import ReleaseUpdateRequest
from ReleaseDetailsUpdateRequest.clsReleaseDetailsUpdateRequest import ReleaseDetailsUpdateRequest
from BuildInfo.clsBuildInfo import BuildInfo
from DestinationId.clsDestinationId import DestinationId
from ReleaseDestinationRequest.clsReleaseDestinationRequest import ReleaseDestinationRequest
from ReleaseStoreDestinationRequest.clsReleaseStoreDestinationRequest import ReleaseStoreDestinationRequest
from ReleaseTesterDestinationRequest.clsReleaseTesterDestinationRequest import ReleaseTesterDestinationRequest
from ReleaseDestinationResponse.clsReleaseDestinationResponse import ReleaseDestinationResponse
from ReleaseStoreDestinationResponse.clsReleaseStoreDestinationResponse import ReleaseStoreDestinationResponse
from Destination.clsDestination import Destination
from PrivateReleaseUpdateRequest.clsPrivateReleaseUpdateRequest import PrivateReleaseUpdateRequest
from DistributionGroup.clsDistributionGroup import DistributionGroup
from DistributionGroupWithoutIsLatest.clsDistributionGroupWithoutIsLatest import DistributionGroupWithoutIsLatest
from DistributionStore.clsDistributionStore import DistributionStore
from DistributionStoreWithoutIsLatest.clsDistributionStoreWithoutIsLatest import DistributionStoreWithoutIsLatest
from ArchIdentifier.clsArchIdentifier import ArchIdentifier
from ProvisioningProfile.clsProvisioningProfile import ProvisioningProfile
from ProvisioningProfileResponse.clsProvisioningProfileResponse import ProvisioningProfileResponse
from ReleaseUpdateError.clsReleaseUpdateError import ReleaseUpdateError
from DestinationError.clsDestinationError import DestinationError
from AutoProvisioningConfigRequest.clsAutoProvisioningConfigRequest import AutoProvisioningConfigRequest
from AutoProvisioningConfigResponse.clsAutoProvisioningConfigResponse import AutoProvisioningConfigResponse
from AnalyticsReleasesResponse.clsAnalyticsReleasesResponse import AnalyticsReleasesResponse
from AnalyticsReleasesParameter.clsAnalyticsReleasesParameter import AnalyticsReleasesParameter
from HockeyAppCompatibilityReleaseResponse.clsHockeyAppCompatibilityReleaseResponse import HockeyAppCompatibilityReleaseResponse
from MigrateReleaseRequest.clsMigrateReleaseRequest import MigrateReleaseRequest
from HockeyAppMigrationRelease.clsHockeyAppMigrationRelease import HockeyAppMigrationRelease
from ProvisioningProfileMigration.clsProvisioningProfileMigration import ProvisioningProfileMigration
from PrivateUpdateUploadDetails.clsPrivateUpdateUploadDetails import PrivateUpdateUploadDetails
from MalwareScanResultPayload.clsMalwareScanResultPayload import MalwareScanResultPayload
from DeviceConfigurationResponse.clsDeviceConfigurationResponse import DeviceConfigurationResponse
from DeviceInfoRequest.clsDeviceInfoRequest import DeviceInfoRequest
from DeviceInfoResponse.clsDeviceInfoResponse import DeviceInfoResponse
from ResignStatus.clsResignStatus import ResignStatus
from ResignInfo.clsResignInfo import ResignInfo
from PublishDevicesRequest.clsPublishDevicesRequest import PublishDevicesRequest
from PublishDevicesResponse.clsPublishDevicesResponse import PublishDevicesResponse
from AppleLoginRequest.clsAppleLoginRequest import AppleLoginRequest
from AppleLoginResponse.clsAppleLoginResponse import AppleLoginResponse
from AppleMutifactorLoginRequest.clsAppleMutifactorLoginRequest import AppleMutifactorLoginRequest
from AppleMultifactorLoginResponse.clsAppleMultifactorLoginResponse import AppleMultifactorLoginResponse
from ApplicationStatusRequest.clsApplicationStatusRequest import ApplicationStatusRequest
from ApplicationStatusResponse.clsApplicationStatusResponse import ApplicationStatusResponse
from ItunesAppsRequest.clsItunesAppsRequest import ItunesAppsRequest
from ItunesTeamsRequest.clsItunesTeamsRequest import ItunesTeamsRequest
from ItunesTeamsResponse.clsItunesTeamsResponse import ItunesTeamsResponse
from AllItunesAppsResponse.clsAllItunesAppsResponse import AllItunesAppsResponse
from AppleTestFlightGroupRequest.clsAppleTestFlightGroupRequest import AppleTestFlightGroupRequest
from AppleTestFlightGroupResponse.clsAppleTestFlightGroupResponse import AppleTestFlightGroupResponse
from AvailabilityOfDevicesRequest.clsAvailabilityOfDevicesRequest import AvailabilityOfDevicesRequest
from DeviceAvailability.clsDeviceAvailability import DeviceAvailability
from AvailabilityOfDevicesResponse.clsAvailabilityOfDevicesResponse import AvailabilityOfDevicesResponse
from UpdateDevicesRequest.clsUpdateDevicesRequest import UpdateDevicesRequest
from UpdateDevicesResponse.clsUpdateDevicesResponse import UpdateDevicesResponse
from UpdateResignStatusRequest.clsUpdateResignStatusRequest import UpdateResignStatusRequest
from UpdateResignStatusResponse.clsUpdateResignStatusResponse import UpdateResignStatusResponse
from DeviceRegistrationUrl.clsDeviceRegistrationUrl import DeviceRegistrationUrl
from ResignAttemptResponse.clsResignAttemptResponse import ResignAttemptResponse
from StoresReleaseDetails.clsStoresReleaseDetails import StoresReleaseDetails
from StorePatchRequest.clsStorePatchRequest import StorePatchRequest
from ExternalStoreRequest.clsExternalStoreRequest import ExternalStoreRequest
from AppleMappingRequest.clsAppleMappingRequest import AppleMappingRequest
from AppleMappingResponse.clsAppleMappingResponse import AppleMappingResponse
from AppleTestFlightGroupsResponse.clsAppleTestFlightGroupsResponse import AppleTestFlightGroupsResponse
from PrivateCreateStoreRequest.clsPrivateCreateStoreRequest import PrivateCreateStoreRequest
from IntuneSecretDetails.clsIntuneSecretDetails import IntuneSecretDetails
from IntuneCategories.clsIntuneCategories import IntuneCategories
from IntuneCategoryValue.clsIntuneCategoryValue import IntuneCategoryValue
from IntuneGroups.clsIntuneGroups import IntuneGroups
from IntuneGroupValue.clsIntuneGroupValue import IntuneGroupValue
from IntuneGroup.clsIntuneGroup import IntuneGroup
from CreateStoreSecretRequest.clsCreateStoreSecretRequest import CreateStoreSecretRequest
from CreateStoreSecretResponse.clsCreateStoreSecretResponse import CreateStoreSecretResponse
from SecretDetails.clsSecretDetails import SecretDetails
from ReleasePublishErrorResponse.clsReleasePublishErrorResponse import ReleasePublishErrorResponse
from ReleaseRealTimeStatusResponse.clsReleaseRealTimeStatusResponse import ReleaseRealTimeStatusResponse
from ValidationResponse.clsValidationResponse import ValidationResponse
from HasBuildUploadedResponse.clsHasBuildUploadedResponse import HasBuildUploadedResponse
from HasTestflightMetadataResponse.clsHasTestflightMetadataResponse import HasTestflightMetadataResponse
from SkipValidationRequest.clsSkipValidationRequest import SkipValidationRequest
from StatusData.clsStatusData import StatusData
from ExternalStoreResponse.clsExternalStoreResponse import ExternalStoreResponse
from StoreSecretResponse.clsStoreSecretResponse import StoreSecretResponse
from IntuneStoreResponse.clsIntuneStoreResponse import IntuneStoreResponse
from IntuneStoreRequest.clsIntuneStoreRequest import IntuneStoreRequest
from PrivateIntuneStoreRequest.clsPrivateIntuneStoreRequest import PrivateIntuneStoreRequest
from IntuneTargetAudience.clsIntuneTargetAudience import IntuneTargetAudience
from IntuneAppCategory.clsIntuneAppCategory import IntuneAppCategory
from IntuneTargetAudienceResponse.clsIntuneTargetAudienceResponse import IntuneTargetAudienceResponse
from IntuneAppCategoryResponse.clsIntuneAppCategoryResponse import IntuneAppCategoryResponse
from PatchReleaseRequest.clsPatchReleaseRequest import PatchReleaseRequest
from StoresBasicReleaseDetails.clsStoresBasicReleaseDetails import StoresBasicReleaseDetails
from StoresDetails.clsStoresDetails import StoresDetails
from StoreDestinationDetails.clsStoreDestinationDetails import StoreDestinationDetails
from StoresBasicDetails.clsStoresBasicDetails import StoresBasicDetails
from IntuneAppsRequest.clsIntuneAppsRequest import IntuneAppsRequest
from IntuneAppsResponse.clsIntuneAppsResponse import IntuneAppsResponse
from OrgComplianceSettingsRequest.clsOrgComplianceSettingsRequest import OrgComplianceSettingsRequest
from OrgComplianceSettingsResponse.clsOrgComplianceSettingsResponse import OrgComplianceSettingsResponse
from StoreNotification.clsStoreNotification import StoreNotification
from DiagnosticIdResponse.clsDiagnosticIdResponse import DiagnosticIdResponse
from Symbol.clsSymbol import Symbol
from Symbols.clsSymbols import Symbols
from SymbolStatusResponse.clsSymbolStatusResponse import SymbolStatusResponse
from SymbolUpload.clsSymbolUpload import SymbolUpload
from SymbolUploads.clsSymbolUploads import SymbolUploads
from SymbolLocation.clsSymbolLocation import SymbolLocation
from SymbolUploadLocation.clsSymbolUploadLocation import SymbolUploadLocation
from SymbolUploadBeginRequest.clsSymbolUploadBeginRequest import SymbolUploadBeginRequest
from SymbolUploadBeginResponse.clsSymbolUploadBeginResponse import SymbolUploadBeginResponse
from SymbolUploadEndRequest.clsSymbolUploadEndRequest import SymbolUploadEndRequest
from SymbolUploadUserInfo.clsSymbolUploadUserInfo import SymbolUploadUserInfo
from UploadedSymbolInfo.clsUploadedSymbolInfo import UploadedSymbolInfo
from SystemVersionNameGroup.clsSystemVersionNameGroup import SystemVersionNameGroup
from SystemVersionNameGroups.clsSystemVersionNameGroups import SystemVersionNameGroups
from CrashGroupStatusEnum.clsCrashGroupStatusEnum import CrashGroupStatusEnum
from AppCrashesInfo.clsAppCrashesInfo import AppCrashesInfo
from AppFeatures.clsAppFeatures import AppFeatures
from AppVersion.clsAppVersion import AppVersion
from Exception.clsException import Exception
from Stacktrace.clsStacktrace import Stacktrace
from Thread.clsThread import Thread
from StackFrame.clsStackFrame import StackFrame
from ReasonStackFrame.clsReasonStackFrame import ReasonStackFrame
from RetentionSettings.clsRetentionSettings import RetentionSettings
from CrashAttachment.clsCrashAttachment import CrashAttachment
from RawCrashLog.clsRawCrashLog import RawCrashLog
from NativeCrashLog.clsNativeCrashLog import NativeCrashLog
from CrashRawLocation.clsCrashRawLocation import CrashRawLocation
from CrashAttachmentLocation.clsCrashAttachmentLocation import CrashAttachmentLocation
from CrashGroupsContainer.clsCrashGroupsContainer import CrashGroupsContainer
from CrashGroup.clsCrashGroup import CrashGroup
from CrashGroupChange.clsCrashGroupChange import CrashGroupChange
from Crash.clsCrash import Crash
from CrashDetails.clsCrashDetails import CrashDetails
from HockeyAppCrashForwardingInfo.clsHockeyAppCrashForwardingInfo import HockeyAppCrashForwardingInfo
from HockeyAppCrashForwardingChange.clsHockeyAppCrashForwardingChange import HockeyAppCrashForwardingChange
from AlertingCrashGroup.clsAlertingCrashGroup import AlertingCrashGroup
from CrashDeleteCounter.clsCrashDeleteCounter import CrashDeleteCounter
from v2SymbolStatusEnum.clsv2SymbolStatusEnum import v2SymbolStatusEnum
from v2MissingSymbol.clsv2MissingSymbol import v2MissingSymbol
from v2MissingSymbols.clsv2MissingSymbols import v2MissingSymbols
from v2SymbolUpdateInfo.clsv2SymbolUpdateInfo import v2SymbolUpdateInfo
from v2MissingSymbolCrashGroupStatusEnum.clsv2MissingSymbolCrashGroupStatusEnum import v2MissingSymbolCrashGroupStatusEnum
from v2MissingSymbolCrashGroup.clsv2MissingSymbolCrashGroup import v2MissingSymbolCrashGroup
from v2MissingSymbolCrashGroups.clsv2MissingSymbolCrashGroups import v2MissingSymbolCrashGroups
from v2MissingSymbolCrashGroupsResponse.clsv2MissingSymbolCrashGroupsResponse import v2MissingSymbolCrashGroupsResponse
from v2MissingSymbolCrashGroupsInfoResponse.clsv2MissingSymbolCrashGroupsInfoResponse import v2MissingSymbolCrashGroupsInfoResponse
from v2StatusResponse.clsv2StatusResponse import v2StatusResponse
from v2FailureResponse.clsv2FailureResponse import v2FailureResponse
from ActiveCrashingAppDetails.clsActiveCrashingAppDetails import ActiveCrashingAppDetails
from LogTraceDefinition.clsLogTraceDefinition import LogTraceDefinition
from CrashingAppDetail.clsCrashingAppDetail import CrashingAppDetail
from LogContainer.clsLogContainer import LogContainer
from GenericLogContainer.clsGenericLogContainer import GenericLogContainer
from GenericLog.clsGenericLog import GenericLog
from Log.clsLog import Log
from LogWithProperties.clsLogWithProperties import LogWithProperties
from Device.clsDevice import Device
from StartSessionLog.clsStartSessionLog import StartSessionLog
from HandledErrorLog.clsHandledErrorLog import HandledErrorLog
from UnhandledErrorLog.clsUnhandledErrorLog import UnhandledErrorLog
from StartServiceLog.clsStartServiceLog import StartServiceLog
from CustomPropertyLog.clsCustomPropertyLog import CustomPropertyLog
from CustomProperty.clsCustomProperty import CustomProperty
from StringProperty.clsStringProperty import StringProperty
from NumberProperty.clsNumberProperty import NumberProperty
from BooleanProperty.clsBooleanProperty import BooleanProperty
from DateTimeProperty.clsDateTimeProperty import DateTimeProperty
from ClearProperty.clsClearProperty import ClearProperty
from PageLog.clsPageLog import PageLog
from EventLog.clsEventLog import EventLog
from PushInstallationLog.clsPushInstallationLog import PushInstallationLog
from ErrorLog.clsErrorLog import ErrorLog
from AudienceListResult.clsAudienceListResult import AudienceListResult
from AudienceSummary.clsAudienceSummary import AudienceSummary
from Audience.clsAudience import Audience
from AudienceTestResult.clsAudienceTestResult import AudienceTestResult
from TokenQueryResult.clsTokenQueryResult import TokenQueryResult
from AudienceDefinition.clsAudienceDefinition import AudienceDefinition
from AudienceQueryDefinition.clsAudienceQueryDefinition import AudienceQueryDefinition
from AudienceBlobResult.clsAudienceBlobResult import AudienceBlobResult
from AudienceDevicePropertiesListResult.clsAudienceDevicePropertiesListResult import AudienceDevicePropertiesListResult
from AudienceDevicePropertyValuesListResult.clsAudienceDevicePropertyValuesListResult import AudienceDevicePropertyValuesListResult
from CrashCounts.clsCrashCounts import CrashCounts
from ActiveDeviceCounts.clsActiveDeviceCounts import ActiveDeviceCounts
from Places.clsPlaces import Places
from Place.clsPlace import Place
from Error.clsError import Error
from SessionDurationsDistribution.clsSessionDurationsDistribution import SessionDurationsDistribution
from Versions.clsVersions import Versions
from Version.clsVersion import Version
from SessionCounts.clsSessionCounts import SessionCounts
from SessionsPerDevice.clsSessionsPerDevice import SessionsPerDevice
from AnalyticsModels.clsAnalyticsModels import AnalyticsModels
from Model.clsModel import Model
from Languages.clsLanguages import Languages
from Language.clsLanguage import Language
from OSes.clsOSes import OSes
from OS.clsOS import OS
from DateTimeCounts.clsDateTimeCounts import DateTimeCounts
from DateTimeDecimalCounts.clsDateTimeDecimalCounts import DateTimeDecimalCounts
from AvailableVersions.clsAvailableVersions import AvailableVersions
from CrashFreeDevicePercentages.clsCrashFreeDevicePercentages import CrashFreeDevicePercentages
from Module.clsModule import Module
from Modules.clsModules import Modules
from DateTimePercentages.clsDateTimePercentages import DateTimePercentages
from CrashesOverall.clsCrashesOverall import CrashesOverall
from CrashOverall.clsCrashOverall import CrashOverall
from CrashGroupModels.clsCrashGroupModels import CrashGroupModels
from CrashGroupModel.clsCrashGroupModel import CrashGroupModel
from CrashGroupOperatingSystems.clsCrashGroupOperatingSystems import CrashGroupOperatingSystems
from CrashGroupOperatingSystem.clsCrashGroupOperatingSystem import CrashGroupOperatingSystem
from CrashGroupPlaces.clsCrashGroupPlaces import CrashGroupPlaces
from CrashGroupPlace.clsCrashGroupPlace import CrashGroupPlace
from CrashGroupLanguages.clsCrashGroupLanguages import CrashGroupLanguages
from CrashGroupLanguage.clsCrashGroupLanguage import CrashGroupLanguage
from CrashGroupCarriers.clsCrashGroupCarriers import CrashGroupCarriers
from CrashGroupCarrier.clsCrashGroupCarrier import CrashGroupCarrier
from CrashGroupContainer.clsCrashGroupContainer import CrashGroupContainer
from CrashGroupAndVersion.clsCrashGroupAndVersion import CrashGroupAndVersion
from Events.clsEvents import Events
from Event.clsEvent import Event
from EventCount.clsEventCount import EventCount
from EventDeviceCount.clsEventDeviceCount import EventDeviceCount
from EventCountPerDevice.clsEventCountPerDevice import EventCountPerDevice
from EventCountPerSession.clsEventCountPerSession import EventCountPerSession
from EventProperties.clsEventProperties import EventProperties
from EventPropertyValues.clsEventPropertyValues import EventPropertyValues
from EventPropertyValue.clsEventPropertyValue import EventPropertyValue
from NotifyReleasesContainer.clsNotifyReleasesContainer import NotifyReleasesContainer
from DeleteReleasesContainer.clsDeleteReleasesContainer import DeleteReleasesContainer
from GetReleasesContainer.clsGetReleasesContainer import GetReleasesContainer
from FilterReleasesContainer.clsFilterReleasesContainer import FilterReleasesContainer
from FilterVersionsContainer.clsFilterVersionsContainer import FilterVersionsContainer
from Release.clsRelease import Release
from ReleaseWithDistributionGroup.clsReleaseWithDistributionGroup import ReleaseWithDistributionGroup
from ReleaseWithDistributionGroupAndUserId.clsReleaseWithDistributionGroupAndUserId import ReleaseWithDistributionGroupAndUserId
from ReleaseCounts.clsReleaseCounts import ReleaseCounts
from ReleaseDailySessions.clsReleaseDailySessions import ReleaseDailySessions
from DailySession.clsDailySession import DailySession
from DateTimeDownloadReleaseCounts.clsDateTimeDownloadReleaseCounts import DateTimeDownloadReleaseCounts
from DateTimeDownloadReleaseCount.clsDateTimeDownloadReleaseCount import DateTimeDownloadReleaseCount
from ReleaseCount.clsReleaseCount import ReleaseCount
from LogFlowLogContainer.clsLogFlowLogContainer import LogFlowLogContainer
from LogFlowGenericLogContainer.clsLogFlowGenericLogContainer import LogFlowGenericLogContainer
from LogFlowGenericLog.clsLogFlowGenericLog import LogFlowGenericLog
from LogFlowLog.clsLogFlowLog import LogFlowLog
from LogFlowLogWithProperties.clsLogFlowLogWithProperties import LogFlowLogWithProperties
from LogFlowDevice.clsLogFlowDevice import LogFlowDevice
from LogFlowStartSessionLog.clsLogFlowStartSessionLog import LogFlowStartSessionLog
from LogFlowStartServiceLog.clsLogFlowStartServiceLog import LogFlowStartServiceLog
from LogFlowCustomPropertyLog.clsLogFlowCustomPropertyLog import LogFlowCustomPropertyLog
from LogFlowCustomProperty.clsLogFlowCustomProperty import LogFlowCustomProperty
from LogFlowStringProperty.clsLogFlowStringProperty import LogFlowStringProperty
from LogFlowNumberProperty.clsLogFlowNumberProperty import LogFlowNumberProperty
from LogFlowBooleanProperty.clsLogFlowBooleanProperty import LogFlowBooleanProperty
from LogFlowDateTimeProperty.clsLogFlowDateTimeProperty import LogFlowDateTimeProperty
from LogFlowClearProperty.clsLogFlowClearProperty import LogFlowClearProperty
from LogFlowPageLog.clsLogFlowPageLog import LogFlowPageLog
from LogFlowEventLog.clsLogFlowEventLog import LogFlowEventLog
from LogFlowPushInstallationLog.clsLogFlowPushInstallationLog import LogFlowPushInstallationLog
from LogFlowErrorLog.clsLogFlowErrorLog import LogFlowErrorLog
from ErrorGroups.clsErrorGroups import ErrorGroups
from ErrorGroupsSearchResult.clsErrorGroupsSearchResult import ErrorGroupsSearchResult
from ErrorCounts.clsErrorCounts import ErrorCounts
from ErrorGroupListItem.clsErrorGroupListItem import ErrorGroupListItem
from ErrorGroup.clsErrorGroup import ErrorGroup
from ErrorDateTimePercentages.clsErrorDateTimePercentages import ErrorDateTimePercentages
from ErrorDateTimeCounts.clsErrorDateTimeCounts import ErrorDateTimeCounts
from ErrorGroupState.clsErrorGroupState import ErrorGroupState
from ErrorDownload.clsErrorDownload import ErrorDownload
from ErrorDownloadLink.clsErrorDownloadLink import ErrorDownloadLink
from DiagnosticsException.clsDiagnosticsException import DiagnosticsException
from DiagnosticsStackTrace.clsDiagnosticsStackTrace import DiagnosticsStackTrace
from DiagnosticsThread.clsDiagnosticsThread import DiagnosticsThread
from DiagnosticsStackFrame.clsDiagnosticsStackFrame import DiagnosticsStackFrame
from HandledErrorReasonFrame.clsHandledErrorReasonFrame import HandledErrorReasonFrame
from ErrorFreeDevicePercentages.clsErrorFreeDevicePercentages import ErrorFreeDevicePercentages
from HandledErrors.clsHandledErrors import HandledErrors
from ErrorsSearchResult.clsErrorsSearchResult import ErrorsSearchResult
from HandledError.clsHandledError import HandledError
from HandledErrorDetails.clsHandledErrorDetails import HandledErrorDetails
from ErrorDeleteCounter.clsErrorDeleteCounter import ErrorDeleteCounter
from ErrorLocation.clsErrorLocation import ErrorLocation
from ErrorAttachments.clsErrorAttachments import ErrorAttachments
from ErrorAttachment.clsErrorAttachment import ErrorAttachment
from ErrorAttachmentText.clsErrorAttachmentText import ErrorAttachmentText
from ErrorAttachmentLocation.clsErrorAttachmentLocation import ErrorAttachmentLocation
from ErrorGroupModels.clsErrorGroupModels import ErrorGroupModels
from ErrorGroupModel.clsErrorGroupModel import ErrorGroupModel
from ErrorGroupOperatingSystems.clsErrorGroupOperatingSystems import ErrorGroupOperatingSystems
from ErrorGroupOperatingSystem.clsErrorGroupOperatingSystem import ErrorGroupOperatingSystem
from GenericLogContainer_Diagnostics.clsGenericLogContainer_Diagnostics import GenericLogContainer_Diagnostics
from GenericLog_Diagnostics.clsGenericLog_Diagnostics import GenericLog_Diagnostics
from Log_Diagnostics.clsLog_Diagnostics import Log_Diagnostics
from LogWithProperties_Diagnostics.clsLogWithProperties_Diagnostics import LogWithProperties_Diagnostics
from Device_Diagnostics.clsDevice_Diagnostics import Device_Diagnostics
from StartSessionLog_Diagnostics.clsStartSessionLog_Diagnostics import StartSessionLog_Diagnostics
from HanledErrorLog_Diagnostics.clsHanledErrorLog_Diagnostics import HanledErrorLog_Diagnostics
from StartServiceLog_Diagnostics.clsStartServiceLog_Diagnostics import StartServiceLog_Diagnostics
from CustomPropertyLog_Diagnostics.clsCustomPropertyLog_Diagnostics import CustomPropertyLog_Diagnostics
from CustomProperty_Diagnostics.clsCustomProperty_Diagnostics import CustomProperty_Diagnostics
from StringProperty_Diagnostics.clsStringProperty_Diagnostics import StringProperty_Diagnostics
from NumberProperty_Diagnostics.clsNumberProperty_Diagnostics import NumberProperty_Diagnostics
from BooleanProperty_Diagnostics.clsBooleanProperty_Diagnostics import BooleanProperty_Diagnostics
from DateTimeProperty_Diagnostics.clsDateTimeProperty_Diagnostics import DateTimeProperty_Diagnostics
from ClearProperty_Diagnostics.clsClearProperty_Diagnostics import ClearProperty_Diagnostics
from PageLog_Diagnostics.clsPageLog_Diagnostics import PageLog_Diagnostics
from EventLog_Diagnostics.clsEventLog_Diagnostics import EventLog_Diagnostics
from PushInstallationLog_Diagnostics.clsPushInstallationLog_Diagnostics import PushInstallationLog_Diagnostics
from ErrorLog_Diagnostics.clsErrorLog_Diagnostics import ErrorLog_Diagnostics
from Versions_Diagnostics.clsVersions_Diagnostics import Versions_Diagnostics
from Version_Diagnostics.clsVersion_Diagnostics import Version_Diagnostics
from AvailableVersions_Diagnostics.clsAvailableVersions_Diagnostics import AvailableVersions_Diagnostics
from ErrorRetentionSettings.clsErrorRetentionSettings import ErrorRetentionSettings
from export_entity.clsexport_entity import export_entity
from ExportConfiguration.clsExportConfiguration import ExportConfiguration
from ExportBlobConfiguration.clsExportBlobConfiguration import ExportBlobConfiguration
from ExportConfigurationBlobStorageConnectionString.clsExportConfigurationBlobStorageConnectionString import ExportConfigurationBlobStorageConnectionString
from ExportConfigurationAppInsightsKey.clsExportConfigurationAppInsightsKey import ExportConfigurationAppInsightsKey
from ExportConfigurationBlobStorageLinkedSubscription.clsExportConfigurationBlobStorageLinkedSubscription import ExportConfigurationBlobStorageLinkedSubscription
from ExportConfigurationAppInsightsLinkedSubscription.clsExportConfigurationAppInsightsLinkedSubscription import ExportConfigurationAppInsightsLinkedSubscription
from ExportConfigurationResult.clsExportConfigurationResult import ExportConfigurationResult
from ExportConfigurationListResult.clsExportConfigurationListResult import ExportConfigurationListResult
from NotificationsListResult.clsNotificationsListResult import NotificationsListResult
from NotificationOverviewResult.clsNotificationOverviewResult import NotificationOverviewResult
from NotificationDetailsResult.clsNotificationDetailsResult import NotificationDetailsResult
from NotificationIdList.clsNotificationIdList import NotificationIdList
from NotificationDefinition.clsNotificationDefinition import NotificationDefinition
from NotificationContent.clsNotificationContent import NotificationContent
from NotificationSendSucceededResult.clsNotificationSendSucceededResult import NotificationSendSucceededResult
from NotificationTarget.clsNotificationTarget import NotificationTarget
from NotificationTargetUserIds.clsNotificationTargetUserIds import NotificationTargetUserIds
from NotificationTargetAccountIds.clsNotificationTargetAccountIds import NotificationTargetAccountIds
from NotificationTargetAudiences.clsNotificationTargetAudiences import NotificationTargetAudiences
from NotificationTargetDevices.clsNotificationTargetDevices import NotificationTargetDevices
from NotificationConfig.clsNotificationConfig import NotificationConfig
from NotificationConfigApple.clsNotificationConfigApple import NotificationConfigApple
from NotificationConfigAppleToken.clsNotificationConfigAppleToken import NotificationConfigAppleToken
from NotificationConfigGoogle.clsNotificationConfigGoogle import NotificationConfigGoogle
from NotificationConfigWindows.clsNotificationConfigWindows import NotificationConfigWindows
from NotificationConfigResult.clsNotificationConfigResult import NotificationConfigResult
from NotificationConfigAppleResult.clsNotificationConfigAppleResult import NotificationConfigAppleResult
from NotificationConfigAppleTokenResult.clsNotificationConfigAppleTokenResult import NotificationConfigAppleTokenResult
from NotificationConfigGoogleResult.clsNotificationConfigGoogleResult import NotificationConfigGoogleResult
from NotificationConfigWindowsResult.clsNotificationConfigWindowsResult import NotificationConfigWindowsResult
from AppleNotificationEndpointType.clsAppleNotificationEndpointType import AppleNotificationEndpointType
from NotificationPlatformType.clsNotificationPlatformType import NotificationPlatformType
from NotificationFailureOutcomeCount.clsNotificationFailureOutcomeCount import NotificationFailureOutcomeCount
from ExportConfig.clsExportConfig import ExportConfig
from ExportStartedResult.clsExportStartedResult import ExportStartedResult
from ExportStatusResult.clsExportStatusResult import ExportStatusResult
from AppId.clsAppId import AppId
from DeviceConfiguration.clsDeviceConfiguration import DeviceConfiguration
from DeviceSetConfiguration.clsDeviceSetConfiguration import DeviceSetConfiguration
from DeviceModel.clsDeviceModel import DeviceModel
from DeviceSetModel.clsDeviceSetModel import DeviceSetModel
from DeviceScreenSize.clsDeviceScreenSize import DeviceScreenSize
from DeviceResolution.clsDeviceResolution import DeviceResolution
from DeviceDimensions.clsDeviceDimensions import DeviceDimensions
from DeviceCpu.clsDeviceCpu import DeviceCpu
from DeviceMemory.clsDeviceMemory import DeviceMemory
from DeviceFrame.clsDeviceFrame import DeviceFrame
from DeviceFrameDefinition.clsDeviceFrameDefinition import DeviceFrameDefinition
from TestRun.clsTestRun import TestRun
from TestRunStatistics.clsTestRunStatistics import TestRunStatistics
from TestSeries.clsTestSeries import TestSeries
from TestSeriesName.clsTestSeriesName import TestSeriesName
from TestRunSummary.clsTestRunSummary import TestRunSummary
from DeviceList.clsDeviceList import DeviceList
from DeviceSelection.clsDeviceSelection import DeviceSelection
from DeviceSetUpdate.clsDeviceSetUpdate import DeviceSetUpdate
from DeviceSet.clsDeviceSet import DeviceSet
from DeviceSetOwner.clsDeviceSetOwner import DeviceSetOwner
from Subscription.clsSubscription import Subscription
from Tier.clsTier import Tier
from TestReport.clsTestReport import TestReport
from StepReport.clsStepReport import StepReport
from TestCloudErrorDetails.clsTestCloudErrorDetails import TestCloudErrorDetails
from TestCloudFileHashDeprecated.clsTestCloudFileHashDeprecated import TestCloudFileHashDeprecated
from TestCloudFileHash.clsTestCloudFileHash import TestCloudFileHash
from TestCloudFileHashResponse.clsTestCloudFileHashResponse import TestCloudFileHashResponse
from TestCloudHashUploadStatus.clsTestCloudHashUploadStatus import TestCloudHashUploadStatus
from TestCloudStartTestRunOptions.clsTestCloudStartTestRunOptions import TestCloudStartTestRunOptions
from TestCloudStartTestRunResult.clsTestCloudStartTestRunResult import TestCloudStartTestRunResult
from TestRunState.clsTestRunState import TestRunState
from PerformanceReport.clsPerformanceReport import PerformanceReport
from SubmitDsrOperationRequest.clsSubmitDsrOperationRequest import SubmitDsrOperationRequest
from SubmitDsrOperationResponse.clsSubmitDsrOperationResponse import SubmitDsrOperationResponse
from CreateGdprTestData.clsCreateGdprTestData import CreateGdprTestData
from TestGDPRUser.clsTestGDPRUser import TestGDPRUser
from TestGDPRAccount.clsTestGDPRAccount import TestGDPRAccount
from TestGDPRFeatureFlag.clsTestGDPRFeatureFlag import TestGDPRFeatureFlag
from TestGDPRResourceList.clsTestGDPRResourceList import TestGDPRResourceList
from TestGDPRHashFile.clsTestGDPRHashFile import TestGDPRHashFile
from TestGDPRTestRun.clsTestGDPRTestRun import TestGDPRTestRun
from TestGDPRFileSetFile.clsTestGDPRFileSetFile import TestGDPRFileSetFile
from TestGDPRPipelineTest.clsTestGDPRPipelineTest import TestGDPRPipelineTest
from Deployment.clsDeployment import Deployment
from DeploymentInternal.clsDeploymentInternal import DeploymentInternal
from DeploymentModification.clsDeploymentModification import DeploymentModification
from CodePushReleaseLabel.clsCodePushReleaseLabel import CodePushReleaseLabel
from BlobInfo.clsBlobInfo import BlobInfo
from PackageHashToBlobInfoMap.clsPackageHashToBlobInfoMap import PackageHashToBlobInfoMap
from CodePushReleaseInfo.clsCodePushReleaseInfo import CodePushReleaseInfo
from CodePushRelease.clsCodePushRelease import CodePushRelease
from CodePushReleaseModification.clsCodePushReleaseModification import CodePushReleaseModification
from CodePushReleasePromote.clsCodePushReleasePromote import CodePushReleasePromote
from CodePushReleaseMetric.clsCodePushReleaseMetric import CodePushReleaseMetric
from CodePushStatusMetricMetadata.clsCodePushStatusMetricMetadata import CodePushStatusMetricMetadata
from UpdateCheckResponse.clsUpdateCheckResponse import UpdateCheckResponse
from AcquisitionStatusSuccessResponse.clsAcquisitionStatusSuccessResponse import AcquisitionStatusSuccessResponse
from GDPRPurgeVerifyRequest.clsGDPRPurgeVerifyRequest import GDPRPurgeVerifyRequest
from GDPRPurgeVerifyResponse.clsGDPRPurgeVerifyResponse import GDPRPurgeVerifyResponse
from AlertOperationResult.clsAlertOperationResult import AlertOperationResult
from AlertWebhook.clsAlertWebhook import AlertWebhook
from AlertingEventTypes.clsAlertingEventTypes import AlertingEventTypes
from AlertWebhookListResult.clsAlertWebhookListResult import AlertWebhookListResult
from AlertWebhookPingResult.clsAlertWebhookPingResult import AlertWebhookPingResult
from AlertEmailSettings.clsAlertEmailSettings import AlertEmailSettings
from AlertUserEmailSettingsResult.clsAlertUserEmailSettingsResult import AlertUserEmailSettingsResult
from AlertUserAppEmailSettingsResult.clsAlertUserAppEmailSettingsResult import AlertUserAppEmailSettingsResult
from AlertingBugtrackerSettings.clsAlertingBugtrackerSettings import AlertingBugtrackerSettings
from AlertingVstsBugtrackerSettings.clsAlertingVstsBugtrackerSettings import AlertingVstsBugtrackerSettings
from AlertingGithubBugtrackerSettings.clsAlertingGithubBugtrackerSettings import AlertingGithubBugtrackerSettings
from AlertingJiraBugtrackerSettings.clsAlertingJiraBugtrackerSettings import AlertingJiraBugtrackerSettings
from AlertingBugtracker.clsAlertingBugtracker import AlertingBugtracker
from BugTrackerTokenId.clsBugTrackerTokenId import BugTrackerTokenId
from AlertBugTrackerReposResult.clsAlertBugTrackerReposResult import AlertBugTrackerReposResult
from AlertBugTrackerRepo.clsAlertBugTrackerRepo import AlertBugTrackerRepo
from AlertBugTrackerRepoOwner.clsAlertBugTrackerRepoOwner import AlertBugTrackerRepoOwner
from AlertCrashGroupStateChange.clsAlertCrashGroupStateChange import AlertCrashGroupStateChange
from AlertingAccessTokenResponse.clsAlertingAccessTokenResponse import AlertingAccessTokenResponse
from EventSetting.clsEventSetting import EventSetting
from AlertingEvent.clsAlertingEvent import AlertingEvent
from NewCrashGroupAlertingEvent.clsNewCrashGroupAlertingEvent import NewCrashGroupAlertingEvent
from NewAppReleaseAlertingEvent.clsNewAppReleaseAlertingEvent import NewAppReleaseAlertingEvent
from BugTrackerIssuesResult.clsBugTrackerIssuesResult import BugTrackerIssuesResult
from BugTrackerIssueResult.clsBugTrackerIssueResult import BugTrackerIssueResult
from BugTrackerStateResult.clsBugTrackerStateResult import BugTrackerStateResult
from EventResponseResult.clsEventResponseResult import EventResponseResult
from AlertingError.clsAlertingError import AlertingError
from AggregatedBillingInformation.clsAggregatedBillingInformation import AggregatedBillingInformation
from AttributesValues.clsAttributesValues import AttributesValues
from BillingError.clsBillingError import BillingError
from BillingInformationPlans.clsBillingInformationPlans import BillingInformationPlans
from BillingInformationSearchResults.clsBillingInformationSearchResults import BillingInformationSearchResults
from BillingPeriod.clsBillingPeriod import BillingPeriod
from BillingPlan.clsBillingPlan import BillingPlan
from BillingPlansChangeTypeResponse.clsBillingPlansChangeTypeResponse import BillingPlansChangeTypeResponse
from BillingPlanSelection.clsBillingPlanSelection import BillingPlanSelection
from BillingPlansSelection.clsBillingPlansSelection import BillingPlansSelection
from BillingResourceUsage.clsBillingResourceUsage import BillingResourceUsage
from GdprVerificationResult.clsGdprVerificationResult import GdprVerificationResult
from GitHubAccount.clsGitHubAccount import GitHubAccount
from GitHubMarketplacePlan.clsGitHubMarketplacePlan import GitHubMarketplacePlan
from GitHubMarketplacePurchase.clsGitHubMarketplacePurchase import GitHubMarketplacePurchase
from MetricsValues.clsMetricsValues import MetricsValues
from MetricsValuesByApp.clsMetricsValuesByApp import MetricsValuesByApp
from ServiceBillingPlans.clsServiceBillingPlans import ServiceBillingPlans
from ServiceResourceUsage.clsServiceResourceUsage import ServiceResourceUsage
from UsagePeriod.clsUsagePeriod import UsagePeriod
from UsageRecordStatus.clsUsageRecordStatus import UsageRecordStatus
from VersionedBillingPlan.clsVersionedBillingPlan import VersionedBillingPlan
from MessageEnvelope.clsMessageEnvelope import MessageEnvelope
from DataSubjectRightEmailRequest.clsDataSubjectRightEmailRequest import DataSubjectRightEmailRequest
from DataSubjectRightResponse.clsDataSubjectRightResponse import DataSubjectRightResponse
from DataSubjectRightStatusResponse.clsDataSubjectRightStatusResponse import DataSubjectRightStatusResponse
from ClientIdResponse.clsClientIdResponse import ClientIdResponse
from InnerError.clsInnerError import InnerError
from AuthTenantsResponse.clsAuthTenantsResponse import AuthTenantsResponse
from AuthTenant.clsAuthTenant import AuthTenant
from ApplicationsResponse.clsApplicationsResponse import ApplicationsResponse
from ApplicationResponse.clsApplicationResponse import ApplicationResponse
from ScopesResponse.clsScopesResponse import ScopesResponse
from ScopeResponse.clsScopeResponse import ScopeResponse
from AuthApplicationResponse.clsAuthApplicationResponse import AuthApplicationResponse
from AuthApplicationPatchRequest.clsAuthApplicationPatchRequest import AuthApplicationPatchRequest
from ExistingAuthApplicationPostRequest.clsExistingAuthApplicationPostRequest import ExistingAuthApplicationPostRequest
from TrustFrameworkPoliciesResponse.clsTrustFrameworkPoliciesResponse import TrustFrameworkPoliciesResponse
from TrustFrameworkPolicyResponse.clsTrustFrameworkPolicyResponse import TrustFrameworkPolicyResponse
from OverviewResponse.clsOverviewResponse import OverviewResponse
from EstimatedPricingResponse.clsEstimatedPricingResponse import EstimatedPricingResponse
from DataInstancesResponse.clsDataInstancesResponse import DataInstancesResponse
from DataInstance.clsDataInstance import DataInstance
from InstanceDatabasesResponse.clsInstanceDatabasesResponse import InstanceDatabasesResponse
from InstanceDatabase.clsInstanceDatabase import InstanceDatabase
from DatabaseCollectionsResponse.clsDatabaseCollectionsResponse import DatabaseCollectionsResponse
from DatabaseCollection.clsDatabaseCollection import DatabaseCollection
from UsersResponse.clsUsersResponse import UsersResponse
from UserResponse.clsUserResponse import UserResponse
from DataProvisioningParameters.clsDataProvisioningParameters import DataProvisioningParameters
from ProvisionStatusResponse.clsProvisionStatusResponse import ProvisionStatusResponse
