# coding: utf-8

"""
    App Center Client

    Microsoft Visual Studio App Center API  # noqa: E501

    OpenAPI spec version: preview
    Contact: benedetto.abbenanti@gmail.com
    Project Repository: https://github.com/b3nab/appcenter-sdks
"""

import pprint
import re  # noqa: F401

import six


class v2MissingSymbolCrashGroupsResponse(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    allowed enum values
    """
    active = "active"
    pending = "pending"
    closed = "closed"
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'total_crash_count': 'integer',
        'groups': 'array'
    }

    attribute_map = {
        'total_crash_count': 'total_crash_count',
        'groups': 'groups'
    }

    def __init__(self, total_crash_count=None, groups=None):  # noqa: E501
        """v2MissingSymbolCrashGroupsResponse - a model defined in Swagger"""  # noqa: E501
        self._total_crash_count = None
        self._groups = None
        self.discriminator = None
        self.total_crash_count = total_crash_count
        self.groups = groups

    @property
    def total_crash_count(self):
        """Gets the total_crash_count of this v2MissingSymbolCrashGroupsResponse.  # noqa: E501

        total number of cashes for all the groups  # noqa: E501

        :return: The total_crash_count of this v2MissingSymbolCrashGroupsResponse.  # noqa: E501
        :rtype: integer
        """
        return self._total_crash_count

    @total_crash_count.setter
    def total_crash_count(self, total_crash_count):
        """Sets the total_crash_count of this v2MissingSymbolCrashGroupsResponse.

        total number of cashes for all the groups  # noqa: E501

        :param total_crash_count: The total_crash_count of this v2MissingSymbolCrashGroupsResponse.  # noqa: E501
        :type: integer
        """
        if total_crash_count is None:
            raise ValueError("Invalid value for `total_crash_count`, must not be `None`")  # noqa: E501

        self._total_crash_count = total_crash_count

    @property
    def groups(self):
        """Gets the groups of this v2MissingSymbolCrashGroupsResponse.  # noqa: E501

        A list of crash groups formed by missing symbols combination  # noqa: E501

        :return: The groups of this v2MissingSymbolCrashGroupsResponse.  # noqa: E501
        :rtype: array
        """
        return self._groups

    @groups.setter
    def groups(self, groups):
        """Sets the groups of this v2MissingSymbolCrashGroupsResponse.

        A list of crash groups formed by missing symbols combination  # noqa: E501

        :param groups: The groups of this v2MissingSymbolCrashGroupsResponse.  # noqa: E501
        :type: array
        """
        if groups is None:
            raise ValueError("Invalid value for `groups`, must not be `None`")  # noqa: E501

        self._groups = groups

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, v2MissingSymbolCrashGroupsResponse):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
